#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define int long long
#define pb push_back
#define all(x) x.begin(), x.end()

const int maxn = 1000 + 5;
const int mod = 1e9 + 7;

int n;
int a[maxn][maxn];
int col[maxn], row[maxn];

bool check(int p1, int r1, int p2, int r2) {
    int temp = a[p1][r1];
    a[p1][r1] = a[p2][r2];
    a[p2][r2] = temp;
    set<int> sums;
    for (int i = 1; i <= n; i++) {
        int sum = 0;
        for (int j = 1; j <= n; j++) {
            sum += a[i][j];
        }
        sums.insert(sum);
    }
    int kek[n + 2];
    for (int i = 1; i <= n; i++) {
        kek[i] = 0;
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            kek[j] += a[i][j];
        }
    }
    for (int i = 1; i <= n; i++) {
        sums.insert(kek[i]);
    }
    temp = a[p1][r1];
    a[p1][r1] = a[p2][r2];
    a[p2][r2] = temp;
    if (sums.size() == 1) {
        return 1;
    }
    return 0;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            cin >> a[i][j];
            col[i] += a[i][j];
            row[j] += a[i][j];
        }
    }
    int ok = 0;
    int pos1 = -1, pos2 = -1;
    int sum = n * n * (n * n + 1) / 2;
    sum /= n;
    for (int i = 1; i <= n; i++){
        if (col[i] != sum){
            ok++;
            if (pos1 == -1) pos1 = i;
            else pos2 = i;
        }
    }
    if (!ok){
        pos1 = -1, pos2 = -1;
        for (int j = 1; j <= n; j++){
            if (row[j] != sum){
                if (pos1 == -1) pos1 = j;
                else pos2 = j;
            }
        }
        int more = row[pos1] - sum;
        for (int i = 1; i <= n; i++){
            for (int k = 1; k <= n; k++){
                if (a[i][pos1] - more == a[k][pos2]){
                    if (check(i, pos1, k, pos2)) {
                        cout << i << ' ' << pos1 << '\n' << k << ' ' << pos2 << '\n';
                        return 0;
                    }
                }
            }
        }
    }
    else{
        int more = col[pos1] - sum;
        for (int j = 1; j <= n; j++){
            for (int k = 1; k <= n; k++){
                if (a[pos1][j] - more == a[pos2][k]){
                    if (check(pos1, j, pos2, k)){
                        cout << pos1 << ' ' << j << '\n' << pos2 << ' ' << k << '\n';
                        return 0;
                    }
                }
            }
        }
    }
}
/*
6
1 2 3 4 5 6
2 3 4 5 6 1
3 4 2 6 1 2
4 5 6 1 2 3
5 6 1 2 3 4
6 1 5 3 4 6

 * */