#include <bits/stdc++.h>
#define pb push_back

using namespace std;
#define int long long

const int N=1e6+7;
const int M=1e9+7;

int a[1011][1011];
int n;

bool check(int x1,int y1,int x2,int y2){

    int nd=(n*n*(n*n+1))/(2*n);

    swap(a[x1][y1],a[x2][y2]);

    for(int i=1;i<=n;i++) {
        int sum = 0;
        for (int j = 1; j <= n; j++) {
            sum += a[i][j];
        }
        if (sum != nd) {
            swap(a[x1][y1],a[x2][y2]);
            return false;
        }
    }

    for(int j=1;j<=n;j++) {
        int sum = 0;
        for (int i = 1; i <= n; i++) {
            sum += a[i][j];
        }
        if (sum != nd) {
            swap(a[x1][y1],a[x2][y2]);
            return false;
        }
    }

    swap(a[x1][y1],a[x2][y2]);
    return true;
}

void solve() {

    vector<int>vi,vj;

    cin >> n;

    int nd=(n*n*(n*n+1))/(2*n);

    for(int i=1;i<=n;i++) {
        int sum = 0;
        for (int j = 1; j <= n; j++) {
            cin >> a[i][j];
            sum += a[i][j];
        }
        if (sum != nd) {
            vj.pb(i);
        }
    }

    for(int j=1;j<=n;j++) {
        int sum = 0;
        for (int i = 1; i <= n; i++) {
            sum += a[i][j];
        }
        if (sum != nd) {
            vi.pb(j);
        }
    }

    vector<pair<int,int>>v;

    for(auto to:vi){
        for(auto t:vj){
            v.pb({to,t});
        }
    }

    for(int i=0;i<v.size();i++){
        for(int j=i+1;j<v.size();j++){
            if(check(v[i].first,v[i].second,v[j].first,v[j].second)){
                cout<<v[i].first<<" "<<v[i].second<<endl<<v[j].first<<" "<<v[j].second;
                return;
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);
    solve();
    return 0;
}

