#include <iostream>
using namespace std;
typedef long long int lli;

const lli MAX_SIZE = (lli)5e3 + 5LL,
          MOD = (lli)1e9 + 7LL;

lli N,
    fact[MAX_SIZE],
    ans;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    fact[0] = 1LL;
    for (lli i = 1LL; i < MAX_SIZE; ++i)
        fact[i] = (fact[i - 1] * i) % MOD;

    cin >> N;

    ans = 1LL;
    for (int i = 1; i < (int)N; ++i)
        ans = (ans * fact[i]) % MOD;

    cout << ans << '\n';
    return 0;
}
