#include<bits/stdc++.h>

using namespace std;
using ll = long long;

const int N = 1e3 + 10;

int n;
ll a[N][N];
ll sum = 0;
bool check() {
    for(int i = 0; i < n; i++) {
        ll val = 0;
        for(int j = 0; j < n; j++) {
            val += a[i][j];
        }
        if(val != sum) return false;
    }
    for(int i = 0; i < n; i++) {
        ll val = 0;
        for(int j = 0; j < n; j++) {
            val += a[j][i];
        }
        if(val != sum) return false;
    }
    return true;

}
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cin >> n;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < n; j++) {
            cin >> a[i][j];
            sum += a[i][j];
        }
    }
    /*
    9 4 2
    3 5 7
    8 1 6
    */
    sum /= n;
//    cout << sum << '\n';
    vector<int> cols, rows;
    for(int i = 0; i < n; i++) {
        ll cur = 0;
        for(int j = 0; j < n; j++)
            cur += a[i][j];
        if(cur != sum)
            rows.push_back(i);
//        cout << cur << ' ';
    }
//    cout << '\n';
    for(int j = 0; j < n; j++) {
        ll cur = 0;
        for(int i = 0; i < n; i++) {
            cur += a[i][j];
        }
        if(cur != sum)
            cols.push_back(j);
//        cout << cur << ' ';
    }
//    cout << '\n';
//    for(int x : cols)
//        cout << x << ' ';
//    cout << '\n';
//    for(int x : rows)
//        cout << x << ' ';
//    cout << '\n';
//    return 0;
    if(!rows.empty() && !cols.empty()) {
        swap(a[rows[0]][cols[0]],
             a[rows[1]][cols[1]]);
        if(check()) {
            cout << rows[0]+1 << ' ' << cols[0]+1 << '\n';
            cout << rows[1]+1 << ' ' << cols[1]+1 << '\n';
            return 0;
        }
        swap(a[rows[0]][cols[0]],
             a[rows[1]][cols[1]]);
        swap(a[rows[0]][cols[1]],
             a[rows[1]][cols[0]]);
        if(check()) {
            cout << rows[0]+1 << ' ' << cols[1]+1 << '\n';
            cout << rows[1]+1 << ' ' << cols[0]+1 << '\n';
            return 0;
        }
    }
    if(rows.empty()) {
        int x = cols[0], y = cols[1];
//        cout << x << ' ' << y << '\n';
//        exit(0);
        ll s0 = 0, s1 = 0;
        for(int i = 0; i < n; i++) {
            s0 += a[i][x];
            s1 += a[i][y];
        }
        for(int i = 0; i < n; i++) {
            if(s0 - a[i][x] + a[i][y] == sum) {
                cout << i + 1 << ' ' << x + 1 << '\n';
                cout << i + 1 << ' ' << y + 1 << '\n';
                return 0;
            }
        }
        return 0;
    }

    int x = rows[0], y = rows[1];
//    cout << x << ' ' << y << '\n';
    ll s0 = 0, s1 = 0;
    for(int i = 0; i < n; i++) {
        s0 += a[x][i];
        s1 += a[y][i];
    }
    for(int i = 0; i < n; i++) {
        if(s0 - a[x][i] + a[y][i] == sum) {
            cout << x + 1 << ' ' << i + 1 << '\n';
            cout << y + 1 << ' ' << i + 1 << '\n';
            return 0;
        }
    }
}




