#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;

const int maxn = 1e3 + 1;
int n;
int a[maxn][maxn];
ll col[maxn], row[maxn];

bool isgood(int i1, int j1, int k1, int t1) {
    swap(a[i1][j1], a[k1][t1]);
    bool fl = 0;
    set<int> col1, row1;
    fill(row, row + n, 0);
    fill(col, col + n, 0);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            row[i] += a[i][j];
            col[j] += a[i][j];
        }
    }
    for (int i = 0; i < n; i++) {
        col1.insert(col[i]);
        row1.insert(row[i]);
    }
    swap(a[i1][j1], a[k1][t1]);
    return (col1.size() == 1 && row1.size() == 1);
}

void solve1() {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            for (int k = 0; k < n; k++) {
                for (int t = 0; t < n; t++) {
                    if (isgood(i, j, k, t)) {
                        cout << i + 1 << ' ' << j + 1 << ' ' << '\n' << k + 1 << ' ' << t + 1 << '\n';
                        exit(0);
                    }
                }
            }
        }
    }
}

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            row[i] += a[i][j];
            col[j] += a[i][j];
        }
    }
    vector<int> badcols, badrows;
    map<ll, int> col1, row1;
    for (int i = 0; i < n; i++) {
        col1[col[i]]++;
        row1[row[i]]++;
    }
    for (int i = 0; i < n; i++) {
        if (col1[col[i]] < 3) {
            badcols.push_back(i);
        }
        if (row1[row[i]] < 3) {
            badrows.push_back(i);
        }
    }
    for (auto i : badcols) {
        for (auto j : badrows) {
            for (auto k : badcols) {
                for (auto t : badrows) {
                    if (isgood(i, j, k, t)) {
                        cout << i + 1 << ' ' << j + 1 << ' ' << k + 1 << ' ' << t + 1 << '\n';
                        exit(0);
                    }
                }
            }
        }
    }
}

int main() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
        }
    }
    if (n < 5) {
        solve1();
        exit(0);
    }
    solve();
}
