#include <iostream>
#include <algorithm>
#include <numeric>
#include <math.h>
#include <cmath>
#include <string>
#include <map>
#include <vector>
#define int long long
using namespace std;
const long long mod = 1e18;
vector<vector<int>> sq;
vector<int> sumsi;
vector<int> sumsj;
int n;

bool stupidcheck() {
	vector<int> sumsit(n);
	vector<int> sumsjt(n);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			sumsit[i] += sq[i][j];
			sumsjt[j] += sq[i][j];
		}
	}
	int mn = sumsit[0];
	for (auto t : sumsit)
		if (t != mn)
			return false;
	for (auto t : sumsjt)
		if (t != mn)
			return false;
	return true;
}

void giveanswer(int a, int b, int c, int d) {
	a++;
	b++;
	c++;
	d++;
	cout << a << ' ' << b << '\n' << c << ' ' << d << '\n';
	exit(0);
}

void bf() {
	for(int x1 = 0; x1 < n; x1++)
		for (int y1 = 0; y1 < n; y1++)
			for (int x2 = 0; x2 < n; x2++)
				for (int y2 = 0; y2 < n; y2++) {
					swap(sq[x1][y1], sq[x2][y2]);
					bool sc = stupidcheck();
					if (sc)
						giveanswer(x1, y1, x2, y2);
					swap(sq[x1][y1], sq[x2][y2]);
				}
	exit(1);
}

int magicnumber() {
	map<int, int> mn;
	for (auto t : sumsi)
		mn[t]++;
	for (auto t : sumsj)
		mn[t]++;
	pair<int, int> mxn = { -1, -1 };
	for (auto [num, qtt] : mn)
		if (qtt > mxn.second)
			mxn = { num, qtt };
	return mxn.first;
}

signed main()
{
	cin >> n;
	sq.assign(n, vector<int>(n));
	sumsi.assign(n, 0);
	sumsj.assign(n, 0);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			cin >> sq[i][j];
			sumsi[i] += sq[i][j];
			sumsj[j] += sq[i][j];
		}
	}
	if (n < 7) {
		bf();
		exit(1);
	}
	int magic = magicnumber();
	vector<int> deviai;
	vector<int> deviaj;
	for (int i = 0; i < n; i++) {
		if (sumsi[i] != magic)
			deviai.push_back(i);
		if (sumsj[i] != magic)
			deviaj.push_back(i);
	}
	if (deviai.size() == 2 && deviaj.size() == 2) {
		swap(sq[deviai[0]][deviaj[0]], sq[deviai[1]][deviaj[1]]);
		if (stupidcheck())
			giveanswer(deviai[0], deviaj[0], deviai[1], deviaj[1]);
		swap(sq[deviai[0]][deviaj[0]], sq[deviai[1]][deviaj[1]]);

		swap(sq[deviai[0]][deviaj[1]], sq[deviai[1]][deviaj[0]]);
		if (stupidcheck())
			giveanswer(deviai[0], deviaj[1], deviai[1], deviaj[0]);
		swap(sq[deviai[0]][deviaj[1]], sq[deviai[1]][deviaj[0]]);
		exit(1);
	}
	else if (deviai.size() == 2 && deviaj.size() == 0) {
		for (int j = 0; j < n; j++) {
			int el1 = sq[deviai[0]][j];
			int el2 = sq[deviai[1]][j];
			if (sumsi[deviai[0]] - el1 + el2 == sumsi[deviai[1]] + el1 - el2)
				giveanswer(deviai[0], j, deviai[1], j);
		}
		exit(1);
	}
	else if (deviai.size() == 0 && deviaj.size() == 2) {
		for (int i = 0; i < n; i++) {
			int el1 = sq[i][deviaj[0]];
			int el2 = sq[i][deviaj[1]];
			if (sumsj[deviaj[0]] -el1 + el2 == sumsj[deviaj[1]] + el1 - el2)
				giveanswer(i, deviaj[0], i, deviaj[1]);
		}
		exit(1);
	}
	//while (true) n = n;//exit(1);
}