#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

using pii = pair<int, int>;
using ll = long long;
using ld = long double;

inline void solve() {
     string s;
     cin >> s;
     int n;
     cin >> n;
     map<char, pii> m;
     for (int i = 0; i < n; ++i) {
          char c;
          int x;
          cin >> c >> x;
          m[c]  = {x, 0};
     }
     ll cnt = 0;
     for (char c : s) {
          if(m.find(c) != m.end()) {
               if(m[c].second % m[c].first == 0) {
                    cnt += 2;
                    m[c].second += 2;
               } else {
                    cnt++;
                    m[c].second++;
               }
          }
          else {
               cnt++;
          }
     }
     cout << cnt;

}

int32_t main() {
     ios_base::sync_with_stdio(false);
     cin.tie(nullptr);

     int t = 1;
     //cin >> t;

     while (t--) {
          solve();
     }

     return 0;
}
