#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

using pii = pair<int, int>;
using ll = long long;
using ld = long double;

constexpr int mod = 1e9 + 7;

inline void solve2() {
     int x, y, z;
     cin >> x >> y >> z;

     int a, b, c;
     cin >> a >> b >> c;

     vector<int> dp;
}

inline void solve() {
     int n;
     cin >> n;
     vector<ll> dp(n);
     dp[0] = 1;
     if (n > 1)
          dp[1] = 1;
     for (int i = 2; i < n; ++i) {
          dp[i] = (i * ((i - 1) / 2 + 1) * dp[i-1]) % mod;
     }
     cout << dp.back();
}

int main() {
     ios_base::sync_with_stdio(false);
     cin.tie(nullptr);

     int t = 1;
     //cin >> t;

     while (t--) {
          solve();
     }

     return 0;
}
