﻿#include <vector>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <map>
#include <iostream>
#include <string>
#include <iomanip>
#include <cmath>
#define int long long
using ll = long long;
using namespace std;
const int mod = 1e9 + 7;
const int INF = 1e9 + 7;
#define get_time (double)clock() / (double)(CLOCKS_PER_SEC)
#ifndef ONLINE_JUDGE
#define debug(x) cerr << (#x) << ": " << x << endl;
#else
#define debug(x)
#endif
ll max(ll a, ll b) {
    return (a > b) ? a : b;
}
ll min(ll a, ll b) {
    return (a < b) ? a : b;
}
ll bs_sqrt(ll x) {
    ll left = 0, right = 2000000123;
    while (right > left) {
        ll mid = (left + right) / 2;
        if (mid * mid > x) {
            right = mid;
            continue;
        }
        left = mid + 1;
    }
    return left - 1;
}
int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        int c = a;
        a = b % a;
        b = c;
    }
    return a + b;
}
int bin_pow(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        ll t = bin_pow(a, n / 2);
        return (t * t);
    } else {
        ll t = bin_pow(a, n - 1);
        return (t * a);
    }
}
int n, must;
vector<vector<int> > a;
void check(int p1, int p2, int p3, int p4) {
    swap(a[p1][p2], a[p3][p4]);
    for (int i = 0; i < n; i++) {
        int sum = 0;
        for (int j = 0; j < n; j++) {
            sum += a[i][j];
        }
        if (sum != must) {
            swap(a[p1][p2], a[p3][p4]);
            return;
        }
    }
    for (int i = 0; i < n; i++) {
        int sum = 0;
        for (int j = 0; j < n; j++) {
            sum += a[j][i];
        }
        if (sum != must) {
            swap(a[p1][p2], a[p3][p4]);
            return;
        }
    }
    cout << p1 + 1 << " " << p2 + 1 << " " << endl << p3 + 1 << " " << p4 + 1 << endl;
    exit(0);
}
void solve_str(int x, int y) {
    int sum_1 = 0, sum_2 = 0;
    for (int i = 0; i < n; i++) {
        sum_1 += a[x][i];
    }
    for (int i = 0; i < n; i++) {
        sum_2 += a[y][i];
    }
    for (int j = 0; j < n; j++) {
        int new_sum_1 = sum_1 - a[x][j] + a[y][j];
        int new_sum_2 = sum_2 - a[y][j] + a[x][j];
        if (new_sum_1 == new_sum_2) {
            cout << x + 1 << " " << j + 1 << " " << endl << y + 1 << " " << j + 1 << endl;
            exit(0);
        }
    }
}
void solve_stolb(int x, int y) {
    int sum_1 = 0, sum_2 = 0;
    for (int i = 0; i < n; i++) {
        sum_1 += a[i][x];
    }
    for (int i = 0; i < n; i++) {
        sum_2 += a[i][y];
    }
    for (int i = 0; i < n; i++) {
        int new_sum_1 = sum_1 - a[i][x] + a[i][y];
        int new_sum_2 = sum_2 - a[i][y] + a[i][x];
        if (new_sum_1 == new_sum_2) {
            cout << i + 1 << " " << x + 1 << " " << endl << i + 1 << " " << y + 1 << endl;
            exit(0);
        }
    }
}
void solve() {
    int sum = 0;
    cin >> n;
    a = vector<vector<int> >(n, vector<int>(n, 0));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
            sum += a[i][j];
        }
    }
    must = sum / n;
    vector<int> str, stolb;
    for (int i = 0; i < n; i++) {
        int done = 0;
        for (int j = 0; j < n; j++) {
            done += a[i][j];
        }
        if (done != must) {
            str.push_back(i);
        }
    }
    for (int j = 0; j < n; j++) {
        int done = 0;
        for (int i = 0; i < n; i++) {
            done += a[i][j];
        }
        if (done != must) {
            stolb.push_back(j);
        }
    }
    if (str.size() > 0 && stolb.size() > 0) {
        int aa = str[0], b = str[1], c = stolb[0], d = stolb[1];
        check(aa, c, b, d);
        check(aa, d, b, c);
    }
    if (str.size() == 2) {
        int x = str[0], y = str[1];
        solve_str(x, y);
    }
    if (stolb.size() == 2) {
        int x = stolb[0], y = stolb[1];
        solve_stolb(x, y);
    }
}
signed main() {
    cout << fixed << setprecision(20);
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
/*
3
4 5 2
3 9 7
8 1 6
*/