﻿#include <iomanip>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <map>
#include <iostream>
#include <string>
#include <iomanip>
#include <vector>
#include <cmath>
#define int long long
using ll = long long;
using namespace std;
const int mod = 1e9 + 7;
const int INF = 1e9 + 7;
#define get_time (double)clock() / (double)(CLOCKS_PER_SEC)
#ifndef ONLINE_JUDGE
#define debug(x) cerr << (#x) << ": " << x << endl;
#else
#define debug(x)
#endif
ll max(ll a, ll b) {
    return (a > b) ? a : b;
}
ll min(ll a, ll b) {
    return (a < b) ? a : b;
}
ll bs_sqrt(ll x) {
    ll left = 0, right = 2000000123;
    while (right > left) {
        ll mid = (left + right) / 2;
        if (mid * mid > x) {
            right = mid;
            continue;
        }
        left = mid + 1;
    }
    return left - 1;
}
int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        int c = a;
        a = b % a;
        b = c;
    }
    return a + b;
}
int bin_pow(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        ll t = bin_pow(a, n / 2);
        return (t * t) % mod;
    }
    else {
        ll t = bin_pow(a, n - 1);
        return (t * a) % mod;
    }
}
int rev(int x) {
    return bin_pow(x, mod - 2);
}
int mul(int a, int b) {
    return (a * b) % mod;
}
int make_add(int a, int b) {
    return (a + b) % mod;
}
const int MAXN = 3e5;
int fact[MAXN], r_fact[MAXN];
void comb() {
    fact[0] = 1;
    for (int i = 1; i < MAXN; i++) {
        fact[i] = mul(fact[i - 1], i);
    }
    for (int i = 0; i < MAXN; i++) {
        r_fact[i] = rev(fact[i]);
    }
}
int C(int k, int n) {
    int t = fact[n];
    t = mul(t, r_fact[n - k]);
    t = mul(t, r_fact[k]);
    return t;
}
void solve() {
    int n;
    cin >> n;
    vector<int> cnt(3);
    for (int i = 0; i < n; i++) {
        int x; cin >> x;
        cnt[x % 3]++;
    }
    if (abs(cnt[1] - cnt[2]) > 2 || (cnt[1] == cnt[2])) {
        cout << 0;
        return;
    }
    int ans = mul(fact[cnt[1]], fact[cnt[2]]);
    n = cnt[0];
    int k = cnt[2] + cnt[1];
    ans = mul(ans, C(n, n + k - 1));
    cout << ans;
}
signed main() {
    comb();
    cout << fixed << setprecision(20);
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}