#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <iomanip>
#include <cstdint>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> ii;
typedef pair<long long, long long> llll;
typedef vector<int> vi;
typedef vector<long long> vll;

const ll MOD = 1e9 + 7;

void solve() {
    int n;
    cin >> n;
    vector<vector<ll>> dp(n + 1, vector<ll>(n + 1, 0));
    for (int j = 1; j <= n; ++j) {
        dp[0][j] = 1;
        dp[1][j] = j;
    }
    for (int i = 2; i <= n; ++i) {
        if (i >= 3) {
            dp[i][1] = 0;
        } else {
            dp[i][1] = 1;
        }
        for (int j = 2; j <= n; ++j) {
            dp[i][j] = (dp[i][j - 1] + dp[i - 1][j - 1] + dp[i - 2][j - 1]) % MOD;
        }
    };
    ll ans = 1;
    for (int i = 2; i <= n; ++i) {
        ans = (ans * dp[i][i - 1]) % MOD;
    }
    cout << ans << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#endif
    int tests = 1;
    // cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
}