#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MOD = 1e9 + 7;
const int INF = 1e9;

#define int long long

int bin_pow(int a, int n) {
    int ans = 1;
    while (n > 0) {
        if (n & 1) {
            ans = ans * a % MOD;
        }
        n /= 2;
        a = a * a % MOD;
    }
    return ans;
}

vector <int> fact, inv_fact;

int cnk(int n, int k) {
    return fact[n] * inv_fact[k] % MOD * inv_fact[n - k] % MOD;
}

void solveH() {
    const int MAX = 1e5 + 50;
    fact.resize(MAX);
    inv_fact.resize(MAX);
    fact[0] = 1;
    for (int i = 1; i < MAX; i++) {
        fact[i] = fact[i - 1] * i % MOD;
    }
    inv_fact[MAX - 1] = bin_pow(fact[MAX - 1], MOD - 2);
    for (int i = MAX - 2; i >= 0; i--) {
        inv_fact[i] = inv_fact[i + 1] * (i + 1) % MOD;
    }

    int n;
    cin >> n;

    int ans = 0;
    for (int mex = 1; mex <= 1e9; mex++) {
        int s = 0;
        for (int i = 1; i < mex; i++) {
            s += i;
        }
        if (s > n) break;

        if (s == n) {
            ans += mex;
            ans %= MOD;
            break;
        }

        vector <vector <int>> dp(n, vector <int> (n - s + 1, 0));
        dp[0][0] = 1;
        for (int i = 1; i < n; i++) {
            int x = (i >= mex ? i + 1 : i);
            for (int j = 0; j <= n - s; j++) {
                dp[i][j] = dp[i - 1][j];
                if (j >= x) {
                    dp[i][j] += dp[i][j - x];
                    dp[i][j] %= MOD;
                }
            }
        }
        ans += mex * dp[n - 1][n - s] % MOD;
        ans %= MOD;
    }

    cout << ans << "\n";
}

vector <int> ans;
vector <vector <int>> gr;
vector <int> lvl;
vector <int> h;
vector <int> clst;

struct Node {
    int l, r, mx;
};

Node t[1000000];
int tSz = 0;


void dfs(int v) {
    if (gr[v].size() == 0) {
        clst[v] = h[v];
        lvl[h[v]] = 1;
    }

    for (int& u : gr[v]) {
        h[u] = h[v] + 1;
        dfs(u);
        clst[v] = min(clst[u], clst[v]);
    }

    ans[v] = lvl[clst[v]] + 1;
    lvl[h[v]] = max(lvl[h[v]], ans[v]);
}

void solveB() {
    int n;
    cin >> n;

    ans.resize(n);
    gr.resize(n);
    lvl.assign(n, 0);
    h.resize(n);
    clst.assign(n, INF);

    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;

        gr[p].push_back(i);
    }

    h[0] = 0;
    dfs(0);

    cout << ans[0] << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;

    while (t--) {
        solveH();
    }
}
