#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define first fi
#define second se
#define push_back pb

const ll MOD = 1'000'000'000 + 7;
const ll INF = 1e9;

ll bin_pow(ll n, ll k)
{
    if (k == 1) return n;
    if (k == 0) return 1;

    if (k % 2 == 0) {
        ll ans = bin_pow(n, k / 2);
        return ans * ans % MOD;
    } else {
        return n * bin_pow(n, k - 1) % MOD;
    }
}

void solve()
{
    ll n;
    cin >> n;
    vector <vector <int>> vec(n, vector <int> (n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> vec[i][j];
        }
    }
    vector <int> sm1(n);
    vector <int> sm2(n);
    int mx1 = 0;
    int pos1 = 0;
    int mn1 = INF;
    int pos2 = 0;
    int mx2 = 0;
    int pos3 = 0;
    int mn2 = INF;
    int pos4 = 0;
    for (int i = 0; i < n; i++) {
        int cnt = 0;
        for (int j = 0; j < n; j++) {
            cnt += vec[i][j];
        }
        sm1[i] = cnt;
        if (mx1 < sm1[i]) {
            mx1 = sm1[i];
            pos1 = i;
        }

        if (mn1 > sm1[i]) {
            mn1 = sm1[i];
            pos2 = i;
        }
    }
    for (int i = 0; i < n; i++) {
        int cnt = 0;
        for (int j = 0; j < n; j++) {
            cnt += vec[j][i];
        }
        sm2[i] = cnt;
        if (mx2 < sm2[i]) {
            mx2 = sm2[i];
            pos3 = i;
        }

        if (mn2 > sm2[i]) {
            mn2 = sm2[i];
            pos4 = i;
        }
    }
    cout << pos1 + 1 << ' ' << pos3 + 1 << endl << pos2 + 1 << ' ' << pos4 + 1 << endl;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}
