#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

vector<ll> l(1000, 0), s(1000, 0);
map<ll, int> dd, dl, ds;
vector<ll> sm;
vector<vector<int>> m;

bool chck(ll cs, vector<pair<int, int>> br) {
    for (int i = 0; i < br.size(); i++) {
        for (int j = 0; j < br.size(); j++) {
            if (i == j) continue;
            pair<int, int> a = br[i], b = br[j];

            ll nla = l[a.first] - m[a.first][a.second] + m[b.first][b.second];
            ll nsa = s[a.second] - m[a.first][a.second] + m[b.first][b.second];
            ll nlb = l[b.first] - m[b.first][b.second] + m[a.first][a.second];
            ll nsb = s[b.second] - m[b.first][b.second] + m[a.first][a.second];

            if (nla == cs && nsa == cs && nlb == cs && nsb == cs) {
                cout << a.first + 1 << " " << a.second + 1 << endl;
                cout << b.first + 1 << " " << b.second + 1;
                return true;
            }
        }
    }
    return false;
}

void solve() {
    int n; cin >> n;
    for (int i = 0; i < n; i++) {
        vector<int> nm(n);
        for (int j = 0; j < n; j++) {
            int tt;
            cin >> tt;
            nm[j] = tt;
            l[i] += tt;
            s[j] += tt;
        }
        m.push_back(nm);
    }

    for (int i = 0; i < n; i++) {
        ds[s[i]]++; dl[l[i]]++; dd[s[i]]++; dd[l[i]]++;
        sm.push_back(l[i]);
        sm.push_back(s[i]);
    }

    sort(sm.begin(), sm.end());
    ll prev = sm[0];
    for (int i = 0; i < sm.size(); i++){
        vector<pair<int, int>> pp;
        vector<int> bl, bs;
        for (int j = 0; j < n; j++) {
            if (l[j] != sm[i])
                bl.push_back(j);
            if (s[j] != sm[i])
                bs.push_back(j);
        }
        for (int x : bl) {
            for (int y : bs) {
                pp.push_back({x, y});
                if (x != y) pp.push_back({y, x});
            }
        }

        bool ret = chck(sm[i], pp);
        if (ret) return;
    }
}

int main() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    int t = 1;

    while (t--) {
        solve();
    }

    return 0;
}
