#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define rs resize
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define int long long

typedef pair<int, int> pii;

template<typename T>
istream &operator >>(istream &in, vector<T> &arr) {
    for (auto &i : arr) in >> i;
    return in;
}
template<typename T>
ostream &operator <<(ostream &in, vector<T> &arr) {
    for (auto &i : arr) in << i << " ";
    return in;
}

const int maxn = 1e3 + 500;
int a[maxn][maxn];
int b[maxn][maxn];
void precalc() {
    map<pii, int> pref;
    for (int n = 0; n < maxn; n++)
        for (int x = 1; x < maxn; x++) {
            if (n == 0) {
                a[n][x] = 0;
                continue;
            }
            if (x > n) {
                a[n][x] = 0;
                continue;
            }
            a[n][x] = pref[{n, n}] - pref[{n, x - 1}];
            pref[{n + x, x}] = pref[{n + x, x - 1}] + a[n][x];
        }


    map<pii, int> pref2;
    for (int n = 0; n < maxn; n++)
        for (int x = 1; x < maxn; x++) {
            if (n == 0) {
                b[n][x] = 1;
                continue;
            }
            if (x > n) {
                b[n][x] = 0;
                continue;
            }
            b[n][x] = pref2[{n, n}] - pref2[{n, x - 1}];
            pref2[{n + x, x}] = pref2[{n + x, x - 1}] + b[n][x];
        }
}

const int mod = 1e9 + 7;
void solve() {
    int n; cin >> n;
    if (n == 1) {
        cout << 2 << "\n";
        return;
    }

    int ans = 0;
    for (int i = 2; i <= (int)1e6 + n; i++) {
        int sm = i * (i + 1) / 2;
        for (int c = 0; c + sm <= n; c++) {
            int os = n - (c + sm);
            ans = (ans + a[os][i + 1] * b[c][i - 1] % mod) % mod;
        }
    }

    cout << ans;
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int tt = 1;
    precalc();
    //cin >> tt;

    while (tt--) {
        solve();
    }
}
