#include <iostream>
#include <vector>
#include <map>
#include <string>

using namespace std;

using ll = long long;


template <typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (T& x : a) in >> x;
    return in;
}

string SEP = " ";

template <typename T>
ostream& operator<<(ostream& out, vector<T> a) {
    for (T& x : a) out << x << SEP;
    return out;
}

void RUN(ll RND) {

}

ll a,b,c,mx= 1e18;


ll check(ll sum){
    if(sum<5){
        return a;
    }
    if(sum>=5 && sum<10){
        return b;
    }
    if(sum>=10){
        return c;
    }
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n; cin >> n;

    vector<vector<int>> a(n, vector<int>(n));
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }

    vector<ll> sum_y_all(n);
    for(int i = 0; i < n; i++){
        for(int j = 0; j < n; j++){
            sum_y_all[i] += a[i][j];
        }
    }
    vector<ll> sum_x_all(n);
    for(int j = 0; j < n; j++){
        for(int i = 0;i < n; i++){
            sum_x_all[j] += a[i][j];
        }
    }

    map<ll, int> map_y;
    for(int i = 0; i < n; i++){
        if(map_y[sum_y_all[i]] == 0) map_y[sum_y_all[i]] = i + 1;
        else map_y[sum_y_all[i]] = -1;
    }
    for(auto& e : map_y){
        if(e.second > 0) e.second--;
    }
    
    map<ll, int> map_x;
    for(int i = 0; i < n; i++){
        if(map_x[sum_x_all[i]] == 0) map_x[sum_x_all[i]] = i + 1;
        else map_x[sum_x_all[i]] = -1;
    }
    for(auto& e : map_x){
        if(e.second > 0) e.second--;
    }

    int rez_r1 = -1, rez_c1 = -1;
    int rez_r2 = -1, rez_c2 = -1;

    for(auto max_i_1 : map_y){
        for(auto max_j_1 : map_x){
            if(max_i_1.second == -1 || max_j_1.second == -1) continue;

            for(auto max_i_2 : map_y){
                for(auto max_j_2 : map_x){
                    if(max_i_2.second == -1 || max_j_2.second == -1) continue;

                    int r1 = max_i_1.second;
                    int c1 = max_j_1.second;
                    int r2 = max_i_2.second;
                    int c2 = max_j_2.second;

                    vector<ll> sum_y_new = sum_y_all;
                    sum_y_new[r1] += -a[r1][c1] + a[r2][c2];
                    sum_y_new[r2] +=  a[r1][c1] - a[r2][c2];

                    vector<ll> sum_x_new = sum_x_all;
                    sum_x_new[c1] += -a[r1][c1] + a[r2][c2];
                    sum_x_new[c2] +=  a[r1][c1] - a[r2][c2];
                    bool ceck_y = (sum_y_new[0] == sum_y_new[1] && sum_y_new[1] == sum_y_new[2]);
                    bool ceck_x = (sum_x_new[0] == sum_x_new[1] && sum_x_new[1] == sum_x_new[2]);
                    if(ceck_x && ceck_y) {
                        rez_r1 = r1;
                        rez_c1 = c1;
                        rez_r2 = r2;
                        rez_c2 = c2;
                    }
               }
            }
        }
    }

    cout << rez_r1 + 1 << ' ' << rez_c1 + 1 << '\n';
    cout << rez_r2 + 1 << ' ' << rez_c2 + 1 << '\n';

    return ('U' ^ 'U');
}
