#include <iostream>
#include <algorithm>
#include <string>
#include <bitset>
#include <map>
#include <vector>
#include <chrono>
#include <queue>
#include <set>
using namespace std;

#define all(x) x.begin(), x.end()
using ll = long long;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	string s;
	cin >> s;
	const int inf = 1e9;
	vector<int> can(26, inf);
	vector<int> cnt(26, 0);
	int q;
	cin >> q;
	vector<int> x(q, inf);
	for (int i = 0; i < q; i++) {
		char ch;
		cin >> ch;
		cin >> can[ch - 'a'];
	}
	int ans = 0;
	for (int i = 0; i < (int)s.size(); i++) {
		if (can[s[i] - 'a'] == inf) {
			ans++;
			continue;
		}
		if (cnt[s[i] - 'a'] % can[s[i] - 'a'] == 0) {
			ans++;
			cnt[s[i] - 'a']++;
		}
		cnt[s[i] - 'a']++;
		ans++;
	}
	cout << ans << '\n';
}

