#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
using ll = long long;
#define int long long

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<vector<int>> pole(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> pole[i][j];
        }
    }
    int need = n * (n * n + 1) / 2;
    vector<int> one(n);
    vector<int> two(n);
    vector<int> bad1;
    vector<int> bad2;
    for (int i = 0; i < n; i++) {
        int s = 0;
        for (int j = 0; j < n; j++) {
            s += pole[i][j];
        }
        if (s != need) {
            bad1.push_back(i);
        }
        one[i] = s;
    }


    for (int i = 0; i < n; i++) {
        int s = 0;
        for (int j = 0; j < n; j++) {
            s += pole[j][i];
        }
        if (s != need) {
            bad2.push_back(i);
        }
        two[i] = s;
    }


    int sum1 = 0;
    int sum2 = 0;


    for (int i = 0; i < n; i++) {
        sum1 += pole[i][i];
        sum2 += pole[i][n - 1 - i];
    }

    auto my_swap = [&](int i1, int j1, int i2, int j2) -> bool {
        one[i1] -= pole[i1][j1];
        two[j1] -= pole[i1][j1];
        one[i2] -= pole[i2][j2];
        two[j2] -= pole[i2][j2];
        if (i1 == j1) {
            sum1 -= pole[i1][j1];
        }
        if (i1 == n - 1 - j1) {
            sum2 -= pole[i1][j1];
        }

        if (i2 == j2) {
            sum1 -= pole[i2][j2];
        }

        if (i2 == n - 1 - j2) {
            sum2 -= pole[i2][j2];
        }

        swap(pole[i1][j1], pole[i2][j2]);
        one[i1] += pole[i1][j1];
        two[j1] += pole[i1][j1];
        one[i2] += pole[i2][j2];
        two[j2] += pole[i2][j2];

        if (i1 == j1) {
            sum1 += pole[i1][j1];
        }
        if (i1 == n - 1 - j1) {
            sum2 += pole[i1][j1];
        }

        if (i2 == j2) {
            sum1 += pole[i2][j2];
        }
        if (i2 == n - 1 - j2) {
            sum2 += pole[i2][j2];
        }
        int val = one[i1];
        for (int j: {sum1, sum2, one[i1], one[i2], two[j1], two[j2]}) {
            if (j != val) {
                return false;
            }
        }
        cout << i1 + 1 << ' ' << j1 + 1 << '\n' << i2 + 1 << ' ' << j2 + 1 << endl;
        exit(0);
        return true;

    };

    if (bad1.size() == 2 && bad2.size() == 2) {
        my_swap(bad1[0], bad2[0], bad1[1], bad2[1]);
        my_swap(bad1[0], bad2[0], bad1[1], bad2[1]);
        my_swap(bad1[1], bad2[0], bad1[0], bad2[1]);
        my_swap(bad1[1], bad2[0], bad1[0], bad2[1]);
        assert(0);
    } else {
        if (bad1.size() == 2) {
            assert(bad2.size() == 0);
            for (int j = 0; j < n; j++) {
                my_swap(bad1[0], j, bad1[1], j);
//                my_swap(bad1[0], j, bad1[1], j);
//                my_swap(bad1[0], j, bad1[1], j);
                my_swap(bad1[0], j, bad1[1], j);
            }
            assert(0);
        } else if (bad2.size() == 2) {
            assert(bad1.size() == 0);
            for (int j = 0; j < n; j++) {
//                my_swap(j, bad2[0], j, bad2[1]);
//                my_swap(j, bad2[0], j, bad2[1]);
                my_swap(j, bad2[0], j, bad2[1]);
                my_swap(j, bad2[0], j, bad2[1]);
            }
            assert(0);
        } else {
            assert(0);
        }
    }
}

