#include <bits/stdc++.h>
//#define int ll

using namespace std;

typedef long long ll;
const int N = 1e5 + 10;

int n;
string s;
int a[N];

struct node {
    int pref = 0, suf = 0, ans = 0, sz = 0;
    int prefa = 0, sufa = 0, ansa = 0;
};

node t[N * 4];

node merg(node a, node b){
    if(a.sz == 0) return b;
    if(b.sz == 0) return a;


    node res;
    res.pref = a.pref;
    if(a.pref == a.sz) res.pref += b.pref;

    res.suf = b.suf;
    if(b.suf == b.sz) res.suf += a.suf;

    res.ans = max({a.ans, b.ans, a.suf + b.pref});



    res.prefa = a.prefa;
    if(a.prefa == a.sz) res.prefa += b.prefa;

    res.sufa = b.sufa;
    if(b.sufa == b.sz) res.sufa += a.sufa;

    res.ansa = max({a.ansa, b.ansa, a.sufa + b.prefa});
    res.sz = a.sz + b.sz;

    return res;


}

void build(int v, int vl, int vr){
    if(vl == vr){
        t[v].pref = t[v].suf = t[v].ans = a[vl];
        t[v].prefa = t[v].sufa = t[v].ansa = 1 - a[vl];
        t[v].sz = 1;

        return;
    }
    int mid = (vl + vr) >> 1;
    build((v << 1), vl, mid);
    build((v << 1) + 1, mid + 1, vr);

    t[v] = merg(t[(v << 1)], t[(v << 1) + 1]);
}


void upd(int v, int vl, int vr, int pos){
    if(vl == vr){
        t[v].pref = t[v].suf = t[v].ans = a[vl];
        t[v].prefa = t[v].sufa = t[v].ansa = 1 - a[vl];
        t[v].sz = 1;

        return;
    }
    int mid = (vl + vr) >> 1;
    if(pos <= mid) upd((v << 1), vl, mid, pos);
    else upd((v << 1) + 1, mid + 1, vr, pos);

    t[v] = merg(t[(v << 1)], t[(v << 1) + 1]);
}

node get(int v, int vl, int vr, int l, int r){
    if(vl > r || vr < l) return node();

    if(vl >=l && vr <= r) return t[v];

    int mid = (vl + vr) >> 1;

    return merg(get((v << 1), vl, mid, l, r),
                get((v << 1) + 1, mid + 1, vr, l, r));
}
void solve(){
    cin >> n >> s;

    for(int i = 1; i <= n; i++) a[i] = (int)(s[i - 1] - 'a');
    build(1, 1, n);


    int q;
    cin >> q;

    while(q--){
        int tp;
        cin >> tp;

        if(tp == 1){
            int pos;
            cin >> pos;

            a[pos] ^= 1;
            upd(1, 1, n, pos);
        }
        else {
            int l, r;
            cin >> l >> r;

            node res = get(1, 1, n, l, r);

//            cout << res.ansa << ' ' << res.ans << endl;
            if(res.ans == 1 && res.ansa <= 1 && a[l] && (r - l + 1) % 2){
                cout << "NO" << endl;
                continue;
            }

            cout << ((res.ans <= 2) ? "YES" : "NO") << endl;
        }
    }


}


int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    solve();

    return 0;
}
