#include <bits/stdc++.h>
using namespace std;

#define vc vector
#define all(a) a.begin(), a.end()
#define FOR(i, a, b) for (int i = a; i < b; ++i)

#define int long long
const int mod = 1e9 + 7;
const int N = 1052;
int f[N], inv[N];

int bin_pow (int a, int b) {
    int res = 1;
    while (b) {
        if (b & 1) res = res * a % mod;
        a = a * a % mod;
        b >>= 1;
    }
    return res;
}

int C (int n, int k) {
    return f[n] * inv[k] % mod * inv[n - k] % mod;
}
int add(int a, int b) {
    if (a + b >= mod) return a + b - mod;
    return a + b;
}
int mul(int a, int b) {
    return (1ll * a * b) % mod;
}
int dp[N], ndp[N], mex[N];
void solve_case() {
    int n;
    cin >> n;
    int ans = 0;
    dp[0] = 1;
    for (int i = 1; i <= n; i++) {
        for (int s = 0; s <= n; s++) {
            if (s + i <= n) {
                ndp[s + i] = add(ndp[s + i], dp[s]);
                ndp[s + i] = add(ndp[s + i], ndp[s]);
            }
        }
        for (int s = 0; s <= n; s++) {
            if (s + i <= n) {
                mex[s + i] = add(mex[s + i], mex[s]);
            }
        }
        for (int s = 0; s <= n; s++) {
            mex[s] = add(mex[s], mul(dp[s], i));
        }
        for (int s = 0; s <= n; s++) {
            dp[s] = ndp[s];
            ndp[s] = 0;
        }
    }
    ans = mex[n];
    if (n == 1) {
        ans = 2;
    }
    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    int tc = 1; //cin >> tc;
    while (tc--) solve_case();
}
