#include <bits/stdc++.h>
using ll = long long;
using namespace std;

constexpr int mod = 1e9 + 7;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<vector<int>> dp(n + 1, vector<int>(n + 1));
    dp[0][0] = 1;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            // i + 1, j + 1
            // i + 1, j + 2
            // i + 1, j
            if (i + 1 <= n && j + 1 <= n) {
                (dp[i + 1][j + 1] += dp[i][j]) %= mod;
            }
            if (i + 1 <= n && j + 2 <= n) {
                (dp[i + 1][j + 2] += dp[i][j]) %= mod;
            }
            if (i + 1 <= n) {
                (dp[i + 1][j] += dp[i][j]) %= mod;
            }
        }
    }
    ll ans = 1;
    for (int i = 1; i < n; ++i) {
        (ans *= dp[i][i + 1]) %= mod;
    }
    cout << ans;
    return 0;
}
