#include <bits/stdc++.h>
#define int long long
using namespace std;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;

    vector<vector<int>> t(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> t[i][j];
        }
    }

    int sum = (1 + n * n) * (n * n) / 2;
    sum /= n;

    vector<int> col(n), row(n);

    vector<int> C, R;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            row[i] += t[i][j];
        }
        if (row[i] != sum) {
            R.push_back(i);
        }
    }

    for (int j = 0; j < n; j++) {
        for (int i = 0; i < n; i++) {
            col[j] += t[i][j];
        }
        if (col[j] != sum) {
            C.push_back(j);
        }
    }

    auto check = [&](int i1, int j1, int i2, int j2) -> bool {
        swap(t[i1][j1], t[i2][j2]);

        for (int i = 0; i < n; i++) {
            int cur_sum = 0;

            for (int j = 0; j < n; j++) {
                cur_sum += t[i][j];
            }

            if (cur_sum != sum) {
                swap(t[i1][j1], t[i2][j2]);
                return false;
            }
        }

        for (int j = 0; j < n; j++) {
            int cur_sum = 0;

            for (int i = 0; i < n; i++) {
                cur_sum += t[i][j];
            }

            if (cur_sum != sum) {
                swap(t[i1][j1], t[i2][j2]);
                return false;
            }
        }

        cout << i1 + 1 << " " << j1 + 1 << "\n";
        cout << i2 + 1 << " " << j2 + 1 << "\n";
        exit(0);
    };

    if (C.size() == 2 && R.size() == 2) {
        int i1 = R.front();
        int i2 = R.back();

        int j1 = C.front();
        int j2 = C.back();


        check(i1, j1, i2, j2);
        check(i1, j2, i2, j1);
    } else if (C.size() == 2) {
        int j1 = C.front();
        int j2 = C.back();

        for (int i = 0; i < n; i++) {
            if (col[j1] - t[i][j1] + t[i][j2] == sum) {
                cout << i + 1 << " " << j1 + 1 << '\n';
                cout << i + 1 << " " << j2 + 1 << '\n';
                exit(0);
            }
        }
    } else {
        int i1 = R.front();
        int i2 = R.back();

        for (int j = 0; j < n; j++) {
            if (row[i1] - t[i1][j] + t[i2][j] == sum) {
                cout << i1 + 1 << " " << j + 1 << '\n';
                cout << i2 + 1 << " " << j + 1 << '\n';
                exit(0);
            }
        }
    }
    return 0;
}
