#include <bits/stdc++.h>

#define int long long
#define ld long double
using namespace std;

map<int, vector<int>> cols_even;
int cnt_cols_even;
map<int, vector<int>> cols_odd;
int cnt_cols_odd;
map<int, vector<int>> rows_even;
int cnt_rows_even;
map<int, vector<int>> rows_odd;
int cnt_rows_odd;

void cpp_stupid(int x, int y) {
    if (cols_even.find(x) == cols_even.end())
        cols_even[x].resize(2);
    if (cols_odd.find(x) == cols_odd.end())
        cols_odd[x].resize(2);
    if (rows_even.find(y) == rows_even.end())
        rows_even[y].resize(2);
    if (rows_odd.find(y) == rows_odd.end())
        rows_odd[y].resize(2);
}

void update(int x, int y, int type) {
    cpp_stupid(x, y);
    if (x % 2 == 0) {
        cnt_cols_even -= max(cols_even[x][0], cols_even[x][1]);
        cols_even[x][y % 2] += type;
//        cout << cols_even[x][y % 2] << endl;
        cnt_cols_even += max(cols_even[x][0], cols_even[x][1]);
    } else {
        cnt_cols_odd -= max(cols_odd[x][0], cols_odd[x][1]);
        cols_odd[x][y % 2] += type;
//        cout << cols_odd[x][y % 2] << endl;
        cnt_cols_odd += max(cols_odd[x][0], cols_odd[x][1]);
    }
    if (y % 2 == 0) {
        cnt_rows_even -= max(rows_even[y][0], rows_even[y][1]);
        rows_even[y][x % 2] += type;
//        cout << rows_even[y][x % 2] << endl;
        cnt_rows_even += max(rows_even[y][0], rows_even[y][1]);
    } else {
        cnt_rows_odd -= max(rows_odd[y][0], rows_odd[y][1]);
        rows_odd[y][x % 2] += type;
//        cout << rows_odd[y][x % 2] << endl;
        cnt_rows_odd += max(rows_odd[y][0], rows_odd[y][1]);
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    set<pair<int, int>> is;
    while (n--) {
        int x, y;
        cin >> x >> y;
        if (is.find({x, y}) == is.end()) {
            is.emplace(x, y);
            update(x, y, 1);
        } else {
            is.erase({x, y});
            update(x, y, -1);
        }
        cout << max({cnt_cols_even, cnt_cols_odd, cnt_rows_even, cnt_rows_odd}) << '\n';
    }
    return 0;
}
