#include "bits/stdc++.h"

using namespace std;
using ll = long long;

#define all(a) a.begin(), a.end()

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}

const ll MAXN = 2e5 + 10;
vector<ll> g[MAXN];
ll dp[MAXN], h[MAXN], near_list[MAXN];

void dfs_prec(ll v, ll now_h) {
    h[v] = now_h;

    if (g[v].size() == 0) {
        near_list[v] = v;
        return;
    }

    for (auto i : g[v]) {
        dfs_prec(i, now_h + 1);
    }

    near_list[v] = near_list[g[v][0]];

    for (auto i : g[v]) {
        if (h[near_list[i]] < h[near_list[v]]) {
            near_list[v] = near_list[i];
        }
    }
}

map<ll, ll> a[MAXN];

void dfs(ll v) {
    if (g[v].size() == 0) {
        dp[v] = 0;
        a[v] = {{h[v], 0}};
        return;
    }

    a[v] = {};
    for (ll i = 0; i < g[v].size(); ++i) {
        dfs(g[v][i]);

        if (a[v].size() < a[g[v][i]].size()) {
            a[v].swap(a[g[v][i]]);
        }

        for (auto j : a[g[v][i]]) {
            if (a[v].find(j.first) == a[v].end()) {
                a[v][j.first] = j.second;
            }
            else {
                a[v][j.first] = max(a[v][j.first], j.second);
            }
        }
    }

    dp[v] = 1 + a[v][h[near_list[v]]];
    a[v][h[v]] = dp[v];
}

void solve() {
    ll n;
    cin >> n;

    for (ll i = 0; i < n; ++i) {
        ll pr;
        cin >> pr;

        g[pr - 1].push_back(i + 1);
    }

    dfs_prec(0, 0);

    dfs(0);

    cout << dp[0];
}
