#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;
using ld = long double;
using ll = long long;
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (ll) x.size()
#define szof(x) (ll) x.size()

const int INF = 1e9 + 1e3;

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        g[p - 1].push_back(i);
    }
    vector<int> dp(n, 0), mn(n, INF);
    vector<unordered_map<int, int>> kek(n);
    auto Dfs = [&](auto Dfs, int u, int d) -> void {
        dp[u] = 1;
        multiset<int> ms;
        for (auto to : g[u]) {
            Dfs(Dfs, to, d + 1);
            mn[u] = min(mn[u], mn[to]);
            ms.insert(mn[to]);
            dp[u] = max(dp[u], dp[to]);
        }
        for (auto to : g[u]) {
            int val = mn[to];
            ms.erase(ms.find(val));
            if (!ms.empty()) {
                int v = *ms.begin();
                if (kek[to].find(v) != kek[to].end()) {
                    dp[u] = max(dp[u], 1 + kek[to][v]);
                }
            }
            ms.insert(val);
        }
        for (auto to : g[u]) {
            if (sz(kek[u]) < sz(kek[to])) {
                swap(kek[u], kek[to]);
            }
            for (auto [k, v] : kek[to]) {
                kek[u][k] = max(kek[u][k], v);
            }
        }
        kek[u][d] = dp[u];
        if (mn[u] == INF) {
            mn[u] = d;
        }
    };
    Dfs(Dfs, 0, 0);
    cout << dp[0];
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve(), cout << '\n';
    return 0;
}
