#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;
using ld = long double;
using ll = long long;
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (ll) x.size()
#define szof(x) (ll) x.size()

const ll MAXN = 1001;
ll a[MAXN][MAXN];

void solve() {
    ll n;
    cin >> n;
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < n; ++j) {
            cin >> a[i][j];
        }
    }
    ll sum_need = 0;
    for (ll i = 1; i <= n * n; ++i) {
        sum_need += i;
    }
    sum_need /= n;
    vector<ll> bad_str, bad_col;
    for (ll i = 0; i < n; ++i) {
        ll sum = 0, sum2 = 0;
        for (ll j = 0; j < n; ++j) {
            sum += a[i][j];
            sum2 += a[j][i];
        }
        if (sum != sum_need) {
            bad_str.push_back(i);
        }
        if (sum2 != sum_need) {
            bad_col.push_back(i);
        }
    }
//    cout << sz(bad_col) << ' ' << sz(bad_str) << endl;
//    return;
    if (sz(bad_col) == 2 && sz(bad_str) == 2) {
        swap(a[bad_str[0]][bad_col[0]], a[bad_str[1]][bad_col[1]]);
        ll sum = 0;
        for (ll i = 0; i < n; ++i) {
            sum += a[bad_str[0]][i];
        }
        if (sum == sum_need) {
            cout << bad_str[0] + 1 << ' ' << bad_col[0] + 1 << '\n';
            cout << bad_str[1] + 1 << ' ' << bad_col[1] + 1 << '\n';
            return;
        }
        cout << bad_str[0] + 1 << ' ' << bad_col[1] + 1 << '\n';
        cout << bad_str[1] + 1 << ' ' << bad_col[0] + 1 << '\n';
        return;
    }
    if (sz(bad_str) == 0) {
        ll num_str = -1, sum1 = 0, sum2 = 0;
        for (ll i = 0; i < n; ++i) {
            sum1 += a[i][bad_col[0]];
            sum2 += a[i][bad_col[1]];
        }
        for (ll i = 0; i < n; ++i) {
            sum1 += a[i][bad_col[1]] - a[i][bad_col[0]];
            sum2 += a[i][bad_col[0]] - a[i][bad_col[1]];
            if (sum1 == sum_need && sum2 == sum_need) {
                num_str = i + 1;
                break;
            }
            sum1 -= (a[i][bad_col[1]] - a[i][bad_col[0]]);
            sum2 -= (a[i][bad_col[0]] - a[i][bad_col[1]]);
        }
        cout << num_str << ' ' << bad_col[0] + 1 << '\n';
        cout << num_str << ' ' << bad_col[1] + 1 << '\n';
        return;
    }
    ll num_col = -1, sum1 = 0, sum2 = 0;
    for (ll i = 0; i < n; ++i) {
        sum1 += a[bad_str[0]][i];
        sum2 += a[bad_str[1]][i];
    }
    for (ll i = 0; i < n; ++i) {
        sum1 += a[bad_str[1]][i] - a[bad_str[0]][i];
        sum2 += a[bad_str[0]][i] - a[bad_str[1]][i];
        if (sum1 == sum_need && sum2 == sum_need) {
            num_col = i + 1;
            break;
        }
        sum1 -= (a[bad_str[1]][i] - a[bad_str[0]][i]);
        sum2 -= (a[bad_str[0]][i] - a[bad_str[1]][i]);
    }
    cout << bad_str[0] + 1 << ' ' << num_col << '\n';
    cout << bad_str[1] + 1 << ' ' << num_col << '\n';
    return;
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t = 1;
//    cin >> t;
    while (t--)
        solve(), cout << '\n';
    return 0;
}
