#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;
using ld = long double;
using ll = long long;
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (ll) x.size()
#define szof(x) (ll) x.size()

const ll MOD = 1e9 + 7, MAXN = 1e5 + 1;
ll fact[MAXN], rfact[MAXN];

ll binpow(ll a, ll x) {
    if (x == 0) {
        return 1;
    }
    if (x % 2 == 0) {
        ll help = binpow(a, x / 2);
        return help * help % MOD;
    } else {
        return binpow(a, x - 1) * a % MOD;
    }
}

ll C(ll n, ll k) {
    return fact[n] * rfact[k] % MOD * rfact[n - k] % MOD;
}

void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n), c(3);
    ll sum = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i] %= 3;
        sum += a[i];
        c[a[i]]++;
    }
    if (sum % 3 == 0) {
        return void(cout << 0);
    }
    if (c[2] == 0) {
        swap(c[1], c[2]);
    }
    if (c[1] > c[2]) {
        swap(c[1], c[2]);
    }
    if (c[2] - c[1] != 1 && c[2] - c[1] != 2) {
        return void(cout << 0);
    }
    ll ans = C(n - 1, c[0]) * fact[c[0]] % MOD * fact[c[1]] % MOD * fact[c[2]] % MOD;
    cout << ans;
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    fact[0] = 1;
    for (ll i = 1; i < MAXN; ++i) {
        fact[i] = fact[i - 1] * i % MOD;
    }

    rfact[MAXN - 1] = binpow(fact[MAXN - 1], MOD - 2);
    for (ll i = MAXN - 2; i >= 0; --i) {
        rfact[i] = rfact[i + 1] * (i + 1) % MOD;
    }

    int t = 1;
//    cin >> t;
    while (t--)
        solve(), cout << '\n';
    return 0;
}
