#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

typedef long long ll;

const ll mod = 1e9 + 7;

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	ll n;
	cin >> n;

	vector<vector<ll>> dp(n, vector<ll>(n + 1));
	dp[0][0] = 1;
	for (int i = 1; i < n; ++i) {
		for (int s = 0; s <= n; ++s) {
			dp[i][s] = dp[i - 1][s];
			if (s >= 1) {
				dp[i][s] = (dp[i][s] + dp[i - 1][s - 1]) % mod;
			}
			if (s >= 2) {
				dp[i][s] = (dp[i][s] + dp[i - 1][s - 2]) % mod;
			}
		}
	}

	ll res = 1;

	for (int i = 1; i < n; ++i) {
		res = res * dp[i][i + 1] % mod;
	}
	cout << res;


	return 0;
}