#include <iostream>
#include <iomanip>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

ll pow2(ll a, ll b) {
    if (b == 0) return 1ll;
    if (b == 1) return (a);
    ll x = pow2(a, b / 2);
    x = x * x;
    if (b % 2 == 0) {
        return x;
    } else {
        return (a * x);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll k;
    cin >> k;
    ll l = 0, r = 1000000000000000, mid;
    while (r - l > 1) {
        mid = (r + l) / 2;
        cout << "? " << mid << endl;
        ll know;
        cin >> know;
        if (know - k >= 1) {
            r = mid;
        } else {
            l = mid;
        }
    }
    ll rsave = r;
    r = 1000000000000000;
    while (r - l > 1) {
        mid = (r + l) / 2;
        cout << "? " << mid << endl;
        ll know;
        cin >> know;
        if (know - k >= 2) {
            r = mid;
        } else {
            l = mid;
        }
    }
    ll d = r - rsave;
    ll bsave;
    for (int b = 2; b <= 2023; ++b) {
        if (pow2(b, k + 1) - pow2(b, k) == d) {
            bsave = b;
            break;
        }
    }
    ll x = pow2(bsave, k) - rsave;
    cout << "! " << x << " " << bsave << endl;
    return 0;

}
