#include <bits/stdc++.h>

using namespace std;

#define int long long
#define fir first
#define sec second

vector<vector<int>> g;
vector<int> h, mnh;
deque<int> q = {1};
vector<int> res, now;

void dfs(int u) {
    mnh[u] = h[u];
    for (auto v : g[u]) {
        h[v] = h[u] + 1;
        dfs(v);
        if (mnh[u] == h[u] || mnh[u] > mnh[v]) {
            mnh[u] = mnh[v];
        }
    }
}

void dfs1(int u, int l) {
    if (l == 0) {
        if (mnh[u] == h[u]) {
            return;
        }
        now.push_back(u);
        return;
    }
    for (auto v : g[u]) {
        dfs1(v, l - 1);
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    g.resize(n + 1);
    for (int i = 2; i <= n; i++) {
        int x;
        cin >> x;
        g[x].push_back(i);
    }
    h.resize(n + 1);
    mnh.resize(n + 1);
    dfs(1);
    res.resize(n + 1);
    res[1] = 1;
    while (!q.empty()) {
        int u = q[0];
        q.pop_front();
        if (mnh[u] == h[u]) {
            continue;
        }
        int l = mnh[u] - h[u];
        now = {};
        dfs1(u, l);
        for (auto v : now) {
            res[v] = res[u] + 1;
            q.push_back(v);
        }
    }
    int mx = 1;
    for (int i = 1; i <= n; i++) {
        mx = max(mx, res[i]);
    }
    cout << mx;
}