#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <map>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>


using namespace std;
typedef long long i64;
typedef long long ll;
#define int long long

const int MAXN = 5009;
const int MOD = 1e9 + 7;

int dp[MAXN][MAXN];

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG


	int n;
	cin >> n;
	dp[1][0] = 1;
	dp[1][1] = 1;
	dp[1][2] = 2;
	dp[2][1] = 1;
	dp[2][2] = 3;
	for (int i = 3; i <= n; i++)
	{
		for (int j = 1; j <= i + 2; j++)
		{
			if (2 * j < i)
			{
				continue;
			}
			dp[i][j] = dp[i][j - 1] + dp[i - 1][j - 1] + dp[i - 2][j - 1];
			dp[i][j] %= MOD;
		}
	}
	int ans = 1;
	for (int i = 1; i <= n; i++)
	{
		ans *= dp[i][i - 1];
		ans %= MOD;
	}
	cout << ans;
}