#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <map>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>


using namespace std;
typedef long long i64;

#define endl '\n'


int a[1000][1000];

bool check(int n)
{
	long long sum = -1;
	for (int i = 0; i < n; i++)
	{
		long long s = 0;
		for (int j = 0; j < n; j++)
		{
			s += a[i][j];
		}
		if (sum == -1)
		{
			sum = s;
		}
		if (sum != s)
		{
			return false;
		}
	}
	for (int j = 0; j < n; j++)
	{
		long long s = 0;
		for (int i = 0; i < n; i++)
		{
			s += a[i][j];
		}
		if (sum == -1)
		{
			sum = s;
		}
		if (sum != s)
		{
			return false;
		}
	}
	return true;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif

	cin.tie(0);
	ios_base::sync_with_stdio(0);

	int n; cin >> n;

	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			cin >> a[i][j];
		}
	}

	if (n <= 10)
	{
		for (int i = 0; i < n; i++)
		{
			for (int j = 0; j < n; j++)
			{
				for (int k = 0; k < n; k++)
				{
					for (int l = 0; l < n; l++)
					{
						if (i == k && j == l) continue;

						swap(a[i][j], a[k][l]);
						if (check(n))
						{
							cout << i + 1 << ' ' << j + 1 << endl;
							cout << k + 1 << ' ' << l + 1 << endl;
							return 0;
						}
						swap(a[i][j], a[k][l]);
					}
				}
			}
		}
	}
	else
	{
		map<long long, int> m;
		for (int i = 0; i < n; i++)
		{
			long long s = 0;
			for (int j = 0; j < n; j++)
			{
				s += a[i][j];
			}
			m[s]++;
		}
		for (int j = 0; j < n; j++)
		{
			long long s = 0;
			for (int i = 0; i < n; i++)
			{
				s += a[i][j];
			}
			m[s]++;
		}

		int cnt = 0;
		long long st = 0;
		for (const auto& i : m)
		{
			if (cnt < i.second)
			{
				cnt = i.second;
				st = i.first;
			}
		}

		vector<int> is;
		for (int i = 0; i < n; i++)
		{
			long long s = 0;
			for (int j = 0; j < n; j++)
			{
				s += a[i][j];
			}
			if (s != st)
			{
				is.push_back(i);
			}
		}
		vector<int> js;
		for (int j = 0; j < n; j++)
		{
			long long s = 0;
			for (int i = 0; i < n; i++)
			{
				s += a[i][j];
			}
			if (s != st)
			{
				js.push_back(j);
			}
		}

		if (is.size() == 0)
		{
			long long s1 = 0, s2 = 0;
			for (int i = 0; i < n; i++)
			{
				s1 += a[i][js[0]];
				s2 += a[i][js[1]];
			}
			for (int i = 0; i < n; i++)
			{
				if (s1 - a[i][js[0]] + a[i][js[1]] == s2 - a[i][js[1]] + a[i][js[0]])
				{
					cout << i + 1 << ' ' << js[0] + 1 << endl;
					cout << i + 1 << ' ' << js[1] + 1 << endl;
					return 0;
				}
			}
		}
		else if (js.size() == 0)
		{
			long long s1 = 0, s2 = 0;
			for (int j = 0; j < n; j++)
			{
				s1 += a[is[0]][j];
				s2 += a[is[1]][j];
			}
			for (int j = 0; j < n; j++)
			{
				if (s1 - a[is[0]][j] + a[is[1]][j] == s2 - a[is[1]][j] + a[is[0]][j])
				{
					cout << is[0] + 1 << ' ' << j + 1 << endl;
					cout << is[1] + 1 << ' ' << j + 1 << endl;
					return 0;
				}
			}
		}
		else
		{
			swap(a[is[0]][js[0]], a[is[1]][js[1]]);
			if (check(n))
			{
				cout << is[0] + 1 << ' ' << js[0] + 1 << endl;
				cout << is[1] + 1 << ' ' << js[1] + 1 << endl;
				return 0;
			}

			cout << is[1] + 1 << ' ' << js[0] + 1 << endl;
			cout << is[0] + 1 << ' ' << js[1] + 1 << endl;
		}
	}

	return 0;
}