#include <bits/stdc++.h>
#define int long long
const int inf=1e17;
using namespace std;

void opt(){
    ios::sync_with_stdio(false);
    cin.tie(0);
}

const int c=1<<17;

struct node{
    int16_t c[2][2];
    node(char a){
        if(a=='a'){
            c[1][1]=0;
            c[0][0]=1;
            c[0][1]=1;
            c[1][0]=1;
        } else{
            c[0][0]=0;
            c[0][1]=1;
            c[1][0]=1;
            c[1][1]=0;
        }
    }
    node(){
        c[0][0]=-1;
        c[0][1]=-1;
        c[1][0]=-1;
        c[1][1]=-1;
    }
};

struct segtree{
    string s1;
    vector<int>l1;
    vector<node> seg;
    segtree(string s){
        s1=s;
        while(s1.size()<c){
            s1+='a';
        }
        l1.assign(2*c,0);
        seg.assign(2*c,node('a'));
        for(int i=c;i<2*c;i++){
            if(s1[i-c]=='b'){
                seg[i].c[0][0]=0;
            }
            l1[i]=i-c;
        }
        for(int i=c-1;i>0;i--){
            upd(i);
        }
    }
    node merge(const node& a, const node& b, int pos){
        if(a.c[0][0]==-1) return b;
        if(b.c[0][0]==-1) return a;
        node ans('a');
        ans.c[0][0]=(a.c[0][0]&&b.c[0][0])||(a.c[0][1]&&b.c[1][0] && s1[pos]!=s1[pos+1]);
        ans.c[0][1]=(a.c[0][0]&&b.c[0][1])||(a.c[0][1]&&b.c[1][1] && s1[pos]!=s1[pos+1]);
        ans.c[1][0]=(a.c[1][0]&&b.c[0][0])||(a.c[1][1]&&b.c[1][0] && s1[pos]!=s1[pos+1]);
        ans.c[1][1]=(a.c[1][0]&&b.c[0][1])||(a.c[1][1]&&b.c[1][1] && s1[pos]!=s1[pos+1]);
        return ans;
    }
    void upd(int v){
        l1[v]=l1[2*v];
        seg[v]=merge(seg[2*v],seg[2*v+1],l1[2*v+1]-1);
    }
    void change(int v){
        v/=2;
        if(!v) return;
        upd(v);
        change(v);
    }
    node get(int v, int l, int r, int lv, int rv){
        if(l<=lv && rv<=r){
            return seg[v];
        }
        if(lv>=r || l>=rv){
            return node();
        }
        int mid=(lv+rv)/2;
        return merge(get(2*v,l,r,lv,mid),get(2*v+1,l,r,mid,rv),l1[2*v+1]-1);
    }
};
int32_t main() {
    opt();
    int n;
    cin>>n;
    string s;
    cin>>s;
    segtree d(s);
    int q;
    cin>>q;
    for(int i=0;i<q;i++){
        int type;
        cin>>type;
        if(type==1){
            int j;
            cin>>j;
            d.seg[c+j-1].c[0][0]^=1;
            if(d.s1[j-1]=='a'){
                d.s1[j-1]='b';
            } else {
                d.s1[j-1]='a';
            }
            d.change(c+j-1);
        } else {
            int l,r;
            cin>>l>>r;
            if(d.get(1,l-1,r,0,c).c[0][0]){
                cout<<"YES\n";
            } else {
                cout<<"NO\n";
            }
        }
    }
    return 0;
}
