#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e13;
const ll MOD = 1e9+7;


ll binpow(ll n, ll p)
{
	if (p == 0) return 1;
	if (p % 2 == 0)
	{
		ll b = binpow(n, p / 2);
		return (b * b) % MOD;
	}
	return (binpow(n, p - 1) * n) % MOD;
}


void solve()
{
	vector<vector<set<pair<int, int>>>>w(4, vector<set<pair<int, int>>>(4));
	int n; cin >> n;
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		int kwx = ((x % 4) + 4) % 4;
		int kwy = ((y % 4) + 4) % 4;
		w[kwx][kwy].insert({ x,y });
		int ans = 0;
		for (int bsx = 0; bsx < 4; ++bsx) {
			for (int bsy = 0; bsy < 4; ++bsy) {
				ans = max(ans, int(
					w[bsx][bsy].size() +
					w[(bsx + 2) % 4][bsy].size() +
					w[bsx][(bsy + 2) % 4].size() +
					w[(bsx + 2) % 4][(bsy + 2) % 4].size())
				);
				ans = max(ans, int(
					w[bsx][bsy].size() +
					w[bsx][(bsy + 2) % 4].size() +
					w[(bsx + 2) % 4][(bsy + 1) % 4].size() +
					w[(bsx + 2) % 4][(bsy + 3) % 4].size()
					));
				ans = max(ans, int(
					w[bsx][bsy].size() +
					w[(bsx + 2) % 4][bsy].size() +
					w[(bsx + 1) % 4][(bsy + 2) % 4].size() +
					w[(bsx + 3) % 4][(bsy + 2) % 4].size()
					));
			}
		}
		cout << ans;
	}
}

int main()
{
	int t = 1;
	//cin>>t;
	while (t--) solve();
}