#include <bits/stdc++.h>

#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops","omit-frame-poller","inline")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,abm,mmx,avx,avx2,fma,tune=native")
using namespace std;
using ll = long long;

//#define int long long

const ll M = 1e9 + 7;

ll pow(ll m, ll k) {
    if (k == 0) {
        return 1;
    }
    ll v = 1;
    while(k > 1){
        if(k % 2 == 1){
            v = v * m % M;
            k--;
        } else{
            m = m * m % M;
            k/=2;
        }
    }
    return v * m % M;
}

ll f[5001];
ll dp[5001];
void solve() {
    f[0] = 1;
    for (ll i = 1; i < 5001; ++i) {
        f[i] = f[i - 1] * i % M;
    }
    ll n;
    cin >> n;
    dp[1] = 1;
    dp[2] = 1;
    for (int i = 3; i < n + 1; ++i) {
        ll sum = 0;
        for (int cnt2 = 1; cnt2 <= i / 2; ++cnt2) {
            ll cnt1 = i - cnt2 * 2;
            ll cnt0 = i - 1 - cnt1 - cnt2;
            sum += f[i - 1] * pow(f[cnt1] * f[cnt2] % M * f[cnt0] % M, M - 2);
            sum %= M;
        }
        dp[i] = dp[i - 1] * sum % M;
    }
    cout << dp[n];
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
}
