#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pp = pair<int, int>;
const int maxn = 1011;
int arr[maxn][maxn];
pp pos[maxn * maxn];

int main() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> arr[i][j];
            pos[arr[i][j]] = {i, j};
        }
    }
    if (n <= 4) {
        for (int x1 = 0; x1 < n; x1++) {
            for (int y1 = 0; y1 < n; y1++) {
                for (int x2 = 0; x2 < n; x2++) {
                    for (int y2 = 0; y2 < n; y2++) {
                        if (x1 == x2 && y1 == y2) {
                            continue;
                        }
                        swap(arr[x1][y1], arr[x2][y2]);
                        vector<int> row_sums(n), col_sums(n);
                        for (int i = 0; i < n; i++) {
                            for (int j = 0; j < n; j++) {
                                row_sums[i] += arr[i][j];
                                col_sums[j] += arr[i][j];
                            }
                        }
                        int v = row_sums[0];
                        if (all_of(row_sums.begin(), row_sums.end(), [&](int x) { return x == v; })
                            && all_of(col_sums.begin(),
                                      col_sums.end(), [&](int x) { return x == v; })) {
                            cout << x1 + 1 << ' ' << y1 + 1 << '\n' << x2 + 1 << ' ' << y2 + 1;
                            return 0;
                        }
                        swap(arr[x1][y1], arr[x2][y2]);
                    }
                }
            }
        }
    }

    vector<int> row_sums(n), col_sums(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            row_sums[i] += arr[i][j];
            col_sums[j] += arr[i][j];
        }
    }
    map<int, vector<int>> rows_with_s, cols_with_s;
    for (int i = 0; i < n; i++) {
        rows_with_s[row_sums[i]].push_back(i);
        cols_with_s[col_sums[i]].push_back(i);
    }
    vector<int> ones_row_idx, ones_col_idx;
    for (auto &[key, val] : rows_with_s) {
        if (val.size() == 1) {
            ones_row_idx.push_back(val[0]);
        }
    }
    for (auto &[key, val] : cols_with_s) {
        if (val.size() == 1) {
            ones_col_idx.push_back(val[0]);
        }
    }
    if (ones_row_idx.size() == 2) {
        int delta = row_sums[ones_row_idx[1]] - row_sums[ones_row_idx[0]];
        set<int> b;
        for (int j = 0; j < n; j++) {
            b.insert(arr[ones_row_idx[1]][j]);
        }
        for (int j = 0; j < n; j++) {
            if (b.find(arr[ones_row_idx[0]][j] + delta) != b.end()) {//+ or -
                int v1 = arr[ones_row_idx[0]][j];
                int v2 = arr[ones_row_idx[0]][j] + delta;
                cout << pos[v1].first + 1 << ' ' << pos[v1].second + 1 << '\n' << pos[v2].first + 1 << ' '
                     << pos[v2].second + 1;
                return 0;
            }
        }
    } else {
        int delta = col_sums[ones_col_idx[1]] - col_sums[ones_col_idx[0]];
        set<int> b;
        for (int j = 0; j < n; j++) {
            b.insert(arr[j][ones_col_idx[1]]);
        }
        for (int j = 0; j < n; j++) {
            if (b.find(arr[j][ones_col_idx[0]] + delta) != b.end()) {//+ or -
                int v1 = arr[j][ones_col_idx[0]];
                int v2 = arr[j][ones_col_idx[0]] + delta;
                cout << pos[v1].first + 1 << ' ' << pos[v1].second + 1 << '\n' << pos[v2].first + 1 << ' '
                     << pos[v2].second + 1;
                return 0;
            }
        }
    }
}
