#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pp = pair<ll, ll>;
const ll maxn = 1011;
ll arr[maxn][maxn];
pp pos[maxn * maxn];

signed main() {
    ll n;
    cin >> n;
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < n; j++) {
            cin >> arr[i][j];
            pos[arr[i][j]] = {i, j};
        }
    }
    if (n <= 4) {
        for (ll x1 = 0; x1 < n; x1++) {
            for (ll y1 = 0; y1 < n; y1++) {
                for (ll x2 = 0; x2 < n; x2++) {
                    for (ll y2 = 0; y2 < n; y2++) {
                        if (x1 == x2 && y1 == y2) {
                            continue;
                        }
                        swap(arr[x1][y1], arr[x2][y2]);
                        vector<ll> row_sums(n), col_sums(n);
                        for (ll i = 0; i < n; i++) {
                            for (ll j = 0; j < n; j++) {
                                row_sums[i] += arr[i][j];
                                col_sums[j] += arr[i][j];
                            }
                        }
                        ll v = row_sums[0];
                        if (all_of(row_sums.begin(), row_sums.end(), [&](ll x) { return x == v; })
                            && all_of(col_sums.begin(),
                                      col_sums.end(), [&](ll x) { return x == v; })) {
                            cout << x1 + 1 << ' ' << y1 + 1 << '\n' << x2 + 1 << ' ' << y2 + 1;
                            return 0;
                        }
                        swap(arr[x1][y1], arr[x2][y2]);
                    }
                }
            }
        }
    }

    vector<ll> row_sums(n), col_sums(n);
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < n; j++) {
            row_sums[i] += arr[i][j];
            col_sums[j] += arr[i][j];
        }
    }
    map<ll, vector<ll>> rows_with_s, cols_with_s;
    for (ll i = 0; i < n; i++) {
        rows_with_s[row_sums[i]].push_back(i);
        cols_with_s[col_sums[i]].push_back(i);
    }
    vector<ll> ones_row_idx, ones_col_idx;
    for (auto &[key, val] : rows_with_s) {
        if (val.size() == 1) {
            ones_row_idx.push_back(val[0]);
        }
    }
    for (auto &[key, val] : cols_with_s) {
        if (val.size() == 1) {
            ones_col_idx.push_back(val[0]);
        }
    }
    if (ones_row_idx.size() == 2) {
        ll delta = row_sums[ones_row_idx[1]] - row_sums[ones_row_idx[0]];
        set<ll> b;
        for (ll j = 0; j < n; j++) {
            b.insert(arr[ones_row_idx[1]][j]);
        }
        for (ll j = 0; j < n; j++) {
            if (b.find(arr[ones_row_idx[0]][j] - delta / 2) != b.end()) {//+ or -
                ll v1 = arr[ones_row_idx[0]][j];
                ll v2 = arr[ones_row_idx[0]][j] - delta / 2;
                cout << pos[v1].first + 1 << ' ' << pos[v1].second + 1 << '\n' << pos[v2].first + 1 << ' '
                     << pos[v2].second + 1;
                return 0;
            }
        }
    } else {
        ll delta = col_sums[ones_col_idx[1]] - col_sums[ones_col_idx[0]];
        set<ll> b;
        for (ll j = 0; j < n; j++) {
            b.insert(arr[j][ones_col_idx[1]]);
        }
        for (ll j = 0; j < n; j++) {
            if (b.find(arr[j][ones_col_idx[0]] - delta / 2) != b.end()) {//+ or -
                ll v1 = arr[j][ones_col_idx[0]];
                ll v2 = arr[j][ones_col_idx[0]] - delta / 2;
                cout << pos[v1].first + 1 << ' ' << pos[v1].second + 1 << '\n' << pos[v2].first + 1 << ' '
                     << pos[v2].second + 1;
                return 0;
            }
        }
    }
}
