#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<algorithm>
#include<cmath>
#include<vector>
#include<string>
#include<set>
#include<map>


using namespace std;
#define ll long long
#define all(a) a.begin(), a.end()

void solve() {
	int n;
	cin >> n;
	vector<vector<ll>> a(n, vector<ll>(n, 0));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			cin >> a[i][j];
		}
	}
	vector<pair<ll, ll>> sum_strock(n, { 0, 0 });
	vector<pair<ll, ll>> sum_stolb(n, { 0, 0 });
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			sum_strock[i].first += a[i][j];
			sum_strock[i].second = i;
			sum_stolb[j].first += a[i][j];
			sum_stolb[j].second = j;
		}
	}
	sort(all(sum_stolb));
	sort(all(sum_strock));
	ll x1, y1, x2, y2;
	if (sum_strock[0].first == sum_strock[n - 1].first) {
		y1 = sum_stolb[0].second;
		y2 = sum_stolb[n - 1].second;
		ll sum1 = 0, sum2 = 0;
		for (int i = 0; i < n; ++i) {
			sum1 += a[i][y1];
			sum2 += a[i][y2];
		}
		for (int i = 0; i < n; ++i) {
			if (sum1 - a[i][y1] + a[i][y2] == sum2 + a[i][y1] - a[i][y2]) {
				x1 = i;
				x2 = i;
				break;
			}
		}
	}
	else {
		x1 = sum_strock[0].second;
		x2 = sum_strock[n - 1].second;
	}
	////////////////////
	if (sum_stolb[0].first == sum_stolb[n - 1].first) {
		x1 = sum_strock[0].second;
		x2 = sum_strock[n - 1].second;
		ll sum1 = 0, sum2 = 0;
		for (int i = 0; i < n; ++i) {
			sum1 += a[x1][i];
			sum2 += a[x2][i];
		}
		for (int i = 0; i < n; ++i) {
			if (sum1 - a[x1][i] + a[x2][i] == sum2 + a[x1][i] - a[x2][i]) {
				y1 = i;
				y2 = i;
				break;
			}
		}
	}
	else {
		y1 = sum_stolb[0].second;
		y2 = sum_stolb[n - 1].second;
	}
	cout << x1 + 1 << " " << y1 + 1 << endl << x2 + 1 << " " << y2 + 1;
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // _DEBUG

	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}