#include <iostream>
#include <map>
#include <algorithm>
#include <vector>

using namespace std;

using ll = long long;

const ll maxb = 2023;

ll query(ll d) {
    cout << "? " << d << endl;
    ll ans;
    cin >> ans;
    return ans;
}

ll first_with(ll d, ll lo, ll hi) {
//    cout << "d for " << d << endl;
//    ll ans;
//    cin >> ans;
//    return ans;

    while (hi - lo > 1) {
        ll m = (lo + hi) / 2;

        if (query(m) >= d) hi = m;
        else lo = m;
    }

    return hi;
}

int main() {
    ll n;
    cin >> n;

    // to next digit
    ll d1 = first_with(n + 1, 0, 1e10);
    ll d2 = first_with(n + 2, d1, 1e15);

    ll base_ans = -1;

    for (ll base = 2; base <= 2023; base++) {
        ll z = 1;
        for (ll i = 0; i < n && z < ll(1e15); i++) { // sus
            z *= base;
        }
        if (z * (base - 1) == (d2 - d1)) {
            base_ans = base;
            break;
        }
    }

    if (base_ans == -1) {
        exit(-1);
    }

    ll x = 1;
    for (ll i = 0; i < n; i++) {
        x *= base_ans;
    }
    x -= d1;

    cout << "! " << x << " " << base_ans << endl;
}