#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <stack>
#include <set>

using namespace std;

#define ll long long
#define vll vector<ll>
#define pll pair<ll,ll>
#define FOR(i,a,b) for(ll i = (a); i < (b); ++i)
#define vvll vector<vll>


void speed()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
}
const int mod = 1e9 + 7;

int main()
{
	speed();
	ll n;
	cin >> n;
	vll fact(100001);
	fact[1] = 1;
	fact[0] = 1;
	FOR(i, 2, 100001)
	{
		fact[i] = fact[i - 1] * i % mod;
	}
	ll cnt0 = 0, cnt1 = 0, cnt2 = 0;
	FOR(i, 0, n)
	{
		ll a;
		cin >> a;
		if (a % 3 == 0)
			cnt0++;
		else if (a % 3 == 1)
			cnt1++;
		else
			cnt2++;
	}
	int v = 0;
	if (cnt1 < 2 && cnt2 < 2) v = 0;
	if (cnt1 >= 2 && -1 <= cnt1 - 2 - cnt2 && cnt1 - 2 - cnt2 <= 0) v++;
	if (cnt2 >= 2 && -1 <= cnt2 - 2 - cnt1 && cnt2 - 2 - cnt1 <= 0) v++;
	ll ans = (((((fact[cnt1] * fact[cnt2] % mod) * v % mod) * fact[n - 1]) % mod) / fact[cnt1 + cnt2 - 1]) % mod;
	cout << ans << endl;
}