#include <bits/stdc++.h>
#define ll long long
#define len(x) (int)x.size()

using namespace std;

//#define int ll

vector<vector<int>> g;
vector<int> dp;
vector<int> ans;

void dfs(int cur, int cnt, int curans){

    if(len(g[cur]) == 0){
        ans[cur] = curans;
        return;
    }

    if(cnt == 0){
        ++curans;
        cnt = dp[cur];
    }
    for(auto x : g[cur]){
        dfs(x, cnt - 1, curans);
    }
}

int precalc(int cur){
    if(len(g[cur]) == 0) return (dp[cur] = 0) + 1;
    for(auto x : g[cur]){
        dp[cur] = min(dp[cur], precalc(x));
    }
    return dp[cur] + 1;
}

void solve(){
    int n;
    cin >> n;
    g.resize(n);
    dp.resize(n, 1e9);
    ans.resize(n, 1e9);
    for(int i = 0; i < n - 1; ++i){
        int x;
        cin >> x;
        g[x - 1].push_back(i + 1);
    }
    precalc(0);
    dfs(0, dp[0], 0);
    int mmin = 0;
    for(int i = 0; i < n; ++i){
        if(len(g[i])) continue;
        mmin = max(mmin, ans[i]);
    }
    cout << mmin + 1 << '\n';
}


signed main() {
    ios_base::sync_with_stdio(false);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
}