#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int N = 1000 + 7, MOD = 1e9 + 7;

int pref[N][N], suf[N][N];

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    suf[n + 1][0] = 1;
    suf[n + 2][0] = 1;

    for (int i = n; i >= 1; --i) {
        for (int sum = 0; sum <= n; ++sum) {
            suf[i][sum] = suf[i + 1][sum];
            if (sum - i >= 0) {
                suf[i][sum] = (suf[i][sum] + suf[i][sum - i]) % MOD;
            }
        }
    }

    pref[0][0] = 1;
    for (int i = 1; i <= n; ++i) {
        for (int sum = 0; sum <= n; ++sum) {
            pref[i][sum] = (sum - i >= 0 ? pref[i][sum - i] + pref[i - 1][sum - i] : 0) % MOD;
        }
    }

    int ans = 0;
    for (int mex = 1; mex <= n + 1; ++mex) {
        for (int s = 0; s <= n; ++s) {
            ans = (ans + 1LL * pref[mex - 1][s] * suf[mex + 1][n - s] % MOD * mex) % MOD;
        }
    }
    cout << ans << '\n';

    return 0;
}