//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define dl long double
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int)v.size()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 1e5 + 1;
int fac[maxn], rfac[maxn];

int bp(int a, int n) {
    int res = 1;
    while (n) {
        if (n & 1) n--, res = res * a % mod;
        else n /= 2, a = a * a % mod;
    }
    return res;
}

int C(int k, int n) {
    return fac[n] * rfac[k] % mod * rfac[n - k] % mod;
}

void solve() {
    fac[0] = 1;
    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        fac[i] = fac[i - 1] * i % mod;
    }
    rfac[n] = bp(fac[n], mod - 2);
    for (int i = n - 1; i >= 0; --i) {
        rfac[i] = rfac[i + 1] * (i + 1) % mod;
    }
    rfac[0] = 1;
    vector<int> a(n), c(3);
    for (int &x: a)cin >> x, c[x % 3]++;
    if (abs(c[1] - c[2]) > 2) {
        cout << 0;
        return;
    }
    if (c[1] == c[2]) {
        cout << 0;
        return;
    }
    int sum = c[0] + c[1] + c[2] - 1;
    int ans = C(c[0], sum) * fac[c[1]] % mod * fac[c[2]] % mod * fac[c[0]] % mod;
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
        cout << '\n';
    }
}