#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using vl = vector <ll>;

const ll inf = 2e18;
const ll mod = 1e9 + 7;

ll pw(ll x, ll st) {
    if (st == 0) {
        return 1;
    }
    if (st == 1) {
        return x;
    }
    ll t = pw(x, st / 2);
    if (st % 2) {
        return t * t % mod * x % mod;
    }
    return t * t % mod;
}

void solve() {
    ll maxn = 5015;
    vl f(maxn, 1);
    for (ll i = 2; i < maxn; i++) {
        f[i] = f[i - 1] * i;
        f[i] %= mod;
    }
    ll n;
    cin >> n;
    vl dp(n + 1, 1);
    for (ll i = 2; i < n; i++) {
        ll s = 0;
        ll t0 = 0, t1 = i - 1, t2 = 1;
        while (t1 >= 0) {
            ll ts = f[i];
            ts *= pw(f[t0], mod - 2);
            ts %= mod;
            ts *= pw(f[t1], mod - 2);
            ts %= mod;
            ts *= pw(f[t2], mod - 2);
            ts %= mod;
            s += ts;
            s %= mod;
            t1 -= 2;
            t0++;
            t2++;
        }
        dp[i + 1] = dp[i] * s % mod;
    }
    cout << dp[n];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
