#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define nl endl
#else
#define nl '\n'
#pragma GCC optimize("Ofast")
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define forn(i, n) for (decltype(n) i = 0; i < n; i++)
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define ll long long
#define ull unsigned long long
#define ld long double
#define _ <<" "<<

template <typename T> using ordered_set = trie<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

void solve(){
    string s;
    cin >> s;
    map<char,int> cnt;
    map<char,int> broken;
    for(char c : s) cnt[c]++;
    int n;
    cin >> n;
    forn(i, n) {
        char c;
        int x;
        cin >> c >> x;
        broken[c] = x;
    }

    ll tmp = 0;
    for (auto &[c, x] : broken) {
        tmp += cnt[c] / (x - 1) + !!(cnt[c] % (x - 1));
    }
    cout << tmp + s.size() << nl;
}

signed main(){
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cout << fixed << setprecision(15);

    int tt = 1;
//    cin >> tt;
    while(tt--) solve();
}

