#include <bits/stdc++.h>
using namespace std;
#define int long long
#define ll long long
#define all(x) x.begin(), x.end()
#define eb emplace_back
#define pb push_back

bool check(vector<vector<int>> &a, int n) {
    vector<int> sum1(n), sum2(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            sum1[i] += a[i][j];
            sum2[j] += a[i][j];
        }
    }
    sort(all(sum1));
    sort(all(sum2));
    return sum1.front() == sum1.back() && sum2.front() == sum2.back() && sum1.front() == sum2.front();
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int> (n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
        }
    }
    if (n == 3) {
        for (int i = 0; i < n * n; i++) {
            for (int j = i + 1; j < n * n; j++) {
                swap(a[i / n][i % n], a[j / n][j % n]);
                if (check(a, n)) {
                    cout << i / n + 1 << " " << i % n + 1 << endl;
                    cout << j / n + 1 << " " << j % n + 1 << endl;
                    return;
                }
                swap(a[i / n][i % n], a[j / n][j % n]);
            }
        }
        return;
    }
    vector<int> sum1(n), sum2(n);
    for (int i = 0; i < n; i++)  {
        for (int j = 0; j < n; j++) {
            sum1[i] += a[i][j];
            sum2[j] += a[i][j];
        }
    }
    map<int, int> cnt;
    for (int i = 0; i < n; i++) {
        cnt[sum1[i]]++;
        cnt[sum2[i]]++;
    }
    int res = -1;
    for (auto [key, val] : cnt) {
        if (val > cnt[res])
            res = key;
    }
    int x1 = -1, y1 = -1, x2 = -1, y2 = -1;
    for (int i = 0; i < n; i++) {
        if (sum1[i] != res && x1 == -1)
            x1 = i;
        else if (sum1[i] != res)
            x2 = i;
    }
    if (x1 == -1)
        x1 = 0;
    if (x2 == -1)
        x2 = x1;
    for (int i = 0; i < n; i++) {
        if (sum2[i] != res && y1 == -1)
            y1 = i;
        else if (sum2[i] != res)
            y2 = i;
    }
    if (y1 == -1)
        y1 = 0;
    if (y2 == -1)
        y2 = y1;
    swap(a[x1][y1], a[x2][y2]);
    if (!check(a, n))
        swap(x1, x2);
    cout << x1 + 1 << " " << y1 + 1 << endl;
    cout << x2 + 1 << " " << y2 + 1 << endl;
}

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(0);
    int T = 1;
    //cin >> T;
    while (T--)
        solve();
    return 0;
}
