#include <iostream>
#include <string>
#include <vector>
#include <stdlib.h>
#include <cmath>
#include <map>

const int none = 1000;

std::map<std::pair<int, int>, bool> used;

int mx(int a, int b)
{
	return a > b ? a : b;
}

int m(std::vector<std::vector<int>>& a)
{
	int max = 0;
	for (auto i : a)
		for (auto j : i)
			max = mx(max, j);
	return max;

}

int main()
{
	std::vector<std::vector<int>> count(2, std::vector<int>(2, 0));

	int size;
	std::cin >> size;
	while (size--)
	{
		int a, b;
		std::cin >> a >> b;
		if (used[{a, b}])
		{
			std::cout << m(count) << '\n';
			continue;
		}
		used[{a, b}] = true;
		count[a % 2][b % 2]++;
		std::cout << m(count) << '\n';
	}

	return 0;
}