#include<bits/stdc++.h>

#define ll long long
#define vec vector
#define fir first
#define sec second
#define pb push_back
#define int long long
#define sz(x) (ll)x.size()
#define all(x) x.begin(),x.end()
#define ld long double
using namespace std;

using pii = pair < int, int >;
using pll = pair < ll, ll >;

const int N = 2e5 + 2;
const int mod = 1e9 + 7;

struct st {
    int n;
    vec < int > seg;
    st (int n = 0) : n(n), seg(4 * n) { }
    void Set (int v, int l, int r, int i, int x) {
        if (l == r) {
            seg[v] = x;
            return;
        }
        int m = l + r >> 1;
        if (i <= m)
            Set(v << 1, l, m, i, x);
        else
            Set(v << 1 ^ 1, m + 1, r, i, x);
        seg[v] = max(seg[v << 1], seg[v << 1 | 1]);
    }
    int gt (int v, int l, int r, int ql, int qr) {
        if (l > qr || r < ql)
            return 0;
        if (l >= ql && r <= qr)
            return seg[v];
        int m = l + r >> 1;
        return max(gt(v << 1, l, m, ql, qr),
                    gt(v << 1 ^ 1, m + 1, r, ql, qr));
    }
    int gt (int l, int r) {
        return gt(1, 0, n - 1, l, r);
    }
    void Set (int i, int x) {
        Set(1, 0, n - 1, i, x);
    }
};

vec < int > g[N];
int pa[N];
int dp[N];
int lf[N];
int tin[N], tout[N];
int timer = -1;

vec < st > segs;
vec < int > d[N];

void dfs (int v, int gl) {
    d[gl].pb(tin[v]);
    tin[v] = ++timer;
    for (int i : g[v]) {
        if (i == pa[v]) continue;
        if (!lf[v]) lf[v] = N + 10;
        dfs(i, gl + 1);
        lf[v] = min(lf[v], lf[i] + 1);
    }
    tout[v] = timer;
}

void dfs1 (int v, int gl) {
    if (v != 1 && sz(g[v]) == 1) {
        dp[v] = 0;
        int ps = lower_bound(all(d[gl]), tin[v]) - d[gl].begin();
        segs[gl].Set(ps, dp[v]);
        return;
    }
    for (int i : g[v]) {
        if (i == pa[v]) continue;
        dfs1(i, gl + 1);
        dp[v] = max(dp[v], dp[i]);
    }
    int dst = lf[v];
    int nw = gl + dst;
    int le = lower_bound(all(d[nw]), tin[v]) - d[nw].begin();
    int ri = --upper_bound(all(d[nw]), tout[v]) - d[nw].begin();
    int cur = segs[nw].gt(le, ri);
    dp[v] = max(dp[v], cur + 1);
    int ps = lower_bound(all(d[gl]), tin[v]) - d[gl].begin();
    segs[gl].Set(ps, dp[v]);
}

int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 2, p; i <= n; ++i) {
        cin >> p;g[p].pb(i);g[i].pb(p);pa[i] = p;
    }
    dfs(1, 0);
    segs.resize(n);
    for (int i = 0; i < n; ++i) {
        segs[i] = st(sz(d[i]));
    }
    dfs1(1, 0);
//    for (int i = 1; i <= 3; ++i)
//        cout << i << " " << dp[i] << "\n";
    cout << dp[1];
}
