#include <bits/stdc++.h>

#define ll long long

using namespace std;

const ll mod = 1e9 + 7;

ll fact(int x) {
    ll res = 1;
    for(ll i=1;i<=x;i++)
        res = (res * i) % mod;
    return res;
}

ll bin_pow(ll a, ll n) {
    ll res = 1;
    while(n) {
        if (n & 1) res = (res * a) % mod;
        a = (a * a) % mod;
        n >>= 1;
    }
    return res;
}

ll cnk(ll n, ll k) {
    if (k > n) return 0;
    ll z = (fact(k) * fact(n - k)) % mod;
    ll c = (fact(n) * bin_pow(z, mod - 2)) % mod;
    return c;
}

int main()
{

    int n;
    cin >> n;
    vector<int> a(n);
    for(int i=0;i<n;i++)
        cin >> a[i];

    ll A = 0, B = 0, C = 0;

    for(int i=0;i<n;i++) {
        if (a[i] % 3 == 0) C++;
        if (a[i] % 3 == 1) A++;
        if (a[i] % 3 == 2) B++;
    }

    ll ans = 1;

    ans = (fact(A) * fact(B)) % mod;

    if (A > 2 && B == 0) {
        cout << 0 << endl;
        return 0;
    }
    if (B > 2 && A == 0) {
        cout << 0 << endl;
        return 0;
    }
    if (A == 1 && B == 1) {
        cout << 0 << endl;
        return 0;
    }
    if (A == 0 && B == 0 && C != 0) {
        cout << 0 << endl;
        return 0;
    }

    if (A >= 2 && B >= 2) ans = (ans * 2) % mod;

    ans = (ans * cnk(A + B, C)) % mod;

    cout << ans << endl;

    return 0;
}
