#include <bits/stdc++.h>
using namespace std;

vector < vector <int> > g(2e5);
vector <int> dp(2e5), far_child(2e5, 1e9), used(2e5);

void dfs1(int v) {
    if (g[v].size() == 0) {
        far_child[v] = 0;
        return;
    }
    for (int u : g[v]) {
        dfs1(u);
        far_child[v] = min(far_child[v], far_child[u]);
    }
    far_child[v]++;
}

int dfs2(int v, int deep) {
    if (deep == 0) {
        if (g[v].size() == 0) return 0;
        for (int u : g[v]) {
            dp[v] = max(dp[v], dfs2(u, far_child[v] - 1));
        }
        dp[v]++;
        return dp[v];
    }
    for (int u : g[v]) dp[v] = max(dp[v], dfs2(u, deep - 1));
    return dp[v];
}

int main() {
    int n, v;
    cin >> n;
    if (n == 1) {
        cout << 1 << '\n';
        return 0;
    }
    for (int i = 1; i < n; i++) {
        cin >> v;
        g[v - 1].push_back(i);
    }
    dfs1(0);
    cout << dfs2(0, 0) << endl;
}

