#include <bits/stdc++.h>
using namespace std;

#define int long long
#define sz(a) ((int) (a).size())
const int M = 1e9 + 7;
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<int> fact(n + 5), inv(n + 5);
    fact[0] = 1;
    for (int i = 1; i < sz(fact); ++i) {
        fact[i] = (fact[i - 1] * i) % M;
    }
    auto bin_pow = [&](auto bin_pow, int x, int pw) -> int {
        if (pw == 0)
            return 1;
        if (pw & 1)
            return (bin_pow(bin_pow, x, pw - 1) * x) % M;
        return bin_pow(bin_pow, (x * x) % M, pw / 2);
    };
    inv[n + 4] = bin_pow(bin_pow, fact[n + 4], M - 2);
    for (int i = sz(inv) - 2; i >= 0; --i) {
        inv[i] = (inv[i + 1] * (i + 1)) % M;
    }
    auto cnk = [&](int N, int K) -> int {
//        cout << N << " " << K << '\n';
        return (((fact[N] * inv[K]) % M) * inv[N - K]) % M;
    };
    int res = 1;
    for (int lay = 3; lay <= n; ++lay) {
        int cur_lay = 0;
        for (int i = 0; i < lay; ++i) {
            if ((lay - i) & 1)
                continue;
            int two = (lay - i) / 2;
            int left = lay - 1 - two - i;
            cur_lay += (cnk(lay - 1, two) * cnk(lay - 1 - two, i)) % M;
            cur_lay %= M;
        }
        res *= cur_lay;
        res %= M;
    }

    cout << res << '\n';
    return 0;
}

