#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using dl = double long;
using ull = unsigned long long;

ll fact[100100];
const ll MOD = 1e9 + 7;
int qab[3];

ll mpow(ll a, int b){
    if(b == 1) return a;
    if((b & 1) == 1){
        return (mpow(a, b - 1) * a) % MOD;
    }
    ll ext = mpow(a, b >> 1);
    return (ext * ext) % MOD;
}

void solve(){

    fact[0] = 1;
    for(int i= 1; i < 100100; ++i) fact[i] = (fact[i - 1] * i) % MOD;

    int qe, ab;
    cin >> qe;
    for(int i = 1; i <= qe; ++i){
        cin >> ab;
        ++qab[ab % 3];
    }
    if(qab[1] == qab[2] || qab[1] > qab[2] + 2 || qab[2] > qab[1] + 2){
        cout << "0\n";
        return;
    }

    cout << (((((((fact[qab[1]] * fact[qab[2]]) % MOD) * fact[qab[0]]) % MOD) * fact[qe - 1]) % MOD) * mpow(qe - qab[0] - 1, MOD - 2)) % MOD << '\n';

}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
