#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define int long long

int n;
bool checkMag(vector<vector<int>> a) {
    set<int> s;
    for (int i = 0; i < n; i++) {
        int sm = 0;
        for (int j = 0; j < n; j++) sm += a[i][j];
        s.insert(sm);
    }
    if (s.size() > 1) return false;

    s.clear();
    for (int j = 0; j < n; j++) {
        int sm = 0;
        for (int i = 0; i < n; i++) {
            sm += a[i][j];
        }
        s.insert(sm);
    }
    if (s.size() > 1) return false;
    return true;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    vector<vector<int>> a(n, vector<int> (n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
        }
    }

    if (n <= 5) {
        for (int i1 = 0; i1 < n; i1++) {
            for (int j1 = 0; j1 < n; j1++) {
                for (int i2 = i1; i2 < n; i2++) {
                    for (int j2 = j1 + 1; j2 < n; j2++) {
                        swap(a[i1][j1], a[i2][j2]);
                        if (checkMag(a)) {
                                cout << i1 + 1 << " " << j1 + 1 << '\n' << i2 + 1 << " " << j2 + 1;
                                return 0;
                        }
                        swap(a[i1][j1], a[i2][j2]);
                    }
                }
            }
        }
    } else {
        map<int, int> cntg, indg;
        for (int i = 0; i < n; i++) {
            int sm = 0;
            for (int j = 0; j < n; j++) {
                sm += a[i][j];
            }
            cntg[sm]++;
            indg[sm] = i;
        }
        map<int, int> cnts, inds;
        for (int j = 0; j < n; j++) {
            int sm = 0;
            for (int i = 0; i < n; i++) {
                sm += a[i][j];
            }
            cnts[sm]++;
            inds[sm] = j;
        }

        if (cntg.size() == 1) {
            vector<int> d;
            for (auto x : cnts) {
                if (cnts[x.first] == 1) d.push_back(inds[x.first]);
            }
            int sm0 = 0, sm1 = 0;
            for (int i = 0; i < n; i++) {
                sm0 += a[i][d[0]];
                sm1 += a[i][d[1]];
            }

            int smNeed = cntg.begin()->first;
            for (int i = 0; i < n; i++) {
                sm0 -= a[i][d[0]];
                sm0 += a[i][d[1]];
                sm1 -= a[i][d[1]];
                sm1 += a[i][d[0]];
                if (sm0 == sm1 && sm0 == smNeed) {
                    cout << i + 1 << " " << d[0] + 1 << '\n' << i + 1 << " " << d[1] + 1;
                    return 0;
                }
                sm0 += a[i][d[0]];
                sm0 -= a[i][d[1]];
                sm1 += a[i][d[1]];
                sm1 -= a[i][d[0]];
            }
        } else if (cnts.size() == 1) {
            vector<int> d;
            for (auto x : cntg) {
                if (cntg[x.first] == 1) d.push_back(indg[x.first]);
            }
            int sm0 = 0, sm1 = 0;
            for (int i = 0; i < n; i++) {
                sm0 += a[d[0]][i];
                sm1 += a[d[1]][i];
            }

            int smNeed = cnts.begin()->first;
            for (int i = 0; i < n; i++) {
                sm0 -= a[d[0]][i];
                sm0 += a[d[1]][i];
                sm1 -= a[d[1]][i];
                sm1 += a[d[0]][i];
                if (sm0 == sm1 && sm0 == smNeed) {
                    cout << d[0] + 1 << " " << i + 1 << '\n' << d[1] + 1 << " " << i + 1;
                    return 0;
                }
                sm0 += a[d[0]][i];
                sm0 -= a[d[1]][i];
                sm1 += a[d[1]][i];
                sm1 -= a[d[0]][i];
            }
        } else {
            vector<int> d1, d2;
            for (auto x : cnts) {
                if (cnts[x.first] == 1) d1.push_back(inds[x.first]);
            }
            for (auto x : cntg) {
                if (cntg[x.first] == 1) d2.push_back(indg[x.first]);
            }

            swap(a[d2[0]][d1[0]], a[d2[1]][d1[1]]);
            if (checkMag(a)) {
                cout << d2[0] + 1 << " " << d1[0] + 1 << '\n' << d2[1] + 1 << " " << d1[1] + 1;
                return 0;
            } else {
                cout << d2[0] + 1 << " " << d1[1] + 1 << '\n' << d2[1] + 1 << " " << d1[0] + 1;
            }
        }
    }
}
