#include <bits/stdc++.h>

#define int long long
#define f first
#define s second
#define sz(x) (int)x.size()
#define pb push_back

using namespace std;

using pii = pair <int, int>;

const int N = 1337;
int a[N][N];
int n;

int find_sm() {
    int res = 0, mx = 0;
    vector <int> sm(N * N);
    for (int i = 0; i < n; i++) {
        int smn = 0;
        for (int j = 0; j < n; j++)
            smn += a[i][j];

        if (++sm[smn] > mx) {
            swap(smn, mx);
        }
    }

    for (int j = 0; j < n; j++) {
        int smn = 0;
        for (int i = 0; i < n; i++)
            smn += a[i][j];

        if (++sm[smn] > mx) {
            swap(smn, mx);
        }
    }

    return res;
}

bool can() {
    set <int> st;
    for (int i = 0; i < n; i++) {
        int smn = 0;
        for (int j = 0; j < n; j++)
            smn += a[i][j];

        st.insert(smn);
        if (sz(st) > 1)
            return false;
    }

    for (int j = 0; j < n; j++) {
        int smn = 0;
        for (int i = 0; i < n; i++)
            smn += a[i][j];

        st.insert(smn);
        if (sz(st) > 1)
            return false;
    }

    return true;
}

int32_t main() {
    cin >> n;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            cin >> a[i][j];

    if (can()) {
        cout << "1 1\n 1 1";
        return 0;
    }

    vector <pii> ps;
    if (n <= 9) {
        for (int i = 0; i < n; i++)
            for (int j = 0; j < n; j++)
                ps.pb({i, j});
    } else {
        int sm = find_sm();
        for (int i = 0; i < n; i++) {
            int smn = 0;
            for (int j = 0; j < n; j++)
                smn += a[i][j];

            if (smn == sm)
                continue;

            for (int j = 0; j < n; j++)
                ps.pb({i, j});
        }

        for (int j = 0; j < n; j++) {
            int smn = 0;
            for (int i = 0; i < n; i++)
                smn += a[i][j];

            if (smn == sm)
                continue;

            for (int i = 0; i < n; i++)
                ps.pb({i, j});
        }
    }

    for (auto& [i1, j1] : ps) {
        for (auto& [i2, j2] : ps) {
            swap(a[i1][j1], a[i2][j2]);
            if (can()) {
                cout << i1 + 1 << " " << j1 + 1 << "\n" << i2 + 1 << " " << j2 + 1;
                return 0;
            }
            swap(a[i1][j1], a[i2][j2]);
        }
    }
}
