#include <bits/stdc++.h>

using namespace std;

#define int long long
#define str string
#define ldb long double
#define ll long long
#define ull unsigned long long
#define ff first
#define ss second
#define all(v) v.begin(), v.end()

const int MOD = 1e9 + 7, MAXN = 1e6;

int f[MAXN];

int binpow(int a, int n) {
    if (n == 0) {
        return 1;
    }
    if (n % 2) {
        return a * binpow(a, n - 1) % MOD;
    }
    int ans = binpow(a, n / 2);
    return ans * ans % MOD;
}

int c(int n, int k) {
    return f[n] * binpow(f[k], MOD - 2) % MOD * binpow(f[n - k], MOD - 2) % MOD;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    f[0] = 1;
    for (int i = 1; i < MAXN; ++i) {
        f[i] = f[i - 1] * i % MOD;
    }
    int n, cnt0 = 0, cnt1 = 0, cnt2 = 0;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        if (x % 3 == 0) {
            cnt0++;
        } else if (x % 3 == 1) {
            cnt1++;
        } else {
            cnt2++;
        }
    }
    if (cnt1 == cnt2 || abs(cnt1 - cnt2) > 2) {
        cout << 0 << '\n';
    } else {
        cout << f[cnt1] * f[cnt2] % MOD * f[cnt0] % MOD * c(n - 1, cnt1 + cnt2 - 1) % MOD << '\n';
    }
    return 0;
}