#pragma GCC optimize("O3")
#include<bits/stdc++.h>
#define ft first
#define sc second
#define all(x) x.begin(),x.end()
using namespace std;
using ll = long long;
using ld = long double;
struct vect{
    ll x, y;
    vect(ll x_ = 0, ll y_ = 0) {x = x_; y= y_;}
};
vect operator - (vect a, vect b) {
    return vect(a.x-b.x, a.y-b.y);
}
ll operator ^ (vect a, vect b) {
    return a.x*b.y-a.y*b.x;
}
ll operator * (vect a, vect b) {
    return a.x*b.x+a.y*b.y;
}
vector<vector<pair<int, int>>> rebra;
const ld pi = acos(-1);
ld ang(vect l, vect r) {
    ld a = atan2(l^r, l*r);
    return (a >= 0 ? a : 2*pi+a);
}
vector<vector<int>> rebra2;

int timer = 1;
vector <int> mt, t;

bool kuhn (int i) {
    if (t[i] == timer) return false;
    t[i] = timer;
    for (auto j : rebra2[i]) {
        if (mt[j] == -1 || kuhn(mt[j])) {
            mt[j] = i;
            return true;
        }
    }
    return false;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, u, v;
    cin >> n;
    vector<vect> a(n);
    for (int i = 0; i < n; i++) cin >> a[i].x >> a[i].y;
    rebra.resize(n);
    map<pair<int, int>, int> num;
    for (int i = 0; i < n-1; i++) {
        cin >> u >> v; u--; v--;
        num[{u, v}] = 2*i;
        num[{v, u}] = 2*i+1;
        rebra[u].push_back({v, i});
        rebra[v].push_back({u, i});
    }
    rebra2.resize(2*(n-1));
    for (int i = 0; i < n; i++) {
        if (rebra[i].size() == 1) continue;
        if (rebra[i].size() == 2) {
            rebra2[num[{rebra[i][0].ft, i}]].push_back(num[{i, rebra[i][1].ft}]);
            rebra2[num[{rebra[i][1].ft, i}]].push_back(num[{i, rebra[i][0].ft}]);
            continue;
        }
        vect x = a[rebra[i][0].ft];
        sort(all(rebra[i]), [&](pair<int, int> a2, pair<int, int> b2)->bool{return ang(x-a[i], a[a2.ft]-a[i]) < ang(x-a[i], a[b2.ft]-a[i]);});
        int n2 = rebra[i].size();
        for (int tt = 0; tt < rebra[i].size(); tt++) {
            auto [j, ind] = rebra[i][tt];
            vect x2 = vect(2*a[i].x-a[j].x, 2*a[i].y-a[j].y);
            int y = lower_bound(all(rebra[i]), ang(x-a[i], x2), [&](pair<int, int> a2, ld z)->bool{return ang(x-a[i], a[a2.ft]-a[i]) < z;})-rebra[i].begin();
            //cout << j << " " << y << " " << ang(x-a[i], x2) << "\n";
            if (y != n2 && ang(x-a[i], x2) == ang(x-a[i], a[rebra[i][y].ft]-a[i])) {
                rebra2[num[{j, i}]].push_back(2*(n-1)+num[{i, rebra[i][y].ft}]);
//                cout << j << " "<< i << " " << rebra[i][y].ft << "!" << endl;
                continue;
            }
            y--;
            if (ang(a[rebra[i][(tt-1+n2)%n2].ft]-a[i], a[j]-a[i]) > ang(a[rebra[i][y].ft]-a[i], x2)) {
                rebra2[num[{j, i}]].push_back(2*(n-1)+num[{i, rebra[i][y].ft}]);
//                cout << j << " "<< i << " " << rebra[i][y].ft << endl;
            }
            if (ang(a[j]-a[i], a[rebra[i][(tt+1)%n2].ft]-a[i]) > ang(x2, a[rebra[i][(y+1)%n2].ft]-a[i])) {
                rebra2[num[{j, i}]].push_back(2*(n-1)+num[{i, rebra[i][(y+1)%n2].ft}]);
                // cout << j << " "<< i << " " << rebra[i][(y+1)%n2].ft << endl;
            }
        }
    }
    // return 0;
    mt.assign(4 * (n - 1), -1);
    t.assign(4 * (n - 1), 0);
    for (int i = 0; i < 2 * (n - 1); ++i) {
        shuffle(all(rebra2[i]), default_random_engine(28 * i));
        if (kuhn(i)) ++timer;
    }
    int M = (2 * (n - 1) - (int)count(all(mt), -1)) / 2;
    cout << n - 1 - M << endl;
}
