#include <bits/stdc++.h>
using namespace std;
#define int int64_t
const int inf = 1e18, M = 1e9 + 7;
int facs[6000];


int binpow(int x, int n) {
    if (n == 0) return 1;
    if (n & 1) return x * binpow(x, n - 1) % M;
    int tmp = binpow(x, n / 2);
    return tmp * tmp % M;
}

int C(int n, int k) {
    return facs[n] * binpow(facs[n - k], M - 2) % M * binpow(facs[k], M - 2) % M;
}

signed main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    facs[0] = 1;
    for (int i = 1; i < 6000; ++i) facs[i] = facs[i - 1] * i % M;
    int n;
    cin >> n;
    if (n == 1) {
        cout << "1\n";
        return 0;
    }
    vector<vector<int>> dp(n + 1, vector<int> (n + 1));
    dp[0][0] = 1;
    for (int i = 1; i < n + 1; ++i) {
        for (int j = 1; j < n + 1; ++j) {
            dp[i][j] = dp[i - 1][j - 1];
            if (i -2 >= 0) dp[i][j] += dp[i - 2][j - 1];
            dp[i][j] %= M;
        }
    }
    vector<int> dpA(n + 1);
    dpA[1] = 1;
    for (int l = 2; l < n; ++l) {
        int cur = 0;
        for (int i = 1; i <= l; ++i) {
            cur += dp[l + 1][i] * C(l, i);
            cur %= M;
        }
        dpA[l] = dpA[l - 1] * cur % M;
    }
    cout << dpA[n - 1] % M;
    return 0;
}