#include <bits/stdc++.h>
using namespace std;
#define int long long
typedef long long ll;
typedef vector<int> vi;
const int mod = 1e9 + 7;

struct node {
    int l = 0, r = 0; // кол-во ашек слево, колво ашек справа
    int sum = 0; // a sum
};

struct seg_tree {
    vector<node> tree;
    int size = 1;
    void init(int n, string &s) {
        while (size <= n) {
            size *= 2;
        }

        tree.resize(size * 2 - 1);
        for (int i = size - 1; i < size * 2 - 1; i++) {
            if (s[i - size + 1] == 'a') {
                tree[i].l = 1;
                tree[i].r = 1;
                tree[i].sum = 1;
            }
        }
    }

    node merge(node a, node b, int len) {
        // ...
        return a;
    }

    void build(int v, int l, int r) {
        if (l == r) return;
        int mid = (l + r) / 2;
        build(v * 2 + 1, l, mid);
        build(v * 2 + 2, mid + 1, r);
        tree[v] = merge(tree[v * 2 + 1], tree[v * 2 + 2], r - mid);
    }

    void update(int ind, int v, int l, int r) {
        if (l == r) {
            if (tree[v].sum) {
                tree[v].l = 0;
                tree[v].r = 0;
                tree[v].sum = 0;
            } else {
                tree[v].l = 1;
                tree[v].r = 1;
                tree[v].sum = 1;
            }
            return;
        }

        int mid = (l + r) / 2;
        if (ind <= mid) {
            update(ind, v * 2 + 1, l, mid);
        } else {
            update(ind, v * 2 + 2, mid + 1, r);
        }
    }

};

void run_case(){
     ll n;
     cin >> n;
     set<pair<ll, ll>> had;
     vector<ll> ans_vert(2, 0);
     vector<ll> ans_hor(2, 0);
     vector<map<ll, ll>> vert(2);
     vector<map<ll, ll>> hor(2);
     for (int i = 0; i < n; i++){
         ll x, y;
         cin >> x>> y;
         ll t = 1;
         if (had.find({x, y}) != had.end()){
             t = -1;
             had.erase({x, y});
         }
         else{
             had.insert({x, y});
         }
         ans_vert[x % 2] -= max(vert[y % 2][x], vert[!(y % 2)][x]);
         ans_hor[y % 2] -= max(hor[x % 2][y], hor[!(x % 2)][y]);
         vert[y % 2][x] += t;
         hor[x % 2][y] += t;
         ans_vert[x % 2] += max(vert[y % 2][x], vert[!(y % 2)][x]);
         ans_hor[y % 2] += max(hor[x % 2][y], hor[!(x % 2)][y]);
         ll maxim = 0;
         for (auto el : ans_vert){
             maxim = max(maxim, el);
         }
         for (auto el : ans_hor){
             maxim = max(maxim, el);
         }
         cout << maxim << "\n";
     }
}
//7
//1 1
//2 3
//3 3
//3 5
//4 5
//6 5
//4 7

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    //cin >> tt;
    while(tt--)run_case();
}
