#include "bits/stdc++.h"

using namespace std;

#define int long long
#define vec vector
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rend(), (a).rbegin()

template<typename t>
istream& operator>>(istream& in, vector<t>& v) {
    for (auto& u: v) in >> u;
    return in;
}

const int mod = 1'000'000'007;

void solve () {
    int n; cin >> n;
    vector<vector<int>> dpl(n + 1, vector<int>(n + 5, 0)), dpr(n + 1, vector<int>(n + 5, 0));
    for (int i = 0; i < n + 5; ++i) {
        dpl[0][i] = 1;
    }
    dpr[0][0] = 1;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= i; ++j) {
            dpr[i][j] = (dpr[i - j][j] + dpr[i - j][j - 1]) % mod;;
            dpl[i][j] = dpl[i - j][j];
        }
        for (int j = n - 1; j >= 1; --j) {
            dpl[i][j] = (dpl[i][j] + dpl[i][j + 1]) % mod;
        }
    }
    int ans = 0;
    for (int m = 1; m <= n + 1; ++m) {
        for (int left = 0; left <= n; ++left) {
            int right = n - left;
            int cntl = dpr[left][m - 1];
            int cntr = dpl[right][m + 1];
            ans = (ans + m * cntl % mod * cntr) % mod;
        }
    }
    cout << ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}