// solution.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include<vector>
#include <algorithm>
#include <cmath>

using namespace std;
using ll = long long;
using vi = vector<int>;

const ll mod = 1e9 + 7;
const ll N = 5005;
ll dp[N][N];

void solve() {
	ll n;
	cin >> n;
	for (ll i = 0; i <= n; ++i) {
		dp[i][0] = 1;
		dp[i][1] = i;
	}
	ll ans = 1;
	for (ll i = 1; i <= n; ++i) {
		for (ll j = 2; j <= min(2 * i, n); ++j) {
			for (ll p = 1; p <= i; ++p) {
				dp[i][j] = (dp[p - 1][j - 1] + dp[p - 1][j - 2] + dp[i][j]) % mod;
			}
		}
	}
	for (ll i = 2; i <= n; ++i)ans = (ans * dp[i - 1][i]) % mod;
	cout << ans << '\n';
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(false);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}

}