#include <bits/stdc++.h>

#define fi first
#define se second

#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

template < typename T >
bool umn(T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template < typename T >
bool umx(T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;

const int N = 5e5 + 5;
const int inf = 1e9;
const ll INF = 1e18;

ll a[1005][1005];
int n;

bool check () {
    ll last = -1;
    for (int i = 1; i <= n; ++ i) {
        ll sum = 0;
        for (int j = 1; j <= n; ++ j) sum += a[i][j];
        if (last == -1) last = sum;

        if (last != sum) return false;

        sum = 0;
        for (int j = 1; j <= n; ++ j) sum += a[j][i];
        if (last != sum) return false;
    }

    return true;
}

int main() {
#ifdef localy
    freopen ("input.txt", "r", stdin);
    freopen ("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    for (int i = 1; i <= n; ++ i) {
        for (int j = 1; j <= n; ++ j) {
            cin >> a[i][j];
        }
    }

    map < ll , ll > mp;

    for (int i = 1; i <= n; ++ i) {
        ll sum = 0;
        for (int j = 1; j <= n; ++ j) {
            sum += a[i][j];
        }

        ++ mp[sum];

        sum = 0;

        for (int j = 1; j <= n; ++ j) {
            sum += a[j][i];
        }

        ++ mp[sum];
    }

    ll s = 0;
    ll mx = 0;


    for (auto& it : mp) {
        umx (mx, it.se);
    }


    vector < int > vi;
    vector < int > vj;

    for (auto& it : mp) {
        if (it.se == mx) {
            vi.clear();
            vj.clear();
            s = it.fi;
            for (int i = 1; i <= n; ++ i) {
                ll sum = 0;
                for (int j = 1; j <= n; ++ j) {
                    sum += a[i][j];
                }

                if (sum != s) vi.pb (i);

                sum = 0;
                for (int j = 1; j <= n; ++ j) {
                    sum += a[j][i];
                }

                if (sum != s) vj.pb (i);
            }


            for (auto& x : vi) {
                for (auto& y : vj) {
                    for (auto& x1 : vi) {
                        for (auto& y1 : vj) {
                            swap (a[x][y], a[x1][y1]);


                            if (check ()) {
                                cout << x << " " << y << "\n" << x1 << " " << y1 << "\n";
                                return 0;
                            }

                            swap (a[x][y], a[x1][y1]);
                        }
                    }
                }
            }
        }
    }

    assert (0);



    return 0;
}
