#include <bits/stdc++.h>
using namespace std;
using ll  = long long;
using ld = long double;
const int INF = 1e9;

vector<vector<int>> g;
vector<pair<int, int>> dp;

void calcDfs(int v) {
    for (auto u : g[v]) {
        calcDfs(u);
        dp[v].second = min(dp[v].second, dp[u].second + 1);
        dp[v].first = max(dp[v].first, dp[u].first + 1);
    }

    if (g[v].empty()) {
        dp[v] = {0, 0};
    }
}

int ans = 0;
void dfs(int v, int cur, int red) {
    if (cur == 0){
        red++;
        ans = max(ans, red);
        cur = dp[v].second;
    }

    for (auto u : g[v]) {
        if (dp[v].first + 1 >= cur) dfs(u, cur - 1, red);
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;

    g.resize(n);
    dp.resize(n, {-1, INF});

    for (int i = 0; i < n - 1; ++i) {
        ll p;
        cin >> p;
        p--;
        g[p].push_back(i + 1);
    }

    calcDfs(0);
    dfs(0, 0, 0);

    cout << ans - 1 << '\n';

    return 0.42069;
}