#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> g;
vector<int> minD;

void dfsD(int v) {
    if(g[v].size() == 0) {
        minD[v] = 0;
        return;
    }
    for(auto t : g[v]) {
        dfsD(t);
        minD[v] = min(minD[v], minD[t] + 1);
    }
}

int dfs(int v, int ttn, int cur) {
    if(g[v].size() == 0) {
        return cur;
    }
    if(ttn == 0) {
        cur++;
        ttn = minD[v];
    }
    int ans = cur;
    for(auto t : g[v]) {
        ans = max(ans, dfs(t, ttn - 1, cur));
    }
    return ans;
}

int main() {
    int n;
    cin >> n;
    g.resize(n);
    minD.resize(n, INT32_MAX);
    for(int i = 1; i < n; i++) {
        int p;
        cin >> p;
        g[p - 1].push_back(i);
    }
    dfsD(0);
    cout << dfs(0, minD[0], 1) << '\n';
}
