#include <bits/stdc++.h>

using namespace std;
 
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);    
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int>(n, 0));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
        }
    }
    vector<int> sumInRow(n), sumInCol(n);
    vector<int> badRows, badCol;

    int sum = n * (n * n + 1) / 2;
 
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            sumInCol[i] += a[j][i];
            sumInRow[i] += a[i][j];
        }
        if (sumInRow[i] != sum) {
            badRows.push_back(i);
        }
        if (sumInCol[i] != sum) {
            badCol.push_back(i);
        }
    }
    if (badCol.size() == 2 && badRows.size() == 2) {
        int x1 = badRows[0], y1 = badCol[0], x2 = badRows[1], y2 = badCol[1];
        if (sumInRow[x1] - a[x1][y1] + a[x2][y2] == sum && sumInCol[y1] - a[x1][y1] + a[x2][y2] == sum &&
            sumInRow[x2] - a[x2][y2] + a[x1][y1] == sum && sumInCol[y2] - a[x2][y2] + a[x1][y1] == sum) {
            cout << x1 + 1 << " " << y1 + 1 << "\n" << x2 + 1 << " " << y2 + 1 << "\n";
        } else {
            cout << x1 + 1 << " " << y2 + 1 << "\n" << x2 + 1 << " " << y1 + 1 << "\n";
        }
        return 0;
    }
    if (badCol.size() == 2) {
        int y1 = badCol[0], y2 = badCol[1];
        for (int i = 0; i < n; i++) {
            if (sumInCol[y1] - a[i][y1] + a[i][y2] == sum) {
                cout << i + 1 << " " << y1 + 1 << "\n" << i + 1 << " " << y2 + 1 << "\n";
                return 0;
            }
        }
    }
    if (badRows.size() == 2) {
        int x1 = badRows[0], x2 = badRows[1];
        for (int i = 0; i < n; i++) {
            if (sumInRow[x1] - a[x1][i] + a[x2][i] == sum) {
                cout << x1 + 1 << " " << i + 1 << "\n" << x2 + 1 << " " << i + 1 << "\n";
                return 0;
            }
        }
    }
}
