#include <bits/stdc++.h>
#define pb push_back
#define int long long

using namespace std;

const int M = 1e9 + 7;

int n;
string s;
struct node{
    int l, r, sa, sb, mx;
};
node t[400005];
node un(node a, node b){
    node c;
    c.sa = a.sa + b.sa;
    c.sb = a.sb + b.sb;

    c.l = a.l + (!a.sa ? b.l : 0);
    c.r = b.r + (!b.sa ? a.r : 0);

    c.mx = max({a.mx, b.mx, c.l, c.r, a.r+b.l});
    return c;
}
void build(int v=1, int tl=1, int tr=n){
    if(tl == tr){
        if(s[tl] == 'b')t[v].l = t[v].r = t[v].sb = t[v].mx = 1;
        else t[v].sa = 1;
        return;
    }

    int tm = (tl+tr)/2;
    build(v+v, tl, tm);
    build(v+v+1, tm+1, tr);
    t[v] = un(t[v+v], t[v+v+1]);
}
void upd(int pos, int v=1, int tl=1, int tr=n){
    if(tl == tr){
        if(s[tl] == 'b')t[v].l = t[v].r = t[v].sb = t[v].mx = 1;
        else t[v].sa = 1;
        return;
    }
    int tm = (tl+tr)/2;
    if(pos <= tm)upd(pos, v+v, tl, tm);
    else upd(pos, v+v+1, tm+1, tr);
    t[v] = un(t[v+v], t[v+v+1]);
}
node get(int l, int r, int v=1, int tl=1, int tr=n){
    if(l <= tl && tr <= r)return t[v];
    if(tr < l || r < tl)return {0, 0, 0, 0, 0};
    int tm = (tl+tr)/2;
    return un(get(l, r, v+v, tl, tm), get(l, r, v+v+1, tm+1, tr));
}
signed main() {
   ios_base::sync_with_stdio(0);
   cin.tie(0);
   cout.tie(0);
   cin >> n >> s;
   s=' '+s;
   build();
   int q;
   cin >> q;
   while(q--){
    int tt;
    cin >> tt;
    if(tt == 1){
        int pos;
        cin >> pos;
        if(s[pos] == 'a')s[pos] = 'b';
        else s[pos] = 'a';
        upd(pos);
    }
    else{
        int l, r;
        cin >> l >> r;
        node x = get(l, r);
        if(x.mx > 2 || x.l > 1 || x.r > 1 || x.sa < x.sb)cout << "NO\n";
        else cout << "YES\n";
    }
   }

return 0;
}
