#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <queue>
#include <string>
#include <bitset>
#include <cstring>
#include <deque>
#define int long long
#define ll int
#define ld long double
#define ENDL cout << "\n";
#define SORT(a) sort(a.begin(), a.end());
#define REVERSE(a) reverse(a.begin(), a.end());
#define HAS(theset, num) ((theset.find(num)) != (theset.end()))




#define vc vector
#define SP " "

using namespace std;

const int MOD = 1e9+7;

vector<int> inv(5001), fact(5001);

int mod_pow(int b, int e) {
    int result = 1;
    while (e > 0) {
        if ( e % 2 == 1) {
            result = (result * b) % MOD;
        }
        b = (b * b) % MOD;
        e /= 2;
    }
    return result;
}

int mod_inverse(int a) {
    return mod_pow(a, MOD-2);
}

int mod_div(int a, int b) {
    return (a * mod_inverse(b)) % MOD;
}

int C(int n, int k) {
    // C = n!/(n-k)!k!
    if (n == k) return 1;
    if (k == 0) return 1;
    return (((fact[n] * (inv[k])) % MOD) * inv[n-k]) % MOD;
}

void pre() {
    fact[0] = 1;
    for (int i = 1; i < 5001; i++) {
        fact[i] = (fact[i-1]*i)%MOD;
        inv[i] = mod_inverse(fact[i]);
    }
}

void solve() {
    int n;
    cin >> n;

    int ans = 1;


    for (int i = 2; i <= n; i++) {
        int v = i / 2;
        int temp = 0;
        for (int j = 0; j < v; j++) {
            int num = (C(i-1, i-1-j) * C(i-1-j, j+1)) % MOD;
            temp += num;
        }
        ans *= temp;
    }

    cout << ans;
}
signed main() {
    pre();
    /*
    int t;
    cin >> t;
    while(t--) {solve();cout << endl;}
    /*/
    solve();
    //*/
}