#include <bits/stdc++.h>

#pragma GCC target ("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize ("ofast,unroll-loops,fast-math,03")

using namespace std;
#define int long long

const int N=1e6+7;
const int M=1e9+7;

int binpow(int a,int n) {
    if (!n)
        return 1;
    if ((n&1)==1)
        return (a * binpow(a,n-1))%M;
    int z= binpow(a,(n>>1));
    return (z*z)%M;
}

int n,f[N],inv[N];

void solve() {
    cin >> n;
    f[0]=1, inv[0]=1;
    for (int i=1;i<=n;i++)
        f[i]=(f[i-1]*i)%M, inv[i] = binpow(f[i],M-2);
    int ans=1;
    n--;
    for (int i=2;i<=n;i++) {
        int z = 0;
        for (int j = 1; 2 * j - 1 <= i; j++) {
            z+=f[i]*(((inv[j]*inv[j-1])%M*inv[i-j-j+1])%M);
            z %= M;
        }
        ans *= z;
        ans %= M;
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);cin.tie(0);
    solve();
    return 0;
}