#include <bits/stdc++.h>
using namespace std;


#define ll long long

const int N = 1e3 + 7;

int a[N][N];

ll rmn = INT_MAX, rmx = INT_MIN, cmn = INT_MAX, cmx = INT_MIN;
ll irmn = 1, irmx = 1, icmn = 1, icmx = 1;

void solve(){
    int n; cin >> n;
    vector<ll> col(n + 1), row(n + 1);
    ll sum = (1 + n*n) * n / 2;

    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= n; j++){
            cin >> a[i][j];
            row[i] += a[i][j];
        }
        if (row[irmn] >= row[i]) {
            rmn = row[i];
            irmn = i;
        }
        if (row[irmx] <= row[i]) {
            rmx = row[i];
            irmx = i;
        }

    }

    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= n; j++){
            col[i] += a[j][i];
        }
        if (col[icmn] >= col[i]) {
            cmn = col[i];
            icmn = i;
        }
        if (col[icmx] <= col[i]) {
            cmx = col[i];
            icmx = i;
        }
    }

    //cout << "!!" << rmx << " " << rmn << " " << cmx << " " << cmn << endl;

    if (rmn != rmx and cmn != cmx) {
        cout << irmn << " " << icmn << endl << irmx << " " << icmx;
        return;
    }


    if (rmx != rmn) {
        int x = irmx, y = irmn, k = (rmx - rmn) / 2;

        for (int i = 1; i <= n; ++i) {
            if (a[x][i] - a[y][i] == k) {
                cout << x << " " << i << endl << y << " " << i;
                return;
            }
        }
    } else {
        int x = icmx, y = icmn, k = (cmx - cmn) / 2;

        for (int i = 1; i <= n; ++i) {
            if (a[i][x] - a[i][y] == k) {
                cout << i << " " << x << endl << i << " " << y;
                return;
            }
        }
    }
}

int main(){
    ios_base:sync_with_stdio(0); cin.tie(0); cout.tie(0);
    solve();
    return 0;
}
