#ifdef ONLINE_JUDGE
#pragma GCC optimize("Ofast,no-stack-p0rotector,unrol-loops,fast-math,O3")
#pragma GCC target("sse,see2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#endif
#include <bits/stdc++.h>
#define speed ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define precision cout.precision(30);cerr.precision(10);
#ifdef ONLINE_JUDGE
#define debug(x) cerr << x << "<---"<<#x<<'\n'
#else
#define debug(x)
#endif
#define ll long long
#define ld long double
#define sz(x) (int)x.size()
#define mp(x,y) make_pair(x,y)
#define all(x) x.begin(), x.end()
#define pc(x) __builtin_popcount(x)
#define pcll(x) __builtin_popcountll(x)
#define F first
#define S second
using namespace std;
const int N = 5e5 + 5;
const int inf = 1e9 + 7;

int triArea2(int x1, int y1, int x2, int y2, int x3, int y3){
    return (x2-x1)*(y3-y1)-(y2-y1)*(x3-x1);
}

ll a[4], cost[4];

ll getCost(int weight)
{
  if (weight < 5)
      return cost[1];
  else if (weight < 10)
      return cost[2];
  else
      return cost[3];
}

inline static void solve(){
    for (int i = 1; i <= 3; i++)
    {
        cin >> a[i];
    }

    for (int i = 1; i <= 3; i++)
    {
        cin >> cost[i];
    }

    ll sum = a[1] + a[2] + a[3];
    ll res = getCost(sum);

    for (int i = 1; i <= 3; i++)
    {
        res = min(res, getCost(sum - a[i]) + getCost(a[i]));
    }

    res = min(res,
                  getCost(a[1])+
                  getCost(a[2])+
                  getCost(a[3])
              );

    cout << res << '\n';
}

int32_t main(){
    speed;
    //precision(3);
    int T = 1;
    srand(time(0));
    //cin >> T;
    while(T--){
        solve();
    }
    return 0;
}

