#include <bits/stdc++.h>
using namespace std;

#define int long long

const int MOD = 1e+9 + 7;

int BinPow(int x, int n) {
    if (n == 0)
        return 1;

    if (n & 1)
        return BinPow(x, n - 1) * x % MOD;

    return BinPow(x * x % MOD, n / 2);
}

int32_t main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int n; cin >> n;

    vector < int > a(n);

    for (int i = 0; i < n; i++)
        cin >> a[i], a[i] %= 3;

    vector < int > cnt(3);

    for (int i = 0; i < n; i++)
        cnt[a[i]]++;

    if (cnt[1] == cnt[2]) {
        cout << "0\n";
        return 0;
    }

    int diff = abs(cnt[1] - cnt[2]);

    if (diff > 2) {
        cout << "0\n";
        return 0;
    }

    vector < int > fact(n + 1);
    fact[0] = 1;

    for (int i = 1; i <= n; i++)
        fact[i] = fact[i - 1] * i % MOD;

    vector < int > factInv(n + 1);
    factInv[0] = 1;

    for (int i = 1; i <= n; i++)
        factInv[i] = factInv[i - 1] * BinPow(i, MOD - 2) % MOD;

    cout << fact[cnt[0]] * fact[cnt[1]] % MOD * fact[cnt[2]] % MOD * fact[n - 1] % MOD * factInv[cnt[0]] % MOD * factInv[n - 1 - cnt[0]] % MOD << "\n";
}
