#include <iostream>
#include <vector>
#include <algorithm>

typedef long long i64;

using namespace std;

i64 n;
vector<i64> v;
vector<vector<i64> > tree;
i64 leafMin = LLONG_MAX, leafMax = LLONG_MIN;

void dfs(i64 cur, i64 cnt) {
	if (tree[cur].size() == 0) {
		leafMax = max(leafMax, cnt);
		leafMin = min(leafMin, cnt);
		return;
	}
	for (i64 i : tree[cur])
		dfs(i, cnt + 1);
}

int main()
{
	cin >> n;
	v.resize(n);
	tree.resize(n);
	for (i64 child = 1; child < n; child++) {
		i64 parent; cin >> parent;
		tree[parent - 1].push_back(child);
	}
	dfs(0, 0);
	cout << leafMax / leafMin;
}