#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

using pii = pair<int, int>;
using ll = long long;
using ld = long double;

constexpr int mod = 1e9 + 7;
int a, b, c;

int check(int w) {
     int x;
     if (w < 5) {
          x = min(a, b);
          x = min(x, c);
     } else if (w < 10) {
          x = min(b, c);
     } else {
          x = c;
     }
     return x;
}

inline void solve() {
     int x, y, z;
     cin >> x >> y >> z;
     cin >> a >> b >> c;

     vector<int> cnt;
     cnt.push_back(check(x) + check(y) + check(z));
     cnt.push_back(check(x + y) + check(z));
     cnt.push_back(check(x + z) + check(y));
     cnt.push_back(check(x) + check(y + z));
     cnt.push_back(check(x + y + z));
     cout << *min_element(cnt.begin(), cnt.end()) << '\n';
}

#if 0
inline void solve2() {
     int n;
     cin >> n;
     vector<ll> dp(n);
     vector<ll> dp2(n + 1);
     dp2[0] = 1;
     dp2[1] = 1;
     for (int i = 2; i < n; ++i) {
          int a = i / 2;
          ll x = a;
          for (int j = 0; j < a - 1; j++) {
               x *= (a - 2 * j - 1) * (a - 2 * j - 2) % mod;
          }
          dp2[i] = dp2[i-1] * x % mod;
     }
     dp[0] = 1;
     if (n > 1)
          dp[1] = 1;
     for (int i = 2; i < n; ++i) {
          dp[i] = (i * ((i - 1) / 2 + 1) * dp[i-1]) % mod;
     }
     cout << dp.back();
}
#endif

int main() {
     ios_base::sync_with_stdio(false);
     cin.tie(nullptr);

     int t = 1;
     //cin >> t;

     while (t--) {
          solve();
     }

     return 0;
}
