﻿#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <cmath>
#include <deque>
#include <set>
#include <map>

using namespace std;

using ll = long long;
using ld = long double;

int main() {
    cin.tie(0)->sync_with_stdio(false);
    int q; cin >> q;
    map<int, int> xEven_yEven, xOdd_yEven, xEven_yOdd, xOdd_yOdd;
    int evenCol = 0, oddCol = 0;
    set<pair<int, int>> st;
    while (q--) {
        int x, y; cin >> x >> y;
        if (st.find({ x, y }) != st.end()) {
            st.erase({x, y});
            if (x % 2 == 0 && y % 2 == 0) {
                evenCol -= max(xEven_yEven[x], xEven_yOdd[x]);
                xEven_yEven[x]--;
                evenCol += max(xEven_yEven[x], xEven_yOdd[x]);
            }
            else if (x % 2 == 1 && y % 2 == 0) {
                oddCol -= max(xOdd_yEven[x], xOdd_yOdd[x]);
                xOdd_yEven[x]--;
                oddCol += max(xOdd_yEven[x], xOdd_yOdd[x]);
            }
            else if (x % 2 == 0 && y % 2 == 1) {
                evenCol -= max(xEven_yEven[x], xEven_yOdd[x]);
                xEven_yOdd[x]--;
                evenCol += max(xEven_yEven[x], xEven_yOdd[x]);
            }
            else {
                oddCol -= max(xOdd_yEven[x], xOdd_yOdd[x]);
                xOdd_yOdd[x]--;
                oddCol += max(xOdd_yEven[x], xOdd_yOdd[x]);
            }
        }
        else {
            st.insert({x, y});
            if (x % 2 == 0 && y % 2 == 0) {
                evenCol -= max(xEven_yEven[x], xEven_yOdd[x]);
                xEven_yEven[x]++;
                evenCol += max(xEven_yEven[x], xEven_yOdd[x]);
            }
            else if (x % 2 == 1 && y % 2 == 0) {
                oddCol -= max(xOdd_yEven[x], xOdd_yOdd[x]);
                xOdd_yEven[x]++;
                oddCol += max(xOdd_yEven[x], xOdd_yOdd[x]);
            }
            else if (x % 2 == 0 && y % 2 == 1) {
                evenCol -= max(xEven_yEven[x], xEven_yOdd[x]);
                xEven_yOdd[x]++;
                evenCol += max(xEven_yEven[x], xEven_yOdd[x]);
            }
            else {
                oddCol -= max(xOdd_yEven[x], xOdd_yOdd[x]);
                xOdd_yOdd[x]++;
                oddCol += max(xOdd_yEven[x], xOdd_yOdd[x]);
            }
        }

        cout << max(oddCol, evenCol) << '\n';
    }
}