#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <iomanip>
#include <cstdint>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> ii;
typedef pair<long long, long long> llll;
typedef vector<int> vi;
typedef vector<long long> vll;

void solve() {
    int n;
    cin >> n;
    vector<vi> a(n, vi(n));
    vll s1(n), s2(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            s1[i] += a[i][j];
            s2[j] += a[i][j];
        }
    }
    if (n == 3) {
        for (int i1 = 0; i1 < n; ++i1) {
            for (int j1 = 0; j1 < n; ++j1) {
                for (int i2 = 0; i2 < n; ++i2) {
                    for (int j2 = 0; j2 < n; ++j2) {
                        if (i1 == i2 && j1 == j2)
                            continue;
                        s1[i1] += -a[i1][j1] + a[i2][j2];
                        s1[i2] += a[i1][j1] - a[i2][j2];
                        s2[j1] += -a[i1][j1] + a[i2][j2];
                        s2[j2] += a[i1][j1] - a[i2][j2];
                        for (int i = 1; i < n; ++i) {
                            if (s1[i] != s1[0])
                                goto end;
                        }
                        for (int i = 1; i < n; ++i) {
                            if (s2[i] != s2[0])
                                goto end;
                        }
                        cout << i1 + 1 << ' ' << j1 + 1 << '\n' << i2 + 1 << ' ' << j2 + 1;
                        return;
                        end:
                        s1[i1] -= -a[i1][j1] + a[i2][j2];
                        s1[i2] -= a[i1][j1] - a[i2][j2];
                        s2[j1] -= -a[i1][j1] + a[i2][j2];
                        s2[j2] -= a[i1][j1] - a[i2][j2];
                    }
                }
            }
        }
    } else {
        map<ll, int> S1, S2;
        for (int i = 0; i < n; ++i) {
            S1[s1[i]]++;
            S2[s2[i]]++;
        }
        vector<ii> ans;
        ll es1 = -1, es2 = -1;
        for (auto [s, cnt] : S1) {
            if (cnt > 1) {
                assert(es1 == -1);
                es1 = s;
            }
        }
        for (auto [s, cnt] : S2) {
            if (cnt > 1) {
                assert(es2 == -1);
                es2 = s;
            }
        }
        assert(es1 == es2);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (s1[i] != es1 && s2[j] != es2)
                    ans.emplace_back(i, j);
            }
        }
        for (int i = 0; i < ans.size(); ++i) {
            for (int j = i + 1; j < ans.size(); ++j) {
                auto [i1, j1] = ans[i];
                auto [i2, j2] = ans[j];
                if (s1[i1] - a[i1][j1] + a[i2][j2] == s1[i2] + a[i1][j1] - a[i2][j2]
                && s2[j1] - a[i1][j1] + a[i2][j2] == s2[j2] + a[i1][j1] - a[i2][j2]
                && s1[i1] - a[i1][j1] + a[i2][j2] == es1
                && s2[j1] - a[i1][j1] + a[i2][j2] == es2) {
                    cout << i1 + 1 << ' ' << j1 + 1 << '\n' << i2 + 1 << ' ' << j2 + 1;
                    return;
                }
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#endif
    int tests = 1;
    // cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
}