#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

typedef long long ll;

const long long INF = 1e18, MOD = 1e9 + 7;
#define all(x) x.begin(), x.end()

ll fact[300001];
ll fact_obr[300001];

ll binpow(ll a, ll b) {
	if (b == 0) {
		return 1;
	}
	ll ans = binpow(a, b / 2);
	ans = ans * ans % MOD;
	if (b % 2 == 1) {
		ans = ans * a % MOD;
	}
	return ans;
}

ll c(int k, int n) {
	return fact[n] * fact_obr[k] % MOD * fact_obr[n - k]  % MOD;
}

ll gt(int f, int ost1, int ost2) {
	int n = ost1 + ost2;
	if (n == 0) {
		return 0;
	}
	int o1 = ost1;
	int o2 = ost2;
	int smnw = f;
	if (f == 1) {
		--o1;
	}
	else {
		--o2;
	}
	for (int i = 1; i < n; ++i) {
		if (smnw == 1) {
			--o1;
			smnw = 2;
		}
		else {
			--o2;
			smnw = 1;
		}
	}
	if (o1 < 0 || o2 < 0) {
		return 0;
	}
	return fact[ost1] * fact[ost2] % MOD;
}

void solve()
{
	fact[0] = 1;
	for (ll i = 1; i <= 300000; ++i) {
		fact[i] = fact[i - 1] * i % MOD;
	}
	fact_obr[300000] = binpow(fact[300000], MOD - 2);
	for (ll i = 300000 - 1; i >= 0; --i) {
		fact_obr[i] = fact_obr[i + 1] * (i + 1) % MOD;
	}
	int n; cin >> n;
	int ost0 = 0, ost1 = 0, ost2 = 0;
	for (int i = 0; i < n; ++i) {
		int a; cin >> a;
		if (a % 3 == 0) {
			++ost0;
		}
		if (a % 3 == 1) {
			++ost1;
		}
		if (a % 3 == 2) {
			++ost2;
		}
	}
	ll ans = (gt(1, ost1, ost2) + gt(2, ost1, ost2)) % MOD;
	if (ans == 0) {
		cout << "0\n";
		return;
	}
	ans = c(ost1 + ost2 - 1, ost0 + ost1 + ost2 - 1) * ans % MOD;
	cout << ans << '\n';
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*

























*/
