#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const ll INF = 1e18 + 1;
#define int long long
#define endl "\n"

vector<vector<int>> w;
int n;

void check(int x1, int y1, int x2, int y2) {
    int valx = -1, valy = -1;
    for (int i = 0; i < n; i++) {
        int sum = 0;
        for (int j = 0; j < n; j++) {
            sum += w[i][j];
        }
        if (valx == -1) valx = sum;
        else if (valx != sum) return;
    }
    for (int j = 0; j < n; j++) {
        int sum = 0;
        for (int i = 0; i < n; i++) {
            sum += w[i][j];
        }
        if (valy == -1) valy = sum;
        else if (valy != sum) return;
    }
    cout << x1 + 1 << ' ' << y1 + 1 << '\n' << x2 + 1 << ' ' << y2 + 1;
    exit(0);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    w.resize(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> w[i][j];
        }
    }
    map<int, vector<int>> x, y;
    for (int i = 0; i < n; i++) {
        int sum = 0;
        for (int j = 0; j < n; j++) {
            sum += w[i][j];
        }
        x[sum].push_back(i);
    }
    for (int j = 0; j < n; j++) {
        int sum = 0;
        for (int i = 0; i < n; i++) {
            sum += w[i][j];
        }
        y[sum].push_back(j);
    }
    vector<int> a, b;
    for (auto [s, c]: x) {
        if (c.size() == 1) {
            a.push_back(c[0]);
        }
    }
    for (auto [s, c]: y) {
        if (c.size() == 1) {
            b.push_back(c[0]);
        }
    }
    vector<pair<int, int>> t;
    for (int i: a) {
        for (int j: b) {
            t.push_back({i, j});
        }
    }
    for (int i = 0; i < t.size(); i++) {
        for (int j = i + 1; j < t.size(); j++) {
            int x1 = t[i].first, y1 = t[i].second, x2 = t[j].first, y2 = t[j].second;
            swap(w[x1][y1], w[x2][y2]);
            check(x1, y1, x2, y2);
            swap(w[x1][y1], w[x2][y2]);
        }
    }
}
