#include <iostream>
#include <vector>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    int n; cin >> n;
    long long sm = (n * n + 1) * n / 2;
    vector <pair <long long, long long> > k1, k2;
    vector <vector <long long> > c(n, vector <long long> (n));
    long long pr;
    for (int i = 0; i < n; i++) {
        pr = 0;
        for (int j = 0; j < n; j++) {
            cin >> c[i][j];
            pr += c[i][j];
        }
        if (pr != sm)
            k1.push_back(make_pair(i, pr));
        if (k1.size() == 2) break;
    }
    for (int j = 0; j < n; j++) {
        pr = 0;
        for (int i = 0; i < n; i++)
            pr += c[i][j];
        if (pr != sm)
            k2.push_back(make_pair(j, pr));
        if (k2.size() == 2) break;
    }
    if (k2.size() == 2) {
        int a = k2[0].first, b = k2[1].first;
        long long sma = k2[0].second, smb = k2[1].second;
        long long pra, prb;
        bool check = false;
        for (int ia = 0; ia < n && !check; ia++) {
            for (int ib = 0; ib < n && !check; ib++) {
                pra = sma; prb = smb;
                pra -= c[ia][a]; prb -= c[ib][b];
                pra += c[ib][b]; prb += c[ia][a];
                if (pra == sm) {
                    check = true;
                    cout << ia+1 << ' ' << a+1 << '\n';
                    cout << ib+1 << ' ' << b+1;
                }
            }
        }
    }
    else {
        int a = k1[0].first, b = k1[1].first;
        long long sma = k1[0].second, smb = k1[1].second;
        long long pra, prb;
        bool check = false;
        for (int ja = 0; ja < n && !check; ja++) {
            for (int jb = 0; jb < n && !check; jb++) {
                pra = sma; prb = smb;
                pra -= c[a][ja]; prb -= c[b][jb];
                pra += c[b][jb]; prb += c[a][ja];
                if (pra == sm) {
                    check = true;
                    cout << a+1 << ' ' << ja+1 << '\n';
                    cout << b+1 << ' ' << jb+1;
                }
            }
        }
    }
}
