#include <bits/stdc++.h>
#define fast ios_base::sync_with_stdio(0); cin.tie(0);
#define int long long
#define all(r) r.begin(), r.end()

using namespace std;

const int INF = 1e9 + 7;
vector<vector<int>> g;
vector<int> near;

void dfs(int v, int p = -1) {
    for (int u : g[v]) {
        if (u != p) {
            dfs(u, v);
            near[v] = min(near[u] + 1, near[v]);
        }
    }
    if (near[v] == INF) near[v] = 0;
}

int maxans = 0;
void dfs2(int v, int ansnow = 0, int t = 0, int p = -1) {
    if (near[v] == 0) {
        maxans = max(maxans, ansnow);
        return;
    }
    if (t == 0) {
        ++ansnow;
        t = near[v];
    }
    for (int u : g[v]) {
        if (u != p) {
            dfs2(u, ansnow, t - 1, v);
        }
    }
}

signed main() {
    fast;
    int n;
    cin >> n;
    g.resize(n);
    for (int i = 1; i < n; ++i) {
        int x;
        cin >> x;
        g[x - 1].push_back(i);
    }
    near.resize(n, INF);
    dfs(0);
    dfs2(0);
    cout << maxans;
    return 0;
}
