#include <bits/stdc++.h>

using namespace std;
#define int int_fast64_t

mt19937 rnd(23);
const int MOD = 1e9 + 7;
const int INF = 2e18;

int binpow(int n, int p) {
    if (p == 0) {
        return 1;
    }
    if (p % 2 == 0) {
        int c = binpow(n, p / 2);
        return c * c % MOD;
    } else {
        return n * binpow(n,p - 1) % MOD;
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<int> cnt(3);
    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;
        cnt[a % 3]++;
    }
    vector<int> fact(n + 1);
    fact[0] = 1;
    for (int i = 1; i <= n; i++) {
        fact[i] = fact[i - 1] * i % MOD;
    }
    if (abs(cnt[1] - cnt[2]) <= 2 && abs(cnt[1] - cnt[2]) > 0) {
        int ans = fact[n - 1] * binpow(fact[n - cnt[0] - 1], MOD - 2) * binpow(fact[cnt[0]], MOD - 2);
        ans *= fact[cnt[0]];
        ans %= MOD;
        ans *= fact[cnt[1]];
        ans %= MOD;
        ans *= fact[cnt[2]];
        cout << ans % MOD;
    } else {
        cout << 0;
    }
    return 0;
}
