#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

void solve() {
    string s;
    cin >> s;
    vector<ll> cnt(26);
    for(ll i = 0; i < (ll)s.size(); i++){
        cnt[s[i] - 'a']++;
    }
    ll n;
    cin >> n;
    map<ll, ll> mp;
    for(ll i = 0; i < n; i++){
        char c;
        ll x;
        cin >> c >> x;
        mp[c - 'a'] = x;
    }
    ll ans = 0;
    for(ll i = 0; i < 26; i++){
        if(mp[i]){
            ll l = 0, r = (ll)1e9;
            while(r - l > 1){
                ll mid = (l + r) / 2;
                if(mid - (mid + mp[i] - 1) / mp[i] >= cnt[i]){
                    r = mid;
                } else {
                    l = mid;
                }
            }
            ans += r;
        } else {
            ans += cnt[i];
        }
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while(t--) {
        solve();
    }
}
