#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll MAXN = 2e5, INF = 1e9;

vector<int> g[MAXN];
vector<int> dp(MAXN);
vector<int> d(MAXN);
map<int, int> mpv[MAXN];

void dsu(int ver1, int ver2) {
    if (mpv[ver2].size() > mpv[ver1].size()) {
        swap(mpv[ver2], mpv[ver1]);
    }
    for (auto e : mpv[ver2]) {
        int glub = e.first, bestver = e.second;
        if (mpv[ver1].find(glub) == mpv[ver1].end() || dp[mpv[ver1][glub]] < dp[bestver]) {
            mpv[ver1][glub] = bestver;
        } else if(dp[mpv[ver1][glub]] == dp[bestver] && !g[bestver].empty()){
            mpv[ver1][glub] = bestver;
        }
    }
}

int dfs(int v = 0, int p = -1) {
    if (p != -1) {
        d[v] = d[p] + 1;
    }
    int min_d_list = INF;
    mpv[v][d[v]] = v;
    for (auto u : g[v]) {
        if (u != p) {
            min_d_list = min(min_d_list, dfs(u, v) + 1);
            dsu(v, u);
        }
    }
    if (g[v].empty()) {
        min_d_list = 0;
        dp[v] = 0;
    } else {
        int ver = mpv[v][d[v] + min_d_list];
        if (g[ver].empty()) {
            dp[v] = 0;
        } else {
            dp[v] = 1 + dp[mpv[v][d[v] + min_d_list]];
        }
    }
    return min_d_list;
}

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        p--;
        g[p].emplace_back(i);
    }
    dfs();
    cout << dp[0] + 1 << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t = 1;
//    cin >> t;
    while(t--) {
        solve();
    }
}