#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll MOD = 1e9 + 7, MAXN = 1e5 + 1;

vector<ll> f(MAXN);

void solve() {
    f[0] = 1;
    for(ll i = 1; i < MAXN; i++){
        f[i] = f[i - 1] * i % MOD;
    }
    ll n;
    cin >> n;
    vector<ll> c(3);
    for(ll i = 0; i < n; i++){
        ll x;
        cin >> x;
        c[x % 3]++;
    }
    if(abs(c[1] - c[2]) == 0 || abs(c[1] - c[2]) > 2){
        cout <<  0;
        return;
    }
    ll ans = 1;
    ans *= f[c[1]];
    ans %= MOD;
    ans *= f[c[2]];
    ans %= MOD;
    for(ll i = 0; i < c[0]; i++){
        ans *= (c[1] + c[2] + i);
        ans %= MOD;
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t = 1;
//    cin >> t;
    while(t--) {
        solve();
    }
}