#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll MAXN = 1005, MOD = 1e9 + 7;

ll dp1[61][MAXN];
ll dp2[MAXN][MAXN];

void solve() {
    ll n;
    cin >> n;
    for (ll i = 0; i <= 60; ++i) {
        dp1[i][0] = 1;
    }
    for (ll i = 1; i <= 60; ++i) {
        for (ll sum = 1; sum < MAXN; ++sum) {
            for (ll cnt = 0; cnt < MAXN; ++cnt) {
                if (sum >= cnt * i) {
                    dp1[i][sum] += dp1[i - 1][sum - cnt * i];
                    if (dp1[i][sum] >= MOD) {
                        dp1[i][sum] -= MOD;
                    }
                }
            }
        }
    }
    for (ll i = 1; i < MAXN; ++i) {
        dp2[i][0] = 1;
    }
    for (ll i = MAXN - 2; i > 0; --i) {
        for (ll sum = 1; sum < MAXN; ++sum) {
            for (ll cnt = 0; cnt <= 60; ++cnt) {
                if (sum >= cnt * i) {
                    dp2[i][sum] += dp2[i + 1][sum - cnt * i];
                    if (dp2[i][sum] >= MOD) {
                        dp2[i][sum] -= MOD;
                    }
                }
            }
        }
    }
    ll ans = 0;
    for (ll mex = 1; mex <= 60; ++mex) {
        for (ll sum = (mex - 1) * mex / 2; sum <= n; ++sum) {
            ans += (dp1[mex - 1][sum - (mex - 1) * mex / 2] * dp2[mex + 1][n - sum]) % MOD * mex;
            ans %= MOD;
        }
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t = 1;
//    cin >> t;
    while(t--) {
        solve();
    }
}