#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define rs resize
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define int long long

typedef pair<int, int> pii;

template<typename T>
istream &operator >>(istream &in, vector<T> &arr) {
    for (auto &i : arr) in >> i;
    return in;
}
template<typename T>
ostream &operator <<(ostream &in, vector<T> &arr) {
    for (auto &i : arr) in << i << " ";
    return in;
}

const int maxn = 2e5 + 10;

vector<int> g[maxn];
int d[maxn];

void dfs(int v, int p) {
    d[v] = d[p] + 1;

    for (auto i : g[v]) {
        if (i != p) {
            dfs(i, v);
        }
    }
}

void solve() {
    int n; cin >> n;

    for (int i = 1; i < n; i++) {
        int a; cin >> a;
        a--;

        g[a].pb(i);
        g[i].pb(a);
    }

    dfs(0, 0);

    vector<int> p;
    for (int i = 0; i < n; i++) {
        if (i != 0 && sz(g[i]) == 1) p.pb(d[i]);
    }

    sort(all(p));

    int sm = 0, cnt = 0;
    for (int i = 0; i < sz(p) - 1; i++) {
        if (sm + p[i] < p.back()) {
            sm += p[i];
            cnt++;
        }
        //cout << p[i] << "\n";
    }
    //cout << p << "\n";

    cout << cnt + 1 << "\n";
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int tt = 1;
    //cin >> tt;

    while (tt--) {
        solve();
    }
}
