#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define rs resize
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define int long long

typedef pair<int, int> pii;

template<typename T>
istream &operator >>(istream &in, vector<T> &arr) {
    for (auto &i : arr) in >> i;
    return in;
}
template<typename T>
ostream &operator <<(ostream &in, vector<T> &arr) {
    for (auto &i : arr) in << i << " ";
    return in;
}

const int maxn = 1e1  + 10, mod = 1e9 + 7;
int f[maxn];

int mul(int a, int b) {
    int c = a * b % mod;
    return c;
}

int add(int a, int b) {
    int c = a + b;
    if (c >= mod) c -= mod;

    return c;
}

int bin_pow(int a, int b) {
    if (b == 0) return 1;

    if (b % 2 == 0) {
        int t = bin_pow(a, b / 2);
        return (t * t) % mod;
    } else {
        return (bin_pow(a, b - 1) * a) % mod;
    }
}

void solve() {
    int n; cin >> n;
    vector<int> s(n); cin >> s;

    map<int, int> a, b, c;
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        if (s[i] % 3 == 0) {
            a[s[i]]++; cnt++;
        } else if (s[i] % 3 == 1) {
            b[s[i]]++;
        } else {
            c[s[i]]++;
        }
    }

    f[0] = f[1] = 1;
    for (int i = 2; i < maxn; i++) {
        f[i] = mul(f[i - 1], i);
        //cout << f[i] << " ";
    }
    //cout << endl;
    //cout << f[n - 1] << ' ' << f[cnt] << ' ' << f[n - 1 - cnt] << endl;
    int C = mul(f[n - 1], mul(bin_pow(f[cnt], mod - 2), bin_pow(f[n - 1 - cnt], mod - 2)));
    //cout << C << endl;

    int sm_a = 0, p_a = 1;
    for (auto [i, j] : a) sm_a = add(sm_a, j);
    for (auto [i, j] : a) p_a = mul(p_a, f[j]);
    int aa = mul(f[sm_a], bin_pow(p_a, mod - 2));

    int sm_b = 0, p_b = 1;
    for (auto [i, j] : b) sm_b = add(sm_b, j);
    for (auto [i, j] : b) p_b = mul(p_b, f[j]);
    int bb = mul(f[sm_b], bin_pow(p_b, mod - 2));

    int sm_c = 0, p_c = 1;
    for (auto [i, j] : c) sm_c = add(sm_c, j);
    for (auto [i, j] : c) p_c = mul(p_c, f[j]);
    int cc = mul(f[sm_c], bin_pow(p_c, mod - 2));

    if (sm_b == sm_c || abs(sm_b - sm_c) > 2) {
        cout << 0;
        return;
    }

    cout << mul(C, mul(aa, mul(bb, cc)));
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int tt = 1;
    //cin >> tt;

    while (tt--) {
        solve();
    }
}