#include "bits/stdc++.h"

using namespace std;

using ll = long long;
using ld = long double;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using vi = vector<int>;
using vl = vector<ll>;
using vp = vector<pi>;
using vpl = vector<pl>;
#define f first
#define s second

vector<vl> dd;

void print(const vi &v0) {
    vi v = v0;
    std::swap(v[0], v[1]);
    std::swap(v[2], v[3]);
    for (int i : v)
        cout << i+1 << " ";
}

ll sumhor(ll y) {
    ll sum = 0;
    for (ll i : dd[y])
        sum += i;
    return sum;
}
ll sumver(ll x) {
    ll sum = 0;
    for (int i = 0; i < dd.size(); i++)
        sum += dd[i][x];
    return sum;
}

pi findd(vpl &v) {
    int n = v.size();
    std::sort(v.begin(), v.end());

    if (v[1].f != v[2].f)
        return {v[0].s, v[1].s};
    if (v[n-2].f != v[n-3].f)
        return {v[n-1].s, v[n-2].s};

    if (v[0].f != v[1].f)
        return {v[0].s, v[n-1].s};
    return {-1, -1};
}

bool eq(const vl &v) {
    for (int i = 1; i < v.size(); i++)
        if (v[i] != v[i-1])
            return false;
    return true;
}

bool check(pi xy1, pi xy2) {
    std::swap(dd[xy1.s][xy1.f], dd[xy2.s][xy2.f]);
    bool b = eq({sumhor(xy1.s), sumhor(xy2.s), sumver(xy1.f), sumver(xy2.f)});
    std::swap(dd[xy1.s][xy1.f], dd[xy2.s][xy2.f]);
    return b;
}

bool check2(pi xy1, pi xy2) {
    std::swap(dd[xy1.s][xy1.f], dd[xy2.s][xy2.f]);
    bool b = eq({sumhor(0), sumhor(1), sumhor(2), sumver(0), sumver(1), sumver(2)});
    std::swap(dd[xy1.s][xy1.f], dd[xy2.s][xy2.f]);
    return b;
}

int main() {
    ios::sync_with_stdio(false); cin.tie(0);

    int n; cin >> n;
    dd.resize(n);
    for (vl &v : dd) {
        v.resize(n);
        for (ll &i : v)
            cin >> i;
    }
    if (n == 3) {
        for (int x1 = 0; x1 < 3; x1++) {
            for (int x2 = x1; x2 < 3; x2++) {
                for (int y1 = 0; y1 < 3; y1++) {
                    for (int y2 = y1; y2 < 3; y2++) {
                        if (x1 == x2 && y1 == y2) continue;
                        if (check2({x1, y1}, {x2, y2})) {
                            print({x1, y1, x2, y2});
                            return 0;
                        }
                    }
                }
            }
        }
        return 1;
    }
    vpl hors, vers;
    for (int i = 0; i < n; i++) {
        hors.emplace_back(sumhor(i), i);
        vers.emplace_back(sumver(i), i);
    }
    pi xx = findd(hors);
    pi yy = findd(vers);
    if (xx.f != -1 && yy.f != -1) {
        auto [x1, x2] = yy;
        auto [y1, y2] = xx;
        if (check({x1, y1}, {x2, y2}))
            print({x1, y1, x2, y2});
        else
            print({x1, y2, x2, y1});
        return 0;
    } else if (yy.f != -1) {
        auto[x1, x2] = yy;
        for (int y = 0; y < n; y++) {
            if (check({x1, y}, {x2, y})) {
                print({x1, y, x2, y});
                return 0;
            }
        }
    } else {
        auto[y1, y2] = xx;
        for (int x = 0; x < n; x++) {
            if (check({x, y1}, {x, y2})) {
                print({x, y1, x, y2});
                return 0;
            }
        }
    }
    return -1;
}
/*
5
1 1 0 0 0
9 1 0 0 0
0 0 9 9 0
0 0 9 0 1
0 0 0 1 9

6 9 2
3 5 7
8 1 4
 */