#include "bits/stdc++.h"

using namespace std;

using ll = long long;
using ld = long double;
using pi = pair<int, int>;
using vi = vector<int>;
#define f first
#define s second

ll mod = 1e9 + 7;

ll MXX = 1e15;

map<int, vi> xx, yy;
vi ansx = {0, 0};
vi ansy = {0, 0};

int mx(const vi &q) {
    return max(q[0], q[1]);
}

int get_ans() {
    return std::max(mx(ansx), mx(ansy));
}

void updateX(int x, int y) {
    y %= 2;
    vi *p = &xx[x];
    int was = mx(*p);
    (*p)[y]++;
    int now = mx(*p);
    ansx[y%2] += now-was;
}

void updateY(int x, int y) {
    x %= 2;
    vi *p = &yy[y];
    int was = mx(*p);
    (*p)[x]++;
    int now = mx(*p);
    ansy[x%2] += now-was;
}

set<pi> sq;

int main() {
    ios::sync_with_stdio(false); cin.tie(0);

    int n; cin >> n;
    for (int i = 0; i < n; i++) {
        int x, y; cin >> x >> y;

        int s0 = sq.size();
        sq.emplace(x, y);
        if (sq.size() == s0) {
            cout << get_ans() << "\n";
            continue;
        }

        if (xx.find(x) == xx.end())
            xx[x] = {0, 0};
        if (yy.find(y) == yy.end())
            yy[y] = {0, 0};

        updateX(x, y);
        updateY(x, y);

        cout << get_ans() << "\n";
    }
}
