#include <bits/stdc++.h>
using namespace std;

#define vc vector
#define all(a) a.begin(), a.end()
#define FOR(i, a, b) for (int i = a; i < b; ++i)

#define int long long
const int mod = 1e9 + 7;
const int N = 3e5;
int f[N], inv[N];

int bin_pow (int a, int b) {
    int res = 1;
    while (b) {
        if (b & 1) res = res * a % mod;
        a = a * a % mod;
        b >>= 1;
    }
    return res;
}

int C (int n, int k) {
    return f[n] * inv[k] % mod * inv[n - k] % mod;
}

void solve_case() {
    int n;
    cin >> n;
    f[0] = inv[0] = 1;
    for (int i = 1; i <= n; ++i) {
        f[i] = f[i - 1] * i % mod;
        inv[i] = bin_pow(f[i], mod - 2);
    }
    vc <int> a(n);
    vc <int> cnt(3);
    for (int &i : a)
        cin >> i, cnt[i % 3]++;
    int ans = 0;
    {
        int ost = cnt[1] - 1;
        if (ost >= cnt[2] && ost <= cnt[2] + 1) {
            ans += C(n - 1, n - cnt[0] - 1) * f[cnt[1]] % mod * f[cnt[2]] % mod * f[cnt[0]] % mod;
            ans %= mod;
        }
    }
    {
        int ost = cnt[2] - 1;
        if (ost >= cnt[1] && ost <= cnt[1] + 1) {
            ans += C(n - 1, n - cnt[0] - 1) * f[cnt[1]] % mod * f[cnt[2]] % mod * f[cnt[0]] % mod;
            ans %= mod;
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    int tc = 1; //cin >> tc;
    while (tc--) solve_case();
}
