#include <bits/stdc++.h>
#define pii pair <int, int>
using namespace std;

#define vc vector
#define all(a) a.begin(), a.end()
#define FOR(i, a, b) for (int i = a; i < b; ++i)

#define int long long
const int mod = 1e9 + 7;
const int N = 2e5 + 100;
const int inf = 1e9;

#define fi first
#define se second
struct pt {
    int x, y, i = -1, f = 0;
    pt () {}
    pt (int x, int y): x(x), y(y) {}
    pt operator + (pt b) {
        return pt(x + b.x, y + b.y);
    }
    pt operator - (pt b) {
        return pt(x - b.x, y - b.y);
    }
    int operator ^ (pt b) {
        return x * b.y - y * b.x;
    }
};

bool cmp (pt a, pt b) {
    return (a ^ b) < 0;
}

vc <pii> g[N];
pt a[N];



void solve_case() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
    }
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v; --u; --v;
        g[u].push_back({v, i - 1});
        g[v].push_back({u, i - 1});
    }
    vc <set <int>> w(n - 1);
    for (int u = 0; u < n; ++u) {
        vc <pt> up, daun;
        for (auto [v, j] : g[u]) {
            pt x1 = a[v] - a[u];
            pt x2 = a[u] - a[v];
            x1.f = 1;
            x1.i = j;
            x2.f = 0;
            x2.i = j;
            if (x1.x <= 0)
                up.push_back(x1);
            else
                daun.push_back(x1);
            if (x2.x <= 0)
                up.push_back(x2);
            else
                daun.push_back(x2);
        }
        sort(up.begin(), up.end(), cmp);
        sort(daun.begin(), daun.end(), cmp);
        vc <pt> b;
        for (pt t : up) {
            // cout << t.x << ' ' << t.y << '\n';
            b.push_back(t);
        }
        for (pt t : daun)
            b.push_back(t);
        int lst1 = -1;
        int k = b.size();
        for (int i = 0; i < k * 2; ++i) {
            pt h = b[i % k];
            if (!h.f) {
                lst1 = h.i;
            } else {
                if (lst1 != -1)
                    w[h.i].insert(lst1);
            }
        }
        lst1 = -1;
        for (int i = k * 2 - 1; i >= 0; --i) {
            pt h = b[i % k];
            if (!h.f) {
                lst1 = h.i;
            } else {
                if (lst1 != -1)
                    w[h.i].insert(lst1);
            }
        }
    }
    for (int i = 0; i < n - 1; ++i) {
        w[i].erase(i);
        vc <int> del;
        for (int j : w[i]) {
            if (w[j].find(i) == w[j].end()) {
                del.push_back(j);
            }
        }
        for (int k : del)
            w[i].erase(k);
    }
    vector<int> ord(n);
    int timer = 0;
    function<void(int, int)> dfs = [&](int v, int p) {
        for (auto [u, id] : g[v]) {
            if (u != p) {
                ord[id] = timer++;
                dfs(u, v);
            }
        }
    };
    dfs(0, 0);
    vector<vector<int>> graph(n - 1);
    for (int i = 0; i < n - 1; i++) {
        for (int u : w[i]) {
            // ord[v] - ord[u]
            if (ord[i] < ord[u]) {
                graph[ord[i]].push_back(ord[u]);
            }
        }
    }
    vector<int> mt(n - 1, -1);
    vector<int> us(n);
    function<bool(int)> kuhn = [&](int v) {
        if (us[v] == timer) return false;
        us[v] = timer;
        for (int u : graph[v]) {
            if (mt[u] == -1) {
                mt[u] = v;
                return true;
            }
        }
        for (int u : graph[v]) {
            if (kuhn(u)) {
                mt[u] = v;
                return true;
            }
        }
        return false;
    };
    timer++;
    int ans = n - 1;
    for (int i = 0; i < n - 1; i++) {
        if (kuhn(i)) {
            timer++;
            ans--;
        }
    }
    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    int tc = 1; //cin >> tc;
    while (tc--) solve_case();
}
