#ifndef LOCAL
#pragma GCC optimize("03")
#pragma GCC target("avx2")
#endif
#include<iostream>
#include<vector>
#include<string>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
#include<iomanip>
using namespace std;
using namespace __gnu_pbds;

//auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
//mt19937_64 generator(seed);
template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T,V>;

using i128 = __int128;
using ll = long long;
using ld = long double;

void solve(){
    string s;
    cin>>s;
    int n;
    cin>>n;
    vector<int> mp(26,1e9);
    vector<int> cnt(26, 1);
    for(int i =0; i < n; ++i){
        char a;
        int b;
        cin>>a>> b;
        mp[a-'a'] = b;
        cnt[a-'a'] = 0;
    }
    for(auto c: s){
        if(cnt[c-'a'] % mp[c-'a'] == 0) cnt[c-'a']++;
        cnt[c-'a']++;
    }
    ll ans = 0;
    for(int i = 0; i < 26; ++i){
        ans += cnt[i];
        if(mp[i] == 1e9) ans--;
    }
    cout << ans;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(6);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin>>t;
    while(t--) solve();
    //stress();
}