#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937_64 generator(seed);
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using i128 = __int128;
using ll = long long;
using ld = long double;
#define int ll

void solve() {
    ll n;
    cin >> n;
    vector<vector<int>> v(n, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> v[i][j];
        }
    }
    ll a = n * (n * n + 1) / 2;
    vector<int> vert;
    vector<int> hor;
    for (int i = 0; i < n; ++i) {
        ll sum = 0;
        ll sum1 = 0;
        for (int j = 0; j < n; ++j) {
            sum += v[i][j];
            sum1 += v[j][i];
        }
        if (sum != a) hor.push_back(i);
        if (sum1 != a) vert.push_back(i);
    }
    pair<int, int> a1 = {hor[0], vert[0]}, a2 = {hor[0], vert[1]},
            a3 = {hor[1], vert[0]}, a4 = {hor[1], vert[1]};
    swap(v[a1.first][a1.second], v[a4.first][a4.second]);
    bool b = true;
    for (int i = 0; i < n; ++i) {
        ll sum = 0;
        ll sum1 = 0;
        for (int j = 0; j < n; ++j) {
            sum += v[i][j];
            sum1 += v[j][i];
        }
        if (sum != a || sum1 != a) b = false;
    }
    if (b) cout << a1.first + 1 << " " << a1.second + 1 << "\n" << a4.first + 1 << " " << a4.second + 1;
    else cout << a2.first + 1 << " " << a2.second + 1 << "\n" << a3.first + 1 << " " << a3.second + 1;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(6);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin>>t;
    while (t--) solve();
    //stress();
}