#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<iomanip>
#include<set>
#include<map>
#include<algorithm>
using namespace std;
#define mod 1000000007
typedef long long ll;
#define int ll
#define int long long

const int MOD = 1e9 + 7;
const int N = 3e5;

int fact[N], infact[N];

int bp(int a, int b) {
	if (b == 0) return 1;
	if (b % 2 == 0) return bp((a * a) % MOD, b / 2);
	return (a * bp(a, b - 1)) % MOD;
}

int C(int n, int k) {
	return fact[n] * infact[n - k] % MOD * infact[k] % MOD;
}

void Fast() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
}

signed main() {
	Fast();
	//    freopen("input.txt", "r", stdin);
	//    freopen("output.txt", "w", stdout);
	fact[0] = 1;
	for (int i = 1; i < N; i++) fact[i] = fact[i - 1] * i % MOD;
	infact[N - 1] = bp(fact[N - 1], MOD - 2);
	for (int i = N - 2; i > -1; i--) infact[i] = infact[i + 1] * (i + 1) % MOD;
	/////////////////
	int kol0 = 0, kol1 = 0, kol2 = 0;
	{
		int n;
		cin >> n;
		for (int i = 0; i < n; i++)
		{
			int a;
			cin >> a;
			if (a % 3 == 0)
				kol0++;
			else if (a % 3 == 1)
				kol1++;
			else
				kol2++;
		}
	}
	int otv = ((fact[kol0] * fact[kol1]) % mod * fact[kol2]) % mod;
	int x = 0;
	{
		int kol1_ = 0, kol2_ = 0;
		int n = kol1 + kol2;
		if (n == 1)
			kol1_ = 1;
		else
		{
			kol1_ = 2;
			for (int i = 2; i < n; i++)
			{
				if (i % 2 == 0)
					kol2_++;
				else
					kol1_++;
			}
		}
		if (kol1 == kol1_)
			x++;
		if (kol1 == kol2_)
			x++;
	}
	otv = (otv * x) % mod;
	int l = kol1 + kol2,m = kol0;
	otv = (otv * C(l + m - 1,m)) % mod;
	cout << otv;
}