#include <bits/stdc++.h>

using namespace std;
#define int long long

const int mod = 1e9 + 7;
const int nMax = 2e5 + 10;

int dist[nMax], sz[nMax];
bool isLeaf[nMax];
vector<int> g[nMax];
struct lea {
    map<int, int> dp;
    int offset = 0;
} leas[nMax];

void dfs1(int v, int p) {
    sz[v] = 1;
    if (!isLeaf[v])dist[v] = 1e9;
    //g[v].resize(remove(g[v].begin(), g[v].end(), p) - g[v].begin());
    for (auto u: g[v]) {
        dfs1(u, v);
        dist[v] = min(dist[u] + 1, dist[v]);
        sz[v] += sz[u];
    }
}

void dfs2(int v, int p) {
    if (g[v].empty())return;
    for (auto u: g[v]) {
        dfs2(u, v);
    }
    sort(g[v].begin(), g[v].end(), [](auto f, auto s) {
        return sz[f] > sz[s];
    });
    auto &gg = g[v];
    leas[v].dp = std::move(leas[gg[0]].dp);
    leas[v].offset = leas[gg[0]].offset;
    for (int i = 1; i < gg.size(); i++) {
        auto u = gg[i];
        for (auto o: leas[u].dp) {
            auto &cell = leas[v].dp[o.first - leas[u].offset + leas[v].offset];
            cell = max(cell, o.second);
        }
    }
    leas[v].offset--;
    leas[v].dp[leas[v].offset] = max(leas[v].dp[leas[v].offset], leas[v].dp[leas[v].offset + dist[v]] + 1);
}

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++)isLeaf[i] = true;
    for (int i = 2; i <= n; i++) {
        int p;
        cin >> p;
        isLeaf[p] = false;
        g[p].push_back(i);
        //g[i].push_back(p);
    }
    dfs1(1, 1);
    for (int i = 1; i <= n; i++) {
        if (!isLeaf[i])continue;
        leas[i].dp[0] = -1;
    }
    dfs2(1, 1);
    cout << leas[1].dp[leas[1].offset] + 1;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}