#include <bits/stdc++.h>

using namespace std;
#define int long long
const size_t nMax = 5e3 + 228, mod = 1e9 + 7;

struct mint {
    int value = 0;

    mint operator+(mint oth) {
        auto rese = value + oth.value;
        if (rese >= mod)rese -= mod;
        return {rese};
    }

    mint operator-(mint oth) {
        auto rese = value - oth.value;
        if (rese < 0)rese += mod;
        return {rese};
    }

    mint operator*(mint oth) {
        int rese = (value * oth.value) % mod;
        return {rese};
    }
};

mint dp[nMax][nMax];

void solve() {
    dp[1][1] = {1};
    for (int i = 0; i < nMax; i++) {
        dp[0][i] = {1};
    }
    for (int i = 2; i < nMax; i++) {
        dp[1][i] = {i};
    }
    for (int i = 2; i < nMax; i++) {
        for (int j = 1; j < nMax; j++) {
            dp[i][j] = dp[i][j - 1] + dp[i - 1][j - 1] + dp[i - 2][j - 1];
        }
    }
    mint ans = {1};
    int n;
    cin >> n;
    for (int i = 2; i <= n; i++) {
        ans = ans * dp[i][i - 1];
    }
    cout << ans.value;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
