#include <bits/stdc++.h>
using namespace std;
#define int long long

const int N = 1000 + 10;
int a[N][N];

void solve() {
    int n;
    cin >> n;

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            cin >> a[i][j];
        }
    }

    int corr = n * n * (n * n + 1) / 2;
    corr /= n;

    // find inc
    vector<pair<int, int>> in;

    for (int i = 1; i <= n; i++) {
        int sum = 0;
        for (int j = 1; j <= n; j++) {
            sum += a[i][j];
        }
        if (sum != corr) {
            in.emplace_back(i, -1);
        }
    }

    for (int j = 1; j <= n; j++) {
        int sum = 0;
        for (int i = 1; i <= n; i++) {
            sum += a[i][j];
        }
        if (sum != corr) {
            in.emplace_back(-1, j);
        }
    }

    vector<int> r, c;
    for (auto [ri, ci] : in) {
        if (ri != -1) {
            r.emplace_back(ri);
        }

        if (ci != -1) {
            c.emplace_back(ci);
        }
    }

    for (auto r1 : r) {
        for (auto c1 : c) {
            for (auto r2 : r) {
                for (auto c2 : c) {
                    if (r1 == r2 && c1 == c2) {
                        continue;
                    }

                    swap(a[r1][c1], a[r2][c2]);

                    set<int> s;
                    s.insert(corr);

                    {
                        int sum = 0;
                        for (int j = 1; j <= n; j++) {
                            sum += a[r1][j];
                        }
                        s.insert(sum);
                    }

                    {
                        int sum = 0;
                        for (int j = 1; j <= n; j++) {
                            sum += a[r2][j];
                        }
                        s.insert(sum);
                    }

                    {
                        int sum = 0;
                        for (int i = 1; i <= n; i++) {
                            sum += a[i][c1];
                        }
                        s.insert(sum);
                    }

                    {
                        int sum = 0;
                        for (int i = 1; i <= n; i++) {
                            sum += a[i][c2];
                        }
                        s.insert(sum);
                    }

                    if (s.size() == 1) {
                        cout << r1 << " " << c1 << "\n" << r2 << " " << c2 << "\n";
                        return;
                    }

                    swap(a[r1][c1], a[r2][c2]);
                }
            }
        }
    }

    if (!r.empty()) {
        int sum1, sum2;
        sum1 = sum2 = 0;

        for (int j = 1; j <= n; j++) {
            sum1 += a[r[0]][j];
            sum2 += a[r[1]][j];
        }

        for (int j = 1; j <= n; j++) {
            set<int> s;
            s.insert(corr);
            s.insert(sum1 - a[r[0]][j] + a[r[1]][j]);
            s.insert(sum2 - a[r[1]][j] + a[r[0]][j]);
            if (s.size() == 1) {
                cout << r[0] << " " << j << "\n" << r[1] << " " << j;
                return;
            }
        }
    } else {
        int sum1, sum2;
        sum1 = sum2 = 0;

        for (int i = 1; i <= n; i++) {
            sum1 += a[i][c[0]];
            sum2 += a[i][c[1]];
        }

        for (int i = 1; i <= n; i++) {
            set<int> s;
            s.insert(corr);
            s.insert(sum1 - a[i][c[0]] + a[i][c[1]]);
            s.insert(sum2 - a[i][c[1]] + a[i][c[0]]);
            if (s.size() == 1) {
                cout << i << " " << c[0] << "\n" << i << " " << c[1];
                return;
            }
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}