#include <bits/stdc++.h>

using namespace std;
#define int long long
const size_t nMax = 5e3 + 228, mod = 1e9 + 7;

int binpow(int n, int m) {
    int res = 1;
    while (m) {
        if (m & 1) {
            res = (res * n) % mod;
        }

        n = (n * n) % mod;
        m >>= 1;
    }

    return res;
}

struct mint {
    int value = 0;

    mint() {}

    mint(int val) : value(val) {}

    mint operator+(mint oth) {
        auto rese = value + oth.value;
        if (rese >= mod)rese -= mod;
        return {rese};
    }

    mint operator-(mint oth) {
        auto rese = value - oth.value;
        if (rese < 0)rese += mod;
        return {rese};
    }

    mint operator*(mint oth) {
        int rese = (value * oth.value) % mod;
        return {rese};
    }

    mint operator/(mint oth) {
        return *this * mint(binpow(oth.value, mod - 2));
    }
};

int ask(int id, string s) {
    cout << "? " << id << ' ' << s << endl;
    int ans;
    cin >> ans;
    return ans;
}

void solve() {
    int n;
    cin >> n;
    if (!n)exit(0);
    string res(n, 'a');
    for (int i = 0; i < n; i += 3) {
        if (n - i < 3)break;
        int aAns, bAns;
        aAns = ask(i + 1, "aa");
        bAns = ask(i + 1, "bb");
        if (aAns == 2 || bAns == 2) {
            if (aAns == 2) {
                res[i] = res[i + 1] = 'a';
            } else {
                res[i] = res[i + 1] = 'b';
            }
            int a2Ans, b2Ans;
            a2Ans = ask(i + 2, "ca");
            b2Ans = ask(i + 2, "cb");
            if (a2Ans) {
                res[i + 2] = 'a';
            } else if (b2Ans) {
                res[i + 2] = 'b';
            } else {
                res[i + 2] = 'c';
            }
            continue;
        }
        if (aAns == 0 && bAns == 0) {
            res[i] = res[i + 1] = 'c';
            int a2Ans, b2Ans;
            a2Ans = ask(i + 2, "aa");
            b2Ans = ask(i + 2, "ab");
            if (a2Ans) {
                res[i + 2] = 'a';
            } else if (b2Ans) {
                res[i + 2] = 'b';
            } else {
                res[i + 2] = 'c';
            }
            continue;
        }
        pair<char, char> good;
        if (aAns == 1 && bAns == 1)good = {'a', 'b'};
        if (aAns == 1 && bAns == 0)good = {'a', 'c'};
        if (aAns == 0 && bAns == 1)good = {'b', 'c'};
        auto ans1 = ask(i + 2, good.first + string("a"));
        if (ans1 == 2) {
            res[i] = good.second;
            res[i + 1] = res[i + 2] = good.first;
            continue;
        }
        if (ans1 == 0) {
            res[i] = good.first;
            res[i + 1] = good.second;
            auto ans2 = ask(i + 2, good.first + string("b"));
            if (ans2)
                res[i + 2] = 'b';
            else res[i + 2] = 'c';
            continue;
        }
        if (ans1 == 1) {
            auto ans2 = ask(i + 2, good.first + string("b"));
            if (ans2 == 1) {
                res[i] = good.second;
                res[i + 1] = good.first;
                res[i + 2] = 'c';
            }
            if (ans2 == 2) {
                res[i] = good.second;
                res[i + 1] = good.first;
                res[i + 2] = 'b';
            }
            if (ans2 == 0) {
                res[i] = good.first;
                res[i + 1] = good.second;
                res[i + 2] = 'a';
            }
        }
    }
    if (n % 3 == 1) {
        int askA = ask(n - 1, res[n - 2] + string("a"));
        int askB = ask(n - 1, res[n - 2] + string("b"));
        if (askA == 2)res[n - 1] = 'a';
        else if (askB == 2)res[n - 1] = 'b';
        else res[n - 1] = 'c';
    }
    if (n % 3 == 2) {
        int askA = ask(n - 1, "aa");
        int askB = ask(n - 1, "bb");
        if (askA == 2) {
            res[n - 2] = res[n - 1] = 'a';
        } else if (askB == 2) {
            res[n - 2] = res[n - 1] = 'b';
        } else if (askA == 0 && askB == 0) {
            res[n - 2] = res[n - 1] = 'c';
        } else {
            pair<char, char> good;
            if (askA == 1 && askB == 1)good = {'a', 'b'};
            if (askA == 1 && askB == 0)good = {'a', 'c'};
            if (askA == 0 && askB == 1)good = {'b', 'c'};
            int ans = ask(n - 1, string(1, good.first) + good.second);
            if (ans == 2) {
                res[n - 2] = good.first;
                res[n - 1] = good.second;
            } else {
                res[n - 1] = good.first;
                res[n - 2] = good.second;
            }
        }

    }
    cout << "! " << res << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    while (true)
        solve();
    return 0;
}
