#include <bits/stdc++.h>

#define int long long
#define ld long double
using namespace std;

constexpr int N = 2e5;
vector<int> g[N];
int p[N], h[N];
bool leave[N];

void dfs(int v) {
    leave[v] = true;
    for (auto &u: g[v]) {
        if (p[v] != u) {
            leave[v] = false;
            h[u] = h[v] + 1;
            dfs(u);
        }
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    p[0] = -1, h[0] = 0;
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[i].emplace_back(p[i]);
        g[p[i]].emplace_back(i);
    }
    dfs(0);
    int depthest = -1, closer = -1;
    for (int i = 0; i < n; i++) {
        if (!leave[i])
            continue;
        if (depthest == -1 || h[depthest] < h[i])
            depthest = i;
        if (closer == -1 || h[closer] > h[i])
            closer = i;
    }
    vector<int> way;
    for (int i = closer; i != -1; i = p[i])
        way.emplace_back(i);
    reverse(way.begin(), way.end());
    int cur = 0, cnt = 1;
    for (int i = 0; i < h[depthest] - 1; i++) {
        cur = (cur + 1) % ((int) way.size());
        cnt += leave[way[cur]];
        if (cur == (int) way.size() - 1)
            cur = 0;
    }
    cout << cnt;
    return 0;
}
