#include <bits/stdc++.h>

#define int long long
#define ld long double
using namespace std;


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    vector <vector <int>> a(n, vector<int>(n));
    for (int r = 0; r<n; ++r) {
        for (int c = 0; c<n; ++c) cin >> a[r][c];
    }

    int s = (n * (n*n+1)) >> 1;
    vector <int> inc_c;
    vector <int> inc_r;
    vector <int> row_sums(n);
    vector <int> col_sums(n);
    for (int r = 0; r<n; ++r) {
        int cur = 0;
        for (int c = 0; c<n; ++c) cur += a[r][c];
        if (cur != s) inc_r.push_back(r);
        row_sums[r] = cur;
    }
    for (int c = 0; c<n; ++c) {
        int cur = 0;
        for (int r = 0; r<n; ++r) cur += a[r][c];
        if (cur != s) inc_c.push_back(c);
        col_sums[c] = cur;
    }
    if (inc_c.size() > 0) {
        if (inc_r.size() > 0) {
            int r1 = inc_r[0];
            int r2 = inc_r[1];
            int c1 = inc_c[0];
            int c2 = inc_c[1];
            int sr1 = row_sums[r1];
            int sr2 = row_sums[r2];
            int sc1 = col_sums[c1];
            int sc2 = col_sums[c2];
            int delta = a[r1][c1] - a[r2][c2];
            sr1 -= delta;
            sr2 += delta;
            sc1 -= delta;
            sc2 += delta;
            if (sr1 == s && sr2 == s && sc1 == s && sc2 == s) {
                cout << r1+1 << ' ' << c1+1 << ' ' << r2+1 << ' ' << c2+1 << endl;
                exit(0);
            }
            swap(r1, r2);
            sr1 = row_sums[r1];
            sr2 = row_sums[r2];
            sc1 = col_sums[c1];
            sc2 = col_sums[c2];
            delta = a[r1][c1] - a[r2][c2];
            sr1 -= delta;
            sr2 += delta;
            sc1 -= delta;
            sc2 += delta;
            if (sr1 == s && sr2 == s && sc1 == s && sc2 == s) {
                cout << r1+1 << ' ' << c1+1 << ' ' << r2+1 << ' ' << c2+1 << endl;
                exit(0);
            }
        }
        else {
            int c1 = inc_c[0];
            int c2 = inc_c[1];
            for (int r = 0; r<n; ++r) {
                int sc1 = col_sums[c1];
                int sc2 = col_sums[c2];
                int sr = row_sums[r];
                int delta = a[r][c1] - a[r][c2];
                sc1 -= delta;
                sc2 += delta;
                if (sr == s && sc1 == s && sc2 == s) {
                    cout << r+1 << ' ' << c1+1 << ' ' << r+1 << ' ' << c2+1 << endl;
                    exit(0);
                }
            }
        }
    }
    else {
        if (inc_r.size() > 0) {
            int r1 = inc_r[0];
            int r2 = inc_r[1];
            for (int c = 0; c<n; ++c) {
                int sr1 = row_sums[r1];
                int sr2 = row_sums[r2];
                int sc = col_sums[c];
                int delta = a[r1][c] - a[r2][c];
                sr1 -= delta;
                sr2 += delta;
                if (sc == s && sr1 == s && sr2 == s) {
                    cout << r1+1 << ' ' << c+1 << ' ' << r2+1 << ' ' << c+1 << endl;
                    exit(0);
                }
            }
        }
    }

    return 0;
}
