#include "bits/stdc++.h"

using namespace std;
using ll = long long;

#define all(a) a.begin(), a.end()

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}
const ll MOD = 1e9+7;

struct Node{
    ll mnp, mns;
    ll ans, sm;
    Node() : mnp(1e18), mns(0), ans(0), sm(0) {}
    Node(ll a, ll b) : mnp(a), mns(0), ans(0), sm(a - b) {}
    Node operator+(const Node& a) const{
        if (a.mnp == 1e18) return *this; //
        if (mnp == 1e18) return a;
        Node res = Node();
        res.sm = sm+a.sm;
        ll f[4];//////
        f[0] = min(0ll, mnp + a.mns) + ans + a.ans;
        f[1] = min(0ll, mnp + a.mns) + ans + a.ans + (mns + a.mnp);
        f[2] = min(0ll, sm + a.mnp + a.mns) + a.ans;
        f[3] = min(0ll, mnp + mns + a.sm) + ans;
        ll i = min_element(f, f + 4) - f;
        if (f[i] == f[3]){
            res.mnp = mnp;
            res.mns = mns + a.sm;
            res.ans = ans;
        }
        else if (f[i] == f[2]){
            res.mnp = sm + a.mnp;
            res.mns = a.mns;
            res.ans = a.ans;
        }else if (f[i] == f[1]){
            res.mnp = mnp;
            res.mns = a.mns;
            res.ans = ans + a.ans + (mns + a.mnp);
        }else if (f[i] == f[0]){
            res.mnp = mnp;
            res.mns = a.mns;
            res.ans = ans + a.ans;
        }


        return res;
    }
    ll get(){
        return min(sm, ans + min(mnp + mns, 0ll));
    }
};

Node t[800000];
ll sz = 1;

void build(vector<ll>& a, vector<ll>& b){
    ll n = a.size();
    while(sz < n) sz *= 2;
    fill(t, t + sz * 2, Node());
    for (ll i = 0;i<n;i++)
        t[sz+i]=Node(a[i], b[i]);
    for (ll i = sz-1;i>=1;i--){
        t[i]=t[i*2]+t[i*2+1];
    }
}

void change(ll i, ll a, ll b){
    t[sz+i] = Node(a, b);
    ll v = (sz + i) / 2;
    while(v > 0){
        t[v]=t[v*2]+t[v*2+1];
        v/=2;
    }
}

Node get(ll lx, ll rx, ll v = 1, ll l = 0, ll r = sz){
    if (lx <= l && r <= rx) return t[v];
    if (lx >= r || l >= rx) return Node();
    ll m = (l+r)/2;
    return get(lx, rx, v * 2, l, m) + get(lx, rx, v*2+1, m, r);
}

void solve() {
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n, 0), b(n, 0);
    for (ll i = 0;i<n;i++){
        cin >> a[i];
    }
    for (ll i = 0;i<n - 1;i++){
        cin >> b[i];
    }
    build(a, b);
    while(q--){
        ll cc;
        cin >> cc;
        if (cc == 1){
            ll i, x;
            cin >> i >> x;
            a[i-1]=x;
            change(i-1, a[i-1], b[i-1]);
        }else if (cc == 2){
            ll i, x;
            cin >> i >> x;
            b[i-1]=x;
            change(i-1, a[i-1], b[i-1]);
        }else{
            ll l, r, x;
            cin >> l >> r >> x;
            l--, r--;
            change(r, a[r], x);
            cout << -get(l, r + 1).get() << "\n";
            change(r, a[r], b[r]);
        }
    }
}
