#include "bits/stdc++.h"

using namespace std;
using ll = long long;

#define all(a) a.begin(), a.end()

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}

const ll MOD = 1e9+7;

ll binpow(ll a, ll n){
    ll ans = 1;
    while(n > 0){
        if (n & 1) ans = (ans * a) % MOD;
        a=(a*a)%MOD;
        n>>=1;
    }
    return ans;
}

const ll N= 2e5;
ll fact[N];

void solve() {
    fact[0]=1;
    for (ll i = 1;i<N;i++){
        fact[i]=(fact[i-1]*i)%MOD;
    }
    ll n;
    cin >> n;
    vector<ll> a(n);
    ll cnt[3];
    fill(cnt, cnt + 3, 0);
    for (ll i = 0;i<n;i++){
        cin >> a[i];
        cnt[a[i] % 3]++;
    }
    ll ans0 = 0;
    if (cnt[1] > 0){
        ll cnt1 = cnt[1] - 1, cnt2 = cnt[2];
        ll sm = 1;
        while(cnt1 > 0 || cnt2 > 0){
            if (sm == 1){
                if (cnt1 == 0) break;
                sm = 2;
                cnt1--;
            }else{
                if (cnt2 == 0) break;
                sm = 1;
                cnt2--;
            }
        }
        ans0 += (cnt1 == 0 && cnt2 == 0);
    }
    if (cnt[2] > 0){
        ll cnt1 = cnt[1], cnt2 = cnt[2] - 1;
        ll sm = 2;
        while(cnt1 > 0 || cnt2 > 0){
            if (sm == 1){
                if (cnt1 == 0) break;
                sm = 2;
                cnt1--;
            }else{
                if (cnt2 == 0) break;
                sm = 1;
                cnt2--;
            }
        }
        ans0 += (cnt1 == 0 && cnt2 == 0);
    }
    for (ll i = 1;i<=cnt[1];i++) ans0 = (ans0 * i) % MOD;
    for (ll i = 1;i<=cnt[2];i++) ans0 = (ans0 * i) % MOD;
    for (ll i = cnt[1]+cnt[2];i<cnt[1]+cnt[2]+cnt[0];i++) ans0=(ans0 * i) % MOD;
    cout << ans0 << "\n";
}
