#include <iostream>
#include <vector>
#include<cmath>
#include<algorithm>
#include<map>
#include<unordered_map>

using namespace std;

#define int long long
#define fir first
#define sec second
#define endl '\n'
#define pii pair<int,int>
#define all(u) u.begin(), u.end()
#define rall(u) u.rbegin(), u.rend()
#define pb push_back

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	vector<vector<int>> vc(n, vector<int>(n));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			cin >> vc[i][j];
		}
	}


	if (n > 6) {
		vector<int> stl(n), str(n);
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				stl[j] += vc[i][j];
				str[i] += vc[i][j];
			}
		}

		unordered_map<int, int> mpstl, mpstr;

		for (int i = 0; i < n; i++) {
			mpstl[stl[i]]++;
			mpstr[str[i]]++;
		}
		
		int tstl = 0, tstr = 0;

		for (auto u : mpstr) {
			if (u.second > mpstr[tstr])
				tstr = u.first;
		}
		for (auto u : mpstl) {
			if (u.second > mpstl[tstl])
				tstl = u.first;
		}

		vector<int> hui1, hui2;

		for (int i = 0; i < n; i++) {
			if (stl[i] != tstl)
				hui1.pb(i);
			if (str[i] != tstr)
				hui2.pb(i);
		}

		if (hui2.size() == 0) {
			int qw = str[0];
			int a = stl[hui1[0]], b = stl[hui1[1]];

			for (int i = 0; i < n; i++) {
				if (a - vc[i][hui1[0]] + vc[i][hui1[1]] == qw && b + vc[i][hui1[0]] - vc[i][hui1[1]] == qw) {
					cout << i + 1 << " " << hui1[0] + 1 << endl << i + 1 << " " << hui1[1] + 1;
					return 0;
				}
			}
		}

		if (hui1.size() == 0) {
			int qw = stl[0];
			int  a = str[hui2[0]], b = str[hui2[1]];

			for (int i = 0; i < n; i++) {
				if (a - vc[hui2[0]][i] + vc[hui2[1]][i] == qw && b + vc[hui2[0]][i] - vc[hui2[1]][i] == qw) {
					cout << hui2[0] + 1 << " " << i + 1 << endl << hui2[1] + 1 << " " << i + 1;
					return 0;
				}
			}
		}

		for (int i1 : hui2) {
			for (int i2 : hui2) {
				for (int j1 : hui1) {
					for (int j2 : hui1) {

						swap(vc[i1][j1], vc[i2][j2]);

						vector<int> stl(n, 0);
						vector<int> str(n, 0);;
						for (int i = 0; i < n; i++) {
							for (int j = 0; j < n; j++) {
								stl[j] += vc[i][j];
								str[i] += vc[i][j];
							}
						}

						if (i1 == 0 && j1 == 0 && i2 == 2 && j2 == 2)
							int ko = 0;
						int a = stl[0];
						bool flag = 1;
						for (int i = 0; i < n; i++) {
							if (a != stl[i] || a != str[i])
								flag = 0;
						}
						if (!flag)
							swap(vc[i1][j1], vc[i2][j2]);
						else {
							cout << i1 + 1 << " " << j1 + 1 << endl << i2 + 1 << " " << j2 + 1;
							return 0;
						}

					}
				}
			}
		}
	}
	

	if (n <= 6) {
		for (int i1 = 0; i1 < n; i1++) {
			for (int j1 = 0; j1 < n; j1++) {
				for (int i2 = 0; i2 < n; i2++) {
					for (int j2 = 0; j2 < n; j2++) {
						swap(vc[i1][j1], vc[i2][j2]);

						vector<int> stl(n, 0);
						vector<int> str(n, 0);;
						for (int i = 0; i < n; i++) {
							for (int j = 0; j < n; j++) {
								stl[j] += vc[i][j];
								str[i] += vc[i][j];
							}
						}

						int a = stl[0];
						bool flag = 1;
						for (int i = 0; i < n; i++) {
							if (a != stl[i] || a != str[i])
								flag = 0;
						}
						if (!flag)
							swap(vc[i1][j1], vc[i2][j2]);
						else {
							cout << i1 + 1 << " " << j1 + 1 << endl << i2 + 1 << " " << j2 + 1;
							return 0;
						}
					}
				}
			}
		}
	}



}