#include <iostream>
#include <vector>
#include<cmath>
#include<algorithm>
#include<map>
#include<unordered_map>

using namespace std;

#define int long long
#define fir first
#define sec second
#define endl '\n'
#define pii pair<int,int>
#define all(u) u.begin(), u.end()
#define rall(u) u.rbegin(), u.rend()
#define pb push_back

const int MOD = 1e9 + 7;

int bp(int x, int n) {
    if (n == 0)
        return 1;
    if (n == 1)
        return x;
    if (n & 1)
        return (x * bp(x, n - 1)) % MOD;
    else
        return bp(x * x, n / 2) % MOD;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vector<int> vc(n);

    vector<int> cnt(3);
    for (int i = 0; i < n; i++) {
        cin >> vc[i];
        cnt[vc[i] % 3]++;
    }

    if (abs(cnt[1] - cnt[2]) > 2) {
        cout << 0;
        return 0;
    }

    int ans = 0;

    /*for (int i = 2; i < cnt[1]; i++) {
        ans *= i;
        ans %= MOD;
    }

    for (int i = 2; i < cnt[2]; i++) {
        ans *= i;
        ans %= MOD;
    }

    for (int i = 2; i < cnt[0]; i++) {
        ans *= i;

    }*/

    if (cnt[1] - 1 - cnt[2] >= 0) {
        //cnt[1]--;
        int res = 1;
        for (int i = 2; i <= cnt[1]; i++) {
            res *= i;
            res %= MOD;
        }

        for (int i = 2; i <= cnt[2]; i++) {
            res *= i;
            res %= MOD;
        }

        int k = cnt[1] + cnt[2];
        for (int i = 1; i <= cnt[0]; i++) {
            res *= i;
            res %= MOD;

            res *= k;
            res %= MOD;
        }
        ans += res;
        ans %= MOD;
        //cnt[1]++;
    }

    if (cnt[2] - 1 - cnt[1] >= 0) {
        //cnt[2]--;
        int res = 1;
        for (int i = 2; i <= cnt[1]; i++) {
            res *= i;
            res %= MOD;
        }

        for (int i = 2; i <= cnt[2]; i++) {
            res *= i;
            res %= MOD;
        }

        int k = cnt[1] + cnt[2];

        for (int i = 1; i <= cnt[0]; i++) {
            res *= i;
            res %= MOD;

            res *= k;
            res %= MOD;
        }
        ans += res;
        ans %= MOD;
    }

    cout << ans;
    return 0;
}