#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <map>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>

#define mp make_pair

using namespace std;
typedef long long i64;
typedef long long ll;
#define int long long

const int MAXN = 5009;
const int MOD = 1e9 + 7, INF = 1e9;

const i64 md = 1e9 + 7;

const i64 S = 1007;
i64 dp[S][S], dp1[S][S];

i64 cnt(i64 k, i64 less) {
	if (dp[k][less]) return dp[k][less];
	if (less > k) {
		return dp[k][less] = cnt(k, k);
	}
	if (less == 1) {
		dp[k][less] = 1;
		return dp[k][less];
	}
	for (i64 y = less; y >= 1; --y) {
		dp[k][less] += cnt(k - y, y);
		dp[k][less] %= md;
	}
	return dp[k][less];
}

i64 cnt1(i64 k, i64 more) {
	if (dp1[k][more]) return dp1[k][more];
	if (k == 0) {
		return dp[k][more] = 1;
	}
	if (more == k) {
		return dp1[k][more] = 1;
	}
	if (more > k) {
		return 0;
	}
	for (i64 y = more; y <= k; ++y) {
		dp1[k][more] += cnt1(k - y, y);
		dp1[k][more] %= md;
	}
	return dp1[k][more];
}

signed main()
{
	
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
#endif // _DEBUG

	i64 a; cin >> a;

	for (i64 x = 1; x <= a + 5; ++x) {
		for (i64 y = 1; y <= a + 5; ++y) {
			dp[x][y] = cnt(x, y);
		}
	}

	for (i64 x = 0; x <= a + 5; ++x) {
		dp[0][x] = 1;
	}

	for (i64 x = 1; x <= a + 5; ++x) {
		for (i64 y = 1; y <= a + 5; ++y) {
			dp1[x][y] = cnt1(x, y);
		}
	}

	for (i64 x = 0; x <= a + 5; ++x) {
		dp1[0][x] = 1;
	}

	i64 ans = 0;

	for (i64 t = 1; t <= a + 1; ++t) {
		for (i64 sum = 0; sum <= a; ++sum) {
			i64 it = dp[sum][t - 1];
			if (a - sum - t * (t - 1) / 2 < 0) continue;
			i64 it1 = dp1[a - sum - t * (t - 1) / 2][t + 1];
			ans = (ans + ((t * it) % md * it1) % md) % md;
		}
	}

	cout << ans;
}