#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)in >> i;
    return in;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const pair<T1, T2> &a) {
    out << a.first << ' ' << a.second;
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &i: a)out << i << '\n';
    return out;
}


void solve() {
    ll n;
    cin >> n;
    vector<vector<ll>> a(n, vector<ll>(n));
    cin >> a;
    ll s = n * (n * n + 1) / 2;
    vector<ll> h(n, 0);
    vector<ll> c(n, 0);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            c[i] += a[i][j];
            h[i] += a[j][i];
        }
    }
    vector<pair<ll, ll>> ans;
    for (int i = 0; i < n; i++) {
        if (c[i] != s) {
            for (int j = 0; j < n; j++) {
                if (h[j] != s && h[j] == c[i]) {
                    ans.emplace_back(i + 1, j + 1);
                    break;
                }
            }
        }
    }
    if (ans.size() == 2) {
        cout << ans;
        return;
    }
    ans.clear();
    for (int i = 0; i < n; i++) {
        if (c[i] != s) {
            ans.emplace_back(i, i);
        }
    }
    if (ans.size() == 2) {
        ll x = c[ans[0].first];
        ll i1 = ans[0].first;
        ll i2 = ans[1].first;
        for (int i = 0; i < n; i++) {
            if (x - a[i1][i] + a[i2][i] == s) {
                cout << vector<pair<ll, ll>>
                        {{i1 + 1, i + 1},
                         {i2 + 1, i + 1}};
                return;
            }
        }
    }
    ans.clear();
    for (int i = 0; i < n; i++) {
        if (h[i] != s) {
            ans.emplace_back(i, i);
        }
    }
    if (ans.size() == 2) {
        ll x = h[ans[0].first];
        ll i1 = ans[0].first;
        ll i2 = ans[1].first;
        for (int i = 0; i < n; i++) {
            if (x - a[i][i1] + a[i][i2] == s) {
                cout << vector<pair<ll, ll>>
                        {{i + 1, i1 + 1},
                         {i + 1, i2 + 1}};
                break;
            }
        }
    }
}

signed main() {
#ifdef Local
    freopen("in.in", "r", stdin);
    freopen("out.out", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    ll t = 1;
    //cin>>t;
    while (t--) solve();
}
