#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pp = pair<int, int>;

ll check(ll x, ll a, ll b, ll c) {
    if (x < 5) return a;
    else if (x < 10) return b;
    else return c;
}

template<typename t>
istream &operator>>(istream &din, vector<t> &a) {
    for (t &e : a) {
        din >> e;
    }
    return din;
}

int main() {
    ll n;
    cin >> n;
    vector<vector<ll>> a(n, vector<ll>(n));
    cin >> a;
    vector<ll> r(n), c(n);
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < n; j++) {
            r[i] += a[i][j];
            c[j] += a[i][j];
        }
    }
    ll exp = (n * n) * (n * n + 1) / 2 / n;
    ll r1 = -1, r2 = -1, c1 = -1, c2 = -1;
    for (ll i = 0; i < n; i++) {
        if (r[i] < exp) r1 = i;
        if (r[i] > exp) r2 = i;
        if (c[i] < exp) c1 = i;
        if (c[i] > exp) c2 = i;
    }
    if (r1 == -1) {
        ll d = exp - c[c1];
        for (ll i = 0; i < n; i++) {
            if (a[i][c2] - a[i][c1] == 2 * d) {
                r1 = r2 = i;
                break;
            }
        }
    } else if (c1 == -1) {
        ll d = exp - r[r1];
        for (ll i = 0; i < n; i++) {
            if (a[r2][i] - a[r1][i] == 2 * d) {
                c1 = c2 = i;
            }
        }
    }
    cout << r1 + 1 << ' ' << c1 + 1 << '\n' << r2 + 1 << ' ' << c2 + 1 << '\n';
}
