#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<algorithm>
#include<cmath>
#include<vector>
#include<string>
#include<set>
#include<map>
#define int long long


using namespace std;
using ll = long long;
#define all(a) a.begin(), a.end()

void solve() {
	int n;
	cin >> n;
	vector<vector<int>> a(n, vector<int>(n, 0));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			cin >> a[i][j];
		}
	}
	vector<int> sum_strock(n, 0);
	vector<int> sum_stolb(n, 0);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			sum_strock[i] += a[i][j];
			sum_stolb[j] += a[i][j];
		}
	}
	int a1 = max_element(sum_strock.begin(), sum_strock.end()) - sum_strock.begin();
	int b1 = max_element(sum_stolb.begin(), sum_stolb.end()) - sum_stolb.begin();
	int a2 = min_element(sum_strock.begin(), sum_strock.end()) - sum_strock.begin();
	int b2 = min_element(sum_stolb.begin(), sum_stolb.end()) - sum_stolb.begin();
	if (sum_strock[a1] != sum_strock[a2] && sum_stolb[b1] != sum_stolb[b2])
	{
		cout << a1 + 1 << " " << b1 + 1 << "\n";
		cout << a2 + 1 << " " << b2 + 1 << "\n";
	}
	else {
		pair<pair<int, int>, pair<int, int>> ans;
		if (sum_strock[a1] == sum_strock[a2]) {
			int raz = sum_stolb[b1] - sum_stolb[b2];
			raz /= 2;
			for (int i = 0; i < n; ++i) {
				if (abs(a[i][b1] - a[i][b2]) == raz) {
					ans = { {i,b1},{i,b2} };
					break;
				}
			}
		}
		else {
			int raz = sum_strock[a1] - sum_strock[a2];
			raz /= 2;
			for (int i = 0; i < n; ++i) {
				if (abs(a[a1][i] - a[a2][i]) == raz) {
					ans = { {a1,i},{a2,i} };
					break;
				}
			}
		}
		cout << ans.first.first+1 << ' ' << ans.first.second+1 << '\n';
		cout << ans.second.first+1 << ' ' << ans.second.second+1 << '\n';
	}
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // _DEBUG

	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}