#include <iostream>
#include <vector>

using namespace std;

const int m = 1000000007;

int main() {
    int n;
    cin >> n;

    vector <vector <int>> dp(n, vector <int> (n + 1));
    dp[0][0] = 1;
    for (int k = 1; k < n; ++k) {
        for (int x = 0; x <= n; ++x) {
            dp[k][x] = dp[k - 1][x];
            if (x >= 1) {
                dp[k][x] += dp[k - 1][x - 1];
                dp[k][x] %= m;
            }
            if (x >= 2) {
                dp[k][x] += dp[k - 1][x - 2];
                dp[k][x] %= m;
            }
        }
    }

    int s = 1;
    for (int i = 1; i < n; ++i) {
        s = (long long) s * dp[i][i + 1] % m;
    }

    cout << s << '\n';
}
