#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;
typedef long long ll;

int n;
vector <vector <int>> g;
vector <int> mnd, dp, h;
vector <map <int, int>> s;

void getmnd(int v) {
	for (auto i : g[v]) {
		h[i] = h[v] + 1;
		getmnd(i);
		mnd[v] = min(mnd[v], mnd[i]);
	}
	if (g[v].size() == 0) mnd[v] = 0;
	else mnd[v]++;
}

void dfs(int v) {
	for (auto i : g[v]) {
		dfs(i);
		if (s[i].size() > s[v].size()) swap(s[i], s[v]);
		for (auto j : s[i]) {
			s[v][j.first] = max(s[v][j.first], j.second);
		}
	}
	if (g[v].size() == 0) dp[v] = 0;
	else {
		if (s[v].find(h[v] + mnd[v]) == s[v].end()) dp[v] = 0;
		else dp[v] = s[v][h[v] + mnd[v]] + 1;
	}
	s[v][h[v]] = dp[v];
}

int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	cin >> n;
	g.resize(n), mnd.resize(n, 1e9), dp.resize(n), h.resize(n), s.resize(n);
	for (int i = 1; i < n; i++) {
		int x; cin >> x; x--;
		g[x].push_back(i);
	}
	h[0] = 0;
	getmnd(0);
	dfs(0);
	cout << dp[0];
	return 0;
}