#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;
typedef long long ll;

int n;
ll mod = 1e9 + 7;

int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	cin >> n;
	vector <vector <ll>> dp(n + 2, vector <ll>(2 * n + 6, 0));
	for (int i = 0; i <= n; i++) dp[i][0] = 1;
	for (int i = 1; i <= n; i++) {
		for (int sum = 0; sum <= 2 * i; sum++) {
			dp[i][sum] = dp[i - 1][sum];
			if (sum - 1 >= 0) dp[i][sum] += dp[i - 1][sum - 1];
			if (sum - 2 >= 0) dp[i][sum] += dp[i - 1][sum - 2];
			dp[i][sum] %= mod;
		}
	}
	ll ans = 1;
	for (int i = 1; i < n; i++) {
		ans *= dp[i][i + 1];
		ans %= mod;
	}
	cout << ans;
	return 0;
}