#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <cmath>

using namespace std;
using ll = long long;

ll mod = 1e9 + 7;

int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	int n; cin >> n;
	ll ans = 0;
	for (int mex = 1; mex <= 35; mex++) {
		if (mex * (mex - 1) / 2 > n) break;
		vector <vector <ll>> dppref(1001, vector <ll>(1001, 0)), dpsuf(1002, vector <ll>(1001, 0));
		dppref[0][0] = 1;
		for (int i = 1; i <= 1000; i++) {
			for (int sum = (i * (i + 1) / 2); sum <= 1000; sum++) {
				for (int kol = 1;; kol++) {
					if (sum - i * kol < (i - 1) * i / 2) break;
					dppref[i][sum] += dppref[i - 1][sum - i * kol];
				}
				dppref[i][sum] %= mod;
			}
		}
		dpsuf[1001][0] = 1;
		for (int i = 1000; i >= 1; i--) {
			for (int sum = 0; sum <= 1000; sum++) {
				for (int kol = 0;; kol++) {
					if (sum - i * kol < 0) break;
					dpsuf[i][sum] += dpsuf[i + 1][sum - i * kol];
				}
				dpsuf[i][sum] %= mod;
			}
		}
		for (int sum = mex * (mex - 1) / 2; sum <= 1000; sum++) {
			if (n - sum < 0) break;
			ans += (mex * dppref[mex - 1][sum] % mod) * dpsuf[mex + 1][n - sum] % mod;
			ans %= mod;
		}
	}
	cout << ans;
	return 0;
}
