#include <iostream>
#include <algorithm>
#include <set>
#include <vector>
#include <map>

using namespace std;
#define ll long long
#define vll vector<ll>
#define vi vector<int>
#define eol '\n'
#define Fastio(){ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);}

#define print(arr){for(auto x: arr){cout << x << " ";} cout << '\n';}
const int mod = 1e9 + 7;

ll binpowmod(ll a, ll n) {
    if (n < 0) return 0;
    if (a == 0) return 0;
    if (n == 0) return 1;
    if (n & 1) return a * binpowmod(a, n - 1) % mod;
    ll d = binpowmod(a, n >> 1);
    return d * d % mod;
}

void solve_d() {
    int n;
    cin >> n;
    int C[100][100];
    ll dp[100];
    C[0][0] = 1;
    for (int i = 1; i <= n; i++) {
        C[i][0] = 1;
        for (int k = 1; k <= i; k++) {
            C[i][k] = (C[i - 1][k - 1] + C[i - 1][k]) % mod;
        }
    }

    dp[0] = 0;
    dp[1] = 1;
    dp[2] = 1;
    dp[3] = 2;
    for (int i = 4; i <= n; i++) {
        ll sm = 0;
        for (int k = 1; k <= i / 2; ++k){
            int one = i - 2*k;
            sm = (sm + C[i-1][k] * C[i - k - 1][one] % mod) % mod;
        }
        dp[i] = sm * dp[i - 1] % mod;
    }

    cout << dp[n];
}


int main() {
//    Fastio();
    solve_d();
}
