#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <queue>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
using vint = vector<int>;
#define all(x) x.begin(), x.end()
#define rep(x) for(int ri = 0; ri < x; ++ri)
#define int long long

const int INF = 2e9 + 7;
const long long LINF = 1e18 + 7;
const int MOD = 1e9 + 7;

ll fact(ll x) {
	ll ans = 1, k = 2;
	while (k <= x) {
		ans *= k;
		ans %= MOD;
		++k;
	}
	return ans;
}
int binpow(int a, int n) {
	if (!n)
		return 1;
	if (n % 2)
		return 1LL * binpow(a, n - 1) * a;
	int ans = binpow(a, n / 2);
	return 1LL * ans * ans;
}

signed main() {
	//ios_base::sync_with_stdio(0); cin.tie(0);
	cout.precision(10);
	int n;
	cin >> n;
	int l = 0, r = 3e12; // r = 1e18 + 1;
	int ln = 0;
	while (r - l > 1) {
		int m = (r + l) / 2;
		cout << "? " << m << endl;
		cin >> ln;
		if (ln == n) {
			l = m;
		}
		else r = m;
	}
	int d = l;
	l = d; r = 1e18 + 1;
	while (r - l > 1) {
		int m = (l + r) / 2;
		cout << "? " << m << endl;
		cin >> ln;
		if (ln <= n + 1) {
			l = m;
		}
		else r = m;
	}
	int dl = (l - d);
	int b = 0;
	for (int i = 2; i < 2024; i++) {
		if ((i - 1) * binpow(i, n) == dl) {
			b = i;
			break;
		}
	}
	cout << "! " << binpow(b, n) - d - 1  << ' ' << b << endl;

}