#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

vector <vector<ll>> r;
vector <ll> g;

void dfs(ll v, ll p) {
    if (r[v].size() == 1 && v!=0) g[v] = 0;
    for (ll y : r[v]) {
        if (y == p) continue;
        dfs(y, v);
        g[v] = min(g[v], 1+g[y]);
    }
}

ll PB(ll v, ll p, ll h);

ll F(ll v, ll p) {
    if (g[v] == 0) return 1;
    ll s = 0;
    for (ll y : r[v]) {
        if (y == p) continue;
        s = max(s, PB(y, v, g[v] - 1));
    }
    return s+1;
}

ll PB(ll v, ll p, ll h) {
    ll s = 0;
    if (h) {
        for (ll y : r[v]) {
            if (y == p) continue;
            s = max(s, PB(y, v, h-1));
        }
        return s;
    }
    return F(v, p);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, i, l;
    cin >> n;
    r.resize(n);
    g.resize(n, 9999999);
    for (i = 1; i < n; i++) {
        cin >> l;
        l--;
        r[l].push_back(i);
        r[i].push_back(l);
    }
    dfs(0, -1);
    cout << F(0, -1)-1;
    return 0;
}
