#include <algorithm>
#include <iostream>
#include <vector>

#define int long long

bool check(int n, const std::vector<std::vector<int>>& a) {
    int sumst = 0;
    for (int i = 0; i < n; i++) {
        sumst += a[i][0];
    }
    int csum;
    for (int i = 0; i < n; i++) {
        csum = 0;
        for (int j = 0; j < n; j++) {
            csum += a[i][j];
        }
        if (csum != sumst) {
            return false;
        }
    }
    for (int j = 0; j < n; j++) {
        csum = 0;
        for (int i = 0; i < n; i++) {
            csum += a[i][j];
        }
        if (csum != sumst) {
            return false;
        }
    }
    return true;
}

void solvesq(int n, std::vector<std::vector<int>> a) {
    for (int i1 = 0; i1 < n; i1++) {
        for (int j1 = 0; j1 < n; j1++) {
            for (int i2 = 0; i2 < n; i2++) {
                for (int j2 = 0; j2 < n; j2++) {
                    if (i1 == i2 && j1 == j2) {
                        continue;
                    }
                    std::swap(a[i1][j1], a[i2][j2]);
                    if (check(n, a)) {
                        std::cout << i1 + 1 << ' ' << j1 + 1 << '\n' << i2 + 1 << ' ' << j2 + 1 << '\n';
                        return;
                    }
                    std::swap(a[i1][j1], a[i2][j2]);
                }
            }
        }
    }
}

signed main() {
    int n;
    std::cin >> n;
    std::vector<std::vector<int>> a(n, std::vector<int>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            std::cin >> a[i][j];
        }
    }
    if (n <= 10) {
        solvesq(n, a);
        return 0;
    }
    std::vector<int> allsums;
    for (int i = 0; i < n; i++) {
        int csum = 0;
        for (int j = 0; j < n; j++) {
            csum += a[i][j];
        }
        allsums.emplace_back(csum);
    }
    for (int j = 0; j < n; j++) {
        int csum = 0;
        for (int i = 0; i < n; i++) {
            csum += a[i][j];
        }
        allsums.emplace_back(csum);
    }
    std::sort(allsums.begin(), allsums.end());
    int goodsum = (n * (n * n + 1)) / 2;
    int i1 = -1;
    int i2 = -1;
    int j1 = -1;
    int j2 = -1;
    for (int i = 0; i < n; i++) {
        int csum = 0;
        for (int j = 0; j < n; j++) {
            csum += a[i][j];
        }
        if (csum != goodsum) {
            if (i1 == -1) {
                i1 = i;
            } else {
                i2 = i;
            }
        }
    }
    for (int j = 0; j < n; j++) {
        int csum = 0;
        for (int i = 0; i < n; i++) {
            csum += a[i][j];
        }
        if (csum != goodsum) {
            if (j1 == -1) {
                j1 = j;
            } else {
                j2 = j;
            }
        }
    }
    if (i1 == -1) {
        int j1sum = 0;
        int j2sum = 0;
        for (int i = 0; i < n; i++) {
            j1sum += a[i][j1];
            j2sum += a[i][j2];
        }
        for (int i = 0; i < n; i++) {
            if (j1sum - a[i][j1] + a[i][j2] == j2sum - a[i][j2] + a[i][j1]) {
                i1 = i;
            }
        }
    }
    if (j1 == -1) {
        int i1sum = 0;
        int i2sum = 0;
        for (int j = 0; j < n; j++) {
            i1sum += a[i1][j];
            i2sum += a[i2][j];
        }
        for (int j = 0; j < n; j++) {
            if (i1sum - a[i1][j] + a[i2][j] == i2sum - a[i2][j] + a[i1][j]) {
                j1 = j;
            }
        }
    }
    if (i2 == -1) {
        i2 = i1;
    }
    if (j2 == -1) {
        j2 = j1;
    }
    std::swap(a[i1][j1], a[i2][j2]);
    if (!check(n, a)) {
        std::swap(a[i1][j1], a[i2][j2]);
        std::swap(j1, j2);
    }
    std::cout << i1 + 1 << ' ' << j1 + 1 << '\n';
    std::cout << i2 + 1 << ' ' << j2 + 1 << '\n';
    return 0;
}