#include <iostream>
#include <vector>

int getres(int csum, int a, int b, int c) {
    if (csum == 0) {
        return 0;
    }
    if (csum < 5) {
        return a;
    } else if (csum < 10) {
        return b;
    } else {
        return c;
    }
}

int main() {
    std::vector<int> x(3);
    std::cin >> x[0] >> x[1] >> x[2];
    int a, b, c;
    std::cin >> a >> b >> c;
    int minres = 1000000000;
    for (unsigned mask = 0; mask < (1u << 3); mask++) {
        for (unsigned mask2 = mask;; mask2 = (mask2 - 1) & mask) {
            int sum1 = 0, sum2 = 0, sum3 = 0;
            for (int i = 0; i < 3; i++) {
                if ((mask >> i) & 1) {
                    if ((mask2 >> i) & 1) {
                        sum1 += x[i];
                    } else {
                        sum2 += x[i];
                    }
                } else {
                    sum3 += x[i];
                }
            }
            int cres = getres(sum1, a, b, c) + getres(sum2, a, b, c) + getres(sum3, a, b, c);
            minres =  std::min(minres, cres);
            if (mask2 == 0) {
                break;
            }
        }
    }
    std::cout << minres << '\n';
    return 0;
}