#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <stack>
#include <set>

using namespace std;

#define ll long long
#define vll vector<ll>
#define pll pair<ll,ll>
#define FOR(i,a,b) for(ll i = (a); i < (b); ++i)
#define vvll vector<vll>


void speed()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
}

int main()
{
	speed();
	ll n;
	cin >> n;
	ll b;
	ll x;
	ll l = 1, r = 1e18;
	while (l < r)
	{
		ll mid = (l + r) / 2;
		cout << "? " << mid << endl;
		ll a;
		cin >> a;
		if (a > n)
		{
			r = mid;
		}
		else
		{
			l = mid + 1;
		}
	}
	n++;
	ll d1 = l;
	l = d1, r = min(d1 * 2023, (ll)1e18);
	while (l < r)
	{
		ll mid = (l + r) / 2;
		cout << "? " << mid << endl;
		ll a;
		cin >> a;
		if (a > n)
		{
			r = mid;
		}
		else
		{
			l = mid + 1;
		}
	}
	ll d2 = l - d1;
	l = 0, r = d2;
	while (l < r)
	{
		ll mid = (l + r) / 2;
		if (pow(mid, n) * (mid - 1) >= d2)
		{
			r = mid;
		}
		else
		{
			l = mid + 1;
		}
	}
	b = l;
	ll x1 = pow(b, n - 1);
	x = x1 - d1;
	cout << "! " << x << " " << b << endl;

}