#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;

const int INF = 1e9;

vector<vector<int>> g;
vector<multiset<pii>> dp;
vector<multiset<int>> depths;

void dfs(int v, int h) {
    int mxD = -1, mxDp = -1;
    bool leaf = true;
    for (auto to : g[v]) {
        leaf = false;
        dfs(to, h + 1);
        if (mxD == -1 || depths[to].size() > depths[mxD].size()) {
            mxD = to;
        }
        if (mxDp == -1 || dp[to].size() > dp[mxDp].size()) {
            mxDp = to;
        }
    }
    if (leaf) {
        depths[v].insert(h);
        dp[v].insert({h, 0});
        return;
    }
    swap(depths[v], depths[mxD]);
    swap(dp[v], dp[mxDp]);
    for (auto to : g[v]) if (to != mxD) {
        while (!depths[to].empty()) {
            depths[v].insert(*depths[to].begin());
            depths[to].erase(depths[to].begin());
        }
    }
    for (auto to : g[v]) if (to != mxDp) {
        while (!dp[to].empty()) {
            dp[v].insert(*dp[to].begin());
            dp[to].erase(dp[to].begin());
        }
    }
    //cout << v + 1 << ": ";
    //for (auto el: dp[v]) {
    //    cout << el.first << " " << el.second << "    ";
    //}
    //cout << endl;
    int mnd = *depths[v].begin();
    auto it = dp[v].lower_bound({mnd + 1, -1});
    int dpv = (*(--it)).second + 1;
    dp[v].insert(make_pair(h, dpv));
}

int main() {
    int n;
    cin >> n;
    g.resize(n);
    dp.resize(n);
    depths.resize(n);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        g[p - 1].push_back(i);
    }
    dfs(0, 0);
    cout << (*dp[0].begin()).second;
}

