#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define S second
#define F first
const int maxn = 2e5;
vector<int> g[maxn];
vector<int> byD[maxn];
int dp[maxn], leaf[maxn];

void dfs(int v) {
    if (g[v].empty()) {
        dp[v] = 0;
        leaf[v] = 0;
        byD[v] = {0};
        return;
    }
    leaf[v] = maxn + 10;
    for (const int& u : g[v]) {
        dfs(u);
        leaf[v] = min(leaf[v], leaf[u]);
        if ((int) byD[v].size() < (int) byD[u].size()) {
            byD[v].swap(byD[u]);
        }
        for (int i = 0; i < (int) byD[u].size(); ++i) {
            byD[v][i] = max(byD[v][i], byD[u][i]);
        }
        byD[u].clear();
    }
    ++leaf[v];
    byD[v].emplace_back();
    dp[v] = 1 + byD[v][(int)byD[v].size() - 1 - leaf[v]];
    byD[v].back() = dp[v];
    /*cerr << "v: " << v << ", " << leaf[v] << '\n';
    for (const int& i : byD[v]) {
        cerr << i << ' ';
    }
    cerr << '\n';*/
}

const ll mod = 1e9 + 7;
ll fact[100010], revfact[100010];

ll binpow(ll n, ll k) {
    if (k == 0)
        return 1;
    ll ret = binpow(n, k / 2);
    ret = ret * ret % mod;
    if (k % 2 == 1)
        ret = ret * n % mod;
    return ret;
}

ll f(ll i) {
    ll ret = 1;
    for (ll c = i % 2; c <= i; c += 2) {
        ret *= fact[i] * revfact[c] % mod * revfact[(i + 1 - c) / 2] % mod * revfact[i - c - (i + 1 - c) / 2] % mod;
        ret %= mod;
    }
    return ret;
}

void solve() {
    fact[0] = 1;
    for (ll i = 1; i <= 100000; i++)
        fact[i] = fact[i - 1] * i % mod;
    revfact[100000] = binpow(fact[100000], mod - 2);
    for (int i = 100000; i > 0; i--)
        revfact[i - 1] = revfact[i] * i % mod;
    int n;
    cin >> n;
    ll ans = 1;
    for (int i = 1; i < n; i++)
        ans = ans * f(i) % mod;
    cout << ans << endl;
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
