#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define nl endl
#else
#define nl '\n'
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define forn(i, n) for (decltype(n) i = 0; i < n; i++)
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define ll long long
#define ull unsigned long long
#define ld long double
#define _ <<" "<<

template <typename T> using ordered_set = trie<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

void solve(){
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    forn(i, n - 1){
        int p;
        cin >> p;
        g[p - 1].push_back(i + 1);
    }


    vector<int> near(n, 1e9), deep(n);
    function<void(int, int)> dfs = [&](int v, int d){
        deep[v] = d;
        if (g[v].empty()) near[v] = d;
        else for (int to : g[v]) dfs(to, d + 1), near[v] = min(near[v], near[to]);
    };
    dfs(0, 0);

    function<int(int, int)> f = [&](int v, int d){
        if (g[v].empty()) return 0;
        int mx = 0;
        vector<int> to_check;

        queue<int> q;
        q.push(v);
        while(!q.empty()){
            auto u = q.front();
            q.pop();
            if (deep[u] == near[v]) to_check.push_back(u);
            else for (int to : g[u]) q.push(to);
        }

        for (int u : to_check) mx = max(mx, f(u, near[v]) + 1);
        return mx;
    };

    cout << f(0, 0) << nl;
}

signed main(){
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cout << fixed << setprecision(15);

    int tt = 1;
//    cin >> tt;
    while(tt--) solve();
}

