#include <bits/stdc++.h>
using namespace std;
#define int long long
#define ll long long
#define all(x) x.begin(), x.end()
#define eb emplace_back
#define pb push_back

bool check(vector<vector<int>> &a, int n) {
    vector<int> sum1(n), sum2(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            sum1[i] += a[i][j];
            sum2[j] += a[i][j];
        }
    }
    sort(all(sum1));
    sort(all(sum2));
    return sum1.front() == sum1.back() && sum2.front() == sum2.back() && sum1.front() == sum2.front();
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int> (n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
        }
    }
    if (check(a, n)) {
        cout << "1 1\n1 1\n";
        return;
    }
    vector<int> sum1(n), sum2(n);
    for (int i = 0; i < n; i++)  {
        for (int j = 0; j < n; j++) {
            sum1[i] += a[i][j];
            sum2[j] += a[i][j];
        }
    }
    int res = (1 + n * n) * n * n / (2 * n);
    int x1 = -1, y1 = -1, x2 = -1, y2 = -1;
    for (int i = 0; i < n; i++) {
        if (sum1[i] != res && x1 == -1)
            x1 = i;
        else if (sum1[i] != res)
            x2 = i;
    }
    for (int i = 0; i < n; i++) {
        if (sum2[i] != res && y1 == -1)
            y1 = i;
        else if (sum2[i] != res)
            y2 = i;
    }
    if (x1 == -1) {
        int d = abs(sum2[y1] - sum2[y2]);
        for (int i = 0; i < n; i++) {
            if (2 * abs(a[i][y1] - a[i][y2]) == d) {
                x1 = i, x2 = i;
            }
        }
    }
    else if (y1 == -1) {
        int d = abs(sum1[x1] - sum1[x2]);
        for (int i = 0; i < n; i++) {
            if (2 * abs(a[x1][i] - a[x2][i]) == d) {
                y1 = i, y2 = i;
            }
        }
    }
    else {
        swap(a[x1][y1], a[x2][y2]);
        if (!check(a, n))
            swap(x1, x2);
    }
    cout << x1 + 1 << " " << y1 + 1 << endl;
    cout << x2 + 1 << " " << y2 + 1 << endl;
}

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(0);
    int T = 1;
    //cin >> T;
    while (T--)
        solve();
    return 0;
}

//3
//8 9 2
//3 5 7
//4 1 6