#include <iostream>
#include <string>
#include <vector>

#include <map>

const int none = 1000;

int main()
{
	std::map<char, int> map;
	for (int i = 0; i < 26; i++)
		map[i + 'a'] = none;
	std::string s;
	std::cin >> s;
	int size;
	std::cin >> size;
	while (size--)
	{
		char a;
		int b;
		std::cin >> a >> b;
		map[a] = b;
	}
	std::vector<int> count(26);
	long long res = 0;
	for (auto i : s)
	{
		count[i - 'a']++;
	}
	for (int i = 0; i < count.size(); i++)
	{
		char c = i + 'a';
		if (map[c] == none)
		{
			res += count[i];
			continue;
		}
		long long l = -1, r = 1000000000;
		while (r - l > 1)
		{
			int m = (r + l) / 2;
			int cnt = m - m / map[i + 'a'] - (m % map[c] > 0);
			if (cnt >= count[i])
				r = m;
			else
				l = m;
		}
		res += r;
	}
	std::cout << res << '\n';
	return 0;
}