#include <bits/stdc++.h>

#define int long long
#define p_b push_back
#define f first
#define s second
using namespace std;

set<pair<int, int> > have;

int r[2], c[2];

map<int, pair<int, int> > rr, cc;

void add_cube(int x, int y){
    r[x % 2] -= max(rr[x].first, rr[x].second);
    c[y % 2] -= max(cc[y].first, cc[y].second);
    if (y % 2 == 0)
        rr[x].first ++;
    else
        rr[x].second ++;
    if (x % 2 == 0)
        cc[y].first ++;
    else
        cc[y].second ++;
    r[x % 2] += max(rr[x].first, rr[x].second);
    c[y % 2] += max(cc[y].first, cc[y].second);
}

void remove_cube(int x, int y){
    r[x % 2] -= max(rr[x].first, rr[x].second);
    c[y % 2] -= max(cc[y].first, cc[y].second);
    if (y % 2 == 0)
        rr[x].first --;
    else
        rr[x].second --;
    if (x % 2 == 0)
        cc[y].first --;
    else
        cc[y].second --;
    r[x % 2] += max(rr[x].first, rr[x].second);
    c[y % 2] += max(cc[y].first, cc[y].second);
}

main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int q;
    cin >> q;
    while (q --) {
        int x, y;
        cin >> x >> y;
        if (have.find({x, y}) == have.end()) {
            have.insert({x, y});
            add_cube(x, y);
        } else  {
            have.erase({x, y});
            remove_cube(x, y);
        }

//        cout << r[0] << ' ' << r[1] << ' ' << c[0] << ' ' << c[1] << '\n';
        cout << max(max(r[0], r[1]), max(c[0], c[1])) << '\n';
    }

    return 0;
}

/*
7
1 1
2 2
6 2
4 4
1 4
2 5
2 6

1
1
2
3
4
4
5
*/
