#include <bits/stdc++.h>
using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
using ll = long long;
using ld = long double;

// ARGHHHHHHHHHHHHHHHH
// ARGHHHHHHHHHHHHHHHH

int32_t main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(false);

	int n;
	cin >> n;

	vector<vector<int>> v(n, vector<int>(n));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			cin >> v[i][j];
		}
	}

	vector<pair<int, int>> pos;

	if (n <= 10) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				pos.emplace_back(i, j);
			}
		}
	} else {
		unordered_map<ll, int> cnt;
		for (int i = 0; i < n; i++) {
			ll t = 0;
			for (int j = 0; j < n; j++) {
				t += v[i][j];
			}
			cnt[t]++;
		}
		for (int j = 0; j < n; j++) {
			ll t = 0;
			for (int i = 0; i < n; i++) {
				t += v[i][j];
			}
			cnt[t]++;
		}
		ll rl;
		ll mxb = -1;
		for (auto [a, b] : cnt) {
			if (b >= mxb) {
				rl = a;
				mxb = b;
			}
		}

		vector<int> h1, h2;
		for (int i = 0; i < n; i++) {
			ll t = 0;
			for (int j = 0; j < n; j++) {
				t += v[i][j];
			}
			if (t != rl) {
				h1.push_back(i);
			}
		}
		for (int j = 0; j < n; j++) {
			ll t = 0;
			for (int i = 0; i < n; i++) {
				t += v[i][j];
			}
			if (t != rl) {
				h2.push_back(j);
			}
		}

		if (h1.empty() || h2.empty()) {
			if (h1.empty()) {
				ll s1 = 0;
				ll nado = 0;
				for (int i = 0; i < n; i++) nado += v[0][i];
				ll s2 = 0;
				for (int i = 0; i < n; i++) s1 += v[i][h2[0]], s2 += v[i][h2[1]];
				for (int i = 0; i < n; i++) {
					ll last1 = s1;
					ll last2 = s2;
					s1 = s1 - v[i][h2[0]] + v[i][h2[1]];
					s2 = s2 - v[i][h2[1]] + v[i][h2[0]];
					if (s1 == s2 && s2 == nado) {
						cout << i + 1 << " " << h2[0] + 1 << "\n" << i + 1 << " " << h2[1] + 1 << "\n";
						return 0;
					}
					s1 = last1;
					s2 = last2;
				}
			} else {
				ll s1 = 0;
				ll nado = 0;
				for (int i = 0; i < n; i++) nado += v[i][0];
				ll s2 = 0;
				for (int i = 0; i < n; i++) s1 += v[h1[0]][i], s2 += v[h1[1]][i];
				for (int i = 0; i < n; i++) {
					ll last1 = s1;
					ll last2 = s2;
					s1 = s1 - v[h1[0]][i] + v[h1[1]][i];
					s2 = s2 - v[h1[1]][i] + v[h1[0]][i];
					if (s1 == s2 && s2 == nado) {
						cout << h1[0] + 1 << " " << i + 1 << "\n" << h1[1] + 1 << " " << i + 1 << "\n";
						return 0;
					}
					s1 = last1;
					s2 = last2;
				}
			}
			assert(false);
		}

		for (int i : h1) {
			for (int j : h2) {
				pos.emplace_back(i, j);
			}
		}
	}

	auto check = [&](int x, int y) {
		swap(v[pos[x].first][pos[x].second], v[pos[y].first][pos[y].second]);
		ll last = -1;
		for (int i = 0; i < n; i++) {
			ll t = 0;
			for (int j = 0; j < n; j++) {
				t += v[i][j];
			}
			if (last == -1) last = t;
			else if (last != t) {
				swap(v[pos[x].first][pos[x].second], v[pos[y].first][pos[y].second]);
				return false;
			}
			last = t;
		}
		for (int j = 0; j < n; j++) {
			ll t = 0;
			for (int i = 0; i < n; i++) {
				t += v[i][j];
			}
			if (last == -1) last = t;
			else if (last != t) {
				swap(v[pos[x].first][pos[x].second], v[pos[y].first][pos[y].second]);
				return false;
			}
			last = t;
		}
		swap(v[pos[x].first][pos[x].second], v[pos[y].first][pos[y].second]);
		return true;
	};

	for (int i = 0; i < pos.size(); i++) {
		for (int j = i + 1; j < pos.size(); j++) {
			if (check(i, j)) {
				cout << pos[i].first + 1 << " " << pos[i].second + 1 << "\n";
				cout << pos[j].first + 1 << " " << pos[j].second + 1 << "\n";
				return 0;
			}
		}
	}

	assert(false);

	return 0;
}