#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using dl = double long;
using ull = unsigned long long;


const ll MM = 2023LL * 2023LL * 1000000000LL;
ll mpow(ll a, int b){
    if(b == 1) return a;
    if((b & 1) == 1){
        return min((mpow(a, b - 1) * a), MM);
    }
    return mpow(min(MM, a) * a, b >> 1);
}

void solve(){
    int sqd, inp;
    ll l = 0, r = 10000000000LL * 2023LL;
    cin >> sqd;
    while(r - l > 1){
        ll m = (l + r) / 2;
        cout << "? " << m << endl;
        cin >> inp;
        if(inp > sqd) r = m;
        else l = m;
    }

    int bl = 1, br = 2024;
    while(br - bl > 1){
        int m = (bl + br) / 2;
        if((ull)r + (ull)(m - 1) * mpow(m, sqd) >= MM) br = m;
        cout << "? " << r + (m - 1) * mpow(m, sqd) << endl;
        cin >> inp;
        if(inp <= sqd + 1){
            bl = m;
        }
        else{
            br = m;
        }
    }
    cout << "! " << mpow(br, sqd) - r << ' ' << br << endl;

}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
