#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define sz(v) (int)v.size()
#define all(x) x.begin(), x.end()

typedef long long ll;
typedef pair<int, int> pii;

const int INF = 1e9 + 42;

vector<int> dp, to;
vector<vector<int>> g;

void dfs(int v, int p, int dep) {
    if (dep > 0) {
        for (auto u : g[v])
            if (u != p) {
                dfs(u, v, dep - 1);
                dp[v] = max(dp[v], dp[u]);
            }
        return;
    }

    for (auto u : g[v])
        if (u != p) {
            dfs(u, v, to[v] - 1);
            dp[v] = max(dp[v], dp[u] + 1);
        }
}

void solve() {
    int n;
    cin >> n;
    g.assign(n, {});
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        g[i].push_back(p);
        g[p].push_back(i);
    }

    to.assign(n, INF);
    deque<int> q;
    for (int i = 0; i < n; ++i)
        if (i != 0 && g[i].size() == 1) {
            q.push_back(i);
            to[i] = 0;
        }
    while (!q.empty()) {
        int v = q[0];
        q.pop_front();

        for (auto u : g[v])
            if (to[u] > to[v] + 1) {
                to[u] = to[v] + 1;
                q.push_back(u);
            }
    }

    dp.assign(n, 0);

    dfs(0, 0, 0);

    cout << dp[0] << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}