#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define sz(v) (int)v.size()
#define all(x) x.begin(), x.end()

typedef long long ll;
typedef pair<int, int> pii;

const int INF = 1e9 + 42;

vector<int> dp, to;
vector<vector<int>> g;

void dfs(int v, int p, int dep) {
    if (dep > 0) {
        for (auto u : g[v])
            if (u != p) {
                dfs(u, v, dep - 1);
                dp[v] = max(dp[v], dp[u]);
            }
        return;
    }

    for (auto u : g[v])
        if (u != p) {
            dfs(u, v, to[v] - 1);
            dp[v] = max(dp[v], dp[u] + 1);
        }
}

void get_to(int v, int p) {
    if (g[v].size() == 1 && v != p)
        to[v] = 0;

    for (auto u : g[v])
        if (u != p) {
            get_to(u, v);
            to[v] = min(to[v], to[u] + 1);
        }
}

void solve() {
    int n;
    cin >> n;
    g.assign(n, {});
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        g[i].push_back(p);
        g[p].push_back(i);
    }

    to.assign(n, INF);
    get_to(0, 0);
    /*
    for (auto i : to)
        cout << i << " ";
    cout << endl;
    */
    dp.assign(n, 0);
    dfs(0, 0, 0);

    cout << dp[0] << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}