#include <bits/stdc++.h>

using namespace std;

#define int long long

typedef long long ll;

const ll MOD = 1'000'000'007;

constexpr int maxn = 2e5 + 5;

vector<int> g[maxn];

int d[maxn], mn_d[maxn], dp[maxn];

map<int, int> dp_d[maxn];
int pos[maxn];

int t = 0;

void dfs(int v) {
    mn_d[v] = maxn;
    pos[v] = v;
    for (auto u : g[v]) {
        dfs(u);
        mn_d[v] = min(mn_d[v], mn_d[u]);
        if (dp_d[pos[u]].size() > dp_d[pos[v]].size()) {
            pos[v] = pos[u];
        }
    }
    if (g[v].empty()) {
        mn_d[v] = d[v];
        dp[v] = 0;
        dp_d[pos[v]][d[v]] = 0;
        return;
    }
    for (auto u : g[v]) {
        if (pos[u] != pos[v]) {
            for (auto [h, vl] : dp_d[pos[u]]) {
                dp_d[pos[v]][h] = max(dp_d[pos[v]][h], vl);
            }
        }
    }
    dp[v] = 1 + dp_d[pos[v]][mn_d[v]];
    dp_d[pos[v]][d[v]] = dp[v];
}

void solve() {
    int n;
    cin >> n;
    vector<int> pr(n);
    for (int i = 1; i < n; ++i) {
        int prv;
        cin >> prv;
        prv--;
        pr[i] = prv;
        g[prv].push_back(i);
        d[i] = d[prv] + 1;
    }
    dfs(0);
    cout << dp[0] << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
