#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MOD = 1e9 + 7;

vector <int> t (1e6, 0);
vector <int> cnt (1e6, 0);

void build(int i) {
    t[i] = max(t[i * 2 + 1], t[i * 2 + 2]);
}
void build2(int i) {
    cnt[i] = cnt[i * 2 + 1] + cnt[i * 2 + 2];
}

void update(int i, int l, int r, int ind, int val) {
    if (l + 1 == r) {
        t[i] = val;
        return;
    }
    int m = (l + r) / 2;
    if (l <= ind && ind < m) {
        update(i * 2 + 1, l, m, ind, val);
    }
    else {
        update(i * 2 + 2, m, r, ind, val);
    }
    build(i);
}
void update2(int i, int l, int r, int ind, int val) {
//    cout << l << " " << r << "\n";
    if (l + 1 == r) {
        cnt[i] = val;
        return;
    }
    int m = (l + r) / 2;
    if (l <= ind && ind < m) {
        update2(i * 2 + 1, l, m, ind, val);
    }
    else {
        update2(i * 2 + 2, m, r, ind, val);
    }
    build2(i);
}
int get (int i, int l,int r, int L, int R) {
    if (L <= l && r <= R) {
//        cout << l << " " << r << " " << cnt[i] << "\n";
        return t[i];
    }
    if (R <= l || r <= L) {
        return 0;
    }
    int m = (l + r) / 2;
    return max(get(i * 2 + 1,l, m, L, R), get(2 * i + 2, m, r, L, R));
}
int get2 (int i, int l,int r, int L, int R) {
    if (L <= l && r <= R) {
        return cnt[i];
    }
    if (R <= l || r <= L) {
        return 0;
    }
    int m = (l + r) / 2;
    return get2(i * 2 + 1,l, m, L, R) + get2(2 * i + 2, m, r, L, R);
}
signed main()
{
//    cout << pow_(2, 2) << "\n"
//;
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);
    int n;
    cin >> n;
    string s;
    cin >> s;
    if (s[0] == 'b')
        update2(0, 0, n, 0, 1);
    for (int i = 1; i < n; i++) {
        if (s[i] == 'b' && s[i - 1] == 'b')
            update(0, 0, n, i, 1);
        if (s[i] == 'b')
            update2(0, 0, n, i, 1);
//        cout << "\1\n";
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        int a;
        cin >> a;
        if (a == 1) {
            int j;
            cin >> j;
            j--;
            if (s[j] == 'a') {
                s[j] = 'b';
            }
            else {
                s[j] = 'a';

            }
            if (j > 0 && s[j] == 'b' && s[j - 1] == 'b')
                update(0, 0, n, j, 1);

            else {
                update(0, 0, n, j, 0);
            }
            if (j + 1 < n && s[j] == 'b' && s[j + 1] == 'b')
                update(0, 0, n, j + 1, 1);

            else {
                update(0, 0, n, j + 1, 0);
            }
            if (s[j] == 'b')
                update2(0, 0, n, j, 1);
                else {
                    update2(0, 0, n, j, 0);
                }
        }
        else {
            int l, r;
            cin >> l >> r;
            if (l == r) {
                if (s[l - 1] == 'a') {
                    cout << "YES\n";
                    continue;
                }
                if (s[l - 1] == 'b') {
                    cout << "NO\n";
                    continue;
                }
            }
            l--;
//            cout << get(0, 0, n, l + 1, r)<< " " << get2(0, 0, n, l, r) << "\n";
            if (get(0, 0, n, l + 1, r) == 1) {
                cout << "NO\n";
                continue;
            }
            if (get2(0, 0, n, l, r) > (r - l) / 2) {
                cout << "NO\n";
                continue;
            }
            cout << "YES\n";
        }
    }
    return 0;
}
