#include <bits/stdc++.h>
using namespace std;

const int maxn = 200005;

int n, d[maxn], mindep[maxn], cnt[maxn], moved[maxn], needmove[maxn];
vector<int> g[maxn];

void dfs(int v, int dep) {
    d[v] = dep;
    for (auto u : g[v])
        dfs(u, dep + 1);
    mindep[v] = 2e9;
    if (g[v].empty())
        mindep[v] = d[v];
    for (auto u : g[v])
        mindep[v] = min(mindep[v], mindep[u]);
}

void calc(int v, int p) {
    if (v == 1)
        needmove[v] = mindep[v];
    for (auto u : g[v]) {
        cnt[u] = cnt[v];
        needmove[u] = needmove[v];
        moved[u] = moved[v] + 1;
        if (moved[u] >= needmove[u]) {
            cnt[u]++;
            moved[u] = 0;
            needmove[u] = mindep[u] - d[u];
        }
        calc(u, v);
    }
}

int main() {
    cin >> n;
    for (int i = 2; i <= n; i++) {
        int p;
        cin >> p;
        g[p].push_back(i);
    }
    dfs(1, 0);
    calc(1, 0);
    int ans = 0;
    for (int i = 1; i <= n; i++)
        ans = max(ans, cnt[i]);
    cout << ans << '\n';
}
