#include <iostream>
#include "bits/stdc++.h"

using namespace std;
using ll = long long;
#define int ll
#define str string
#define vec vector
int l1, l2, r1, r2;
int x1, x2, x3, x4;
int yy1, y2, y3, y4;
int MOD = 1e9 + 7;
void add(int x, int y, int add) {
    if ((x % 2 == 1) && (y % 2 == 1)) {
        l1 += add;
    }
    if ((x % 2 == 1) && (y % 2 == 0)) {
        l2 += add;
    }
    if ((x % 2 == 0) && (y % 2 == 1)) {
        r1 += add;
    }
    if ((x % 2 == 0) && (y % 2 == 0)) {
        r2 += add;
    }
    if ((x % 4 == 0 && y % 2 == 0) || (x % 4 == 2 && y % 2 == 1)) {
        x1 += add;
    }
    if ((x % 4 == 0 && y % 2 == 1) || (x % 4 == 2 && y % 2 == 0)) {
        x2 += add;
    }
    if ((x % 4 == 1 && y % 2 == 0) || (x % 4 == 3 && y % 2 == 1)) {
        x3 += add;
    }
    if ((x % 4 == 1 && y % 2 == 1) || (x % 4 == 3 && y % 2 == 0)) {
        x4 += add;
    }


    if ((y % 4 == 0 && x % 2 == 0) || (y % 4 == 2 && x % 2 == 1)) {
        yy1 += add;
    }
    if ((y % 4 == 0 && x % 2 == 1) || (y % 4 == 2 && x % 2 == 0)) {
        y2 += add;
    }
    if ((y % 4 == 1 && x % 2 == 0) || (y % 4 == 3 && x % 2 == 1)) {
        y3 += add;
    }
    if ((y % 4 == 1 && x % 2 == 1) || (y % 4 == 3 && x % 2 == 0)) {
        y4 += add;
    }
}

void solve() {
    int n; cin >> n;
    vector<vector<int>>dp(n + 1, vector<int>(n + 1));
    for(int j = 0; j <= n; j++) dp[0][j] = 1;
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= n; j++){
            for(int z = 0; z <= i / j; z++){
                dp[i][j] += dp[i - z * j][j - 1];
                dp[i][j] %= MOD;
            }
        }
    }
    int summer = 0; int ans = 0;
    for(int i = 1; i <= n + 1; i++){
        if(summer > n) break;
        int cnt = dp[n - summer][n];
        if(summer + i <= n){
            cnt -= dp[n - summer - i][n];
        }
        cnt = (cnt + MOD) % MOD;
        ans += i * cnt % MOD; ans %= MOD;
        summer += i;
    }
    cout << ans;
}

signed main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    solve();
    return 0;
}
