#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 2e5 + 10;

vector<int> g[MAXN];
int h[MAXN], dp[MAXN], mind[MAXN], maxd[MAXN];

void dfs(int v, int p = -1) {
    if (g[v].size() == 0) {
        mind[v] = 0;
        return;
    }
    mind[v] = 1e18;
    for (int to : g[v]) {
        if (to == p) {
            continue;
        }
        h[to] = h[v] + 1;
        dfs(to, v);
        mind[v] = min(mind[v], mind[to] + 1);
        maxd[v] = max(maxd[v], maxd[to] + 1);
    }
}

vector <map <int, int>> q(MAXN);

void dfsans(int v, int p = -1) {
    if (g[v].size() == 0) {
        dp[v] = 0;
        q[v][h[v]] = dp[v];
        return;
    }
    for (int to : g[v]) {
        if (to != p) {
            dfsans(to, v);
        }
        if (q[to].size() > q[v].size()) {
            for (auto [x, y] : q[v]) {
                if (q[to].find(x) == q[to].end() || q[to][x] < y) {
                    q[to][x] = y;
                }
            }
            swap(q[to], q[v]);
        } else {
            for (auto [x, y] : q[to]) {
                if (q[v].find(x) == q[v].end() || q[v][x] < y) {
                    q[v][x] = y;
                }
            }
        }
    }
    if (mind[v] != maxd[v]) {
        dp[v] = 1 + q[v][h[v] + mind[v]];
    }
    q[v][h[v]] = dp[v];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        g[p - 1].push_back(i);
    }
    dfs(0);
    dfsans(0);
    cout << 1 + dp[0] << '\n';
    return 0;
}