#include <bits/stdc++.h>

#define ll long long
#define int long long
#define F first
#define S second
using namespace std;

vector<vector<ll>> g;
vector<ll> dp, mpnum, dist, dist1;
vector<map<ll, ll>> mps;

ll merge(ll a, ll b) {
    if (mps[a].size() < mps[b].size())
        swap(a, b);

    for (auto &p: mps[b])
        if (!mps[a].count(p.F))
            mps[a][p.F] = p.S;
        else
            mps[a][p.F] = max(mps[a][p.F], p.S);
    return a;
}

pair<ll, ll> f1(ll u, ll depth) {
    if (g[u].empty()) {
        dist[u] = dist1[u] = depth;
        pair<ll, ll> ret = {depth, depth};
        return ret;
    }

    dist[u] = LLONG_MAX;
    dist1[u] = -1;
    for (ll v: g[u]) {
        auto p = f1(v, depth + 1);
        dist[u] = min(dist[u], p.F);
        dist1[u] = max(dist1[u], p.S);
    }
    return {dist[u], dist1[u]};
}

void dfs(ll u, ll depth) {
    for (ll v: g[u]) {
        dfs(v, depth + 1);
        dp[u] = max(dp[u], dp[v]);
        mpnum[u] = merge(mpnum[u], mpnum[v]);
    }

    if (dist[u] != dist1[u])
        dp[u] = max(dp[u], mps[mpnum[u]][dist[u]] + 1);
    mps[mpnum[u]][depth] = max(mps[mpnum[u]][depth], dp[u]);
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    ll n, h;
    cin >> n;
    g.resize(n);
    for (int i = 1; i < n; ++i) {
        cin >> h;
        g[h - 1].push_back(i);
    }
    mpnum.resize(n);
    mps.resize(n);
    iota(mpnum.begin(), mpnum.end(), 0);
    dist.resize(n);
    dist1.resize(n);
    dp.resize(n);

    f1(0, 0);
    dfs(0, 0);

    cout << dp[0] + 1;
    return 0;
}
/*
4
1 1 3

3
1 2

9
1 1 3 3 5 5 7 7

7
1 1 3 3 1 6

*/