#include <bits/stdc++.h>

#define ll long long
#define int long long
#define F first
#define S second
using namespace std;

ll mod = 1000000007;
unordered_map<ll, ll> dp;

ll fact(ll a) {
    if (dp.count(a))
        return dp[a];
    ll h = (fact(a - 1) * a) % mod;
    return h;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    dp[0] = 1;

    ll n, h, a0 = 0, a1 = 0, a2 = 0;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> h, h %= 3;
        if (h == 0)
            a0++;
        else if (h == 1)
            a1++;
        else if (h == 2)
            a2++;
    }

    if (abs(a1 - a2) >= 3 || a0 && !(a1 + a2) || a1 == a2) {
        cout << 0;
        return 0;
    }

    ll ans = 0;
    if (a1 >= a2) {
        ll h1 = 1;
        h1 = (h1 * fact(a1)) % mod;
        h1 = (h1 * fact(a2)) % mod;
        for (int i = 0; i < a0; ++i)
            h1 = (h1 * (a1 + a2 + i)) % mod;
        ans = h1;
    }
    if (a1 <= a2) {
        ll h1 = 1;
        h1 = (h1 * fact(a1)) % mod;
        h1 = (h1 * fact(a2)) % mod;
        for (int i = 0; i < a0; ++i)
            h1 = (h1 * (a1 + a2 + i)) % mod;
        ans = (ans + h1) % mod;
    }
    cout << ans;
    return 0;
}
/*
3
100 21 892

4
11 19 30 32

3
4 298 28

*/