#include <bits/stdc++.h>
using namespace std;
#define int long long
typedef long long ll;
typedef vector<int> vi;
const int mod = 1e9 + 7;
vector<vector<ll>> gr;
vector<ll> go;
void dfs1(int v , int pred = -1){
    go[v] = 1e9;
    for (auto el : gr[v]){
        dfs1(el);
        go[v] = min(go[v], go[el] + 1);
    }
    if (gr[v].empty()){
        go[v] = 0;
    }
}

vector<deque<int>> dp;

void dfs2(int v){
    dp[v] = {-ll(1e9)};
    for (auto el : gr[v]){
        dfs2(el);
        dp[el].push_front(0);
        if (dp[el].size() >= dp[v].size()){
            dp[v].swap(dp[el]);
        }
        for (int i = 0; i < dp[el].size(); i++){
            dp[v][i] = max(dp[v][i], dp[el][i]);
        }
        dp[el].clear();
    }
    ll h = go[v];
    dp[v][0] = max(dp[v][0], dp[v][h] + 1);
}

void run_case(){
    ll n;
    cin >> n;
    gr.resize(n);
    go.resize(n);
    dp.resize(n);
    for (int i = 1; i < n; i++){
        ll p ;
        cin >> p;
        p--;
        gr[p].push_back(i);
    }
    dfs1(0, -1);
    dfs2(0);
    cout << dp[0][0] + 1 << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    //cin >> tt;
    while(tt--)run_case();
}
