#include <bits/stdc++.h>

using namespace std;
#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
using pii = pair <int, int>;

template <typename t1, typename t2>
void mxr(t1& a, const t2& b) {
    if (b > a) {
        return a;
    }
}

bool check(const vector <vector <int> >& v) {
    int n = sz(v);
    vector <int> stolb(n), stroka(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            stolb[j] += v[i][j];
            stroka[i] += v[i][j];
//            hs[i].insert(v[i][j]);
//            hc[j].insert(v[i][j]);
        }
    }
    int sum = accumulate(all(stroka), 0ll);
    int needed = sum / n;
    vector <int> badstroka;
    for (int i = 0; i < n; ++i) {
        if (stroka[i] != needed) {
            badstroka.push_back(i);
        }
    }
    vector <int> badstolb;
    for (int j = 0; j < n; ++j) {
        if (stolb[j] != needed) {
            badstolb.push_back(j);
        }
    }
    return badstolb.empty() && badstroka.empty();
}

signed main() {
#ifdef BUY
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int n;
    cin >> n;
    vector <vector <int> > v(n, vector <int> (n));
    for (auto &i : v) {
        for (auto &j : i) {
            cin >> j;
        }
    }
    vector <int> stolb(n), stroka(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            stolb[j] += v[i][j];
            stroka[i] += v[i][j];
//            hs[i].insert(v[i][j]);
//            hc[j].insert(v[i][j]);
        }
    }
    int sum = accumulate(all(stroka), 0ll);
    int needed = sum / n;
    vector <int> badstroka;
    for (int i = 0; i < n; ++i) {
        if (stroka[i] != needed) {
            badstroka.push_back(i);
        }
    }
    vector <int> badstolb;
    for (int j = 0; j < n; ++j) {
        if (stolb[j] != needed) {
            badstolb.push_back(j);
        }
    }
    vector <pii> prikol;
    if (!badstroka.empty() && !badstolb.empty()) {
        for (auto i : badstroka) {
            for (auto j : badstolb) {
                prikol.emplace_back(i, j);
            }
        }
        for (int i = 0; i < sz(prikol); ++i) {
            for (int j = i + 1; j < sz(prikol); ++j) {
                pii f = prikol[i];
                pii s = prikol[j];
                swap(v[prikol[i].first][prikol[i].second], v[prikol[j].first][prikol[j].second]);
                if (check(v)) {
                    cout << f.first + 1 << " " << f.second + 1 << "\n";
                    cout << s.first + 1 << " " << s.second + 1 << "\n";
                    return 0;
                }
                swap(v[prikol[i].first][prikol[i].second], v[prikol[j].first][prikol[j].second]);
            }
        }
    } else if (!badstroka.empty()) {
        int p = badstroka[0], q = badstroka[1];
        for (int j = 0; j < n; ++j) {
            int sm1 = stroka[p] - v[p][j] + v[q][j];
            int sm2 = stroka[q] - v[q][j] + v[p][j];
            if (sm1 == sm2 && sm1 == needed) {
                cout << p + 1 << " " << j + 1 << "\n";
                cout << q + 1 << " " << j + 1 << "\n";
                return 0;
            }
        }
    } else {
        int p = badstolb[0], q = badstolb[1];
        for (int j = 0; j < n; ++j) {
            int sm1 = stolb[p] - v[j][p] + v[j][q];
            int sm2 = stolb[q] - v[j][q] + v[j][p];
            if (sm1 == sm2 && sm1 == needed) {
                cout << j + 1 << " " << p + 1 << "\n";
                cout << j + 1 << " " << q + 1 << "\n";
                return 0;
            }
        }
    }
}