#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAX_N = 2e5;

int tin[MAX_N], tout[MAX_N], timer = 0, to_list[MAX_N], high[MAX_N];
vector<int> g[MAX_N], dp(MAX_N, 0);
vector<vector<int>> h[MAX_N];

void get_tin(int v = 0, int now_h = 0) {
    tin[v] = timer++;
    high[v] = now_h;
    if (g[v].empty()) {
        to_list[v] = 0;
    } else {
        to_list[v] = 1e9;
    }
    for (int u : g[v]) {
        get_tin(u, now_h + 1);
        to_list[v] = min(to_list[v], to_list[u] + 1);
    }
    tout[v] = timer++;
    h[now_h].push_back({tin[v], tout[v], v});
}

void solve(int v = 0) {
    if (g[v].empty()) {
        dp[v] = 0;
        return;
    }
    for (int u : g[v]) {
        solve(u);
    }
    int need_dist = high[v] + to_list[v];
    if (need_dist < MAX_N) {
        vector<int> need = {tin[v], -1, -1};
        int ind = lower_bound(h[need_dist].begin(), h[need_dist].end(), need) - h[need_dist].begin();
        for (; ind < h[need_dist].size() && h[need_dist][ind][1] <= tout[v]; ind++) {
            dp[v] = max(dp[h[need_dist][ind][2]] + 1, dp[v]);
        }
    }
}

signed main() {
    //freopen("text.in", "r", stdin), freopen("text.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, i, p, ans = 0;
    cin >> n;
    for (i = 1; i < n; i++) {
        cin >> p;
        g[p - 1].push_back(i);
    }
    dp[0] = 0;
    get_tin(), solve();
    for (i = 0; i < n; i++) {
        ans = max(ans, dp[i]);
    }
    cout << ans;
}
