#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MOD = 1e9 + 7;

int factor(int n) {
    int ans = 1;
    for (int i = 2; i <= n; i++) {
        ans *= i;
        ans %= MOD;
    }
    return ans;
}

signed main() {
    //freopen("text.in", "r", stdin), freopen("text.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, i, j, ans = 1;
    cin >> n;
    vector<vector<int>> dp(n + 1, vector<int>(n + 1, 0));
    for (i = 1; i <= n; i++) {
        dp[i][0] = 0;
    }
    for (i = 0; i <= n; i++) {
        dp[0][i] = 1;
    }
    for (i = 1; i <= n; i++) {
        for (j = 1; j <= n; j++) {
            dp[i][j] = dp[i][j - 1] + dp[i - 1][j - 1];
            if (i > 1) {
                dp[i][j] += dp[i - 2][j - 1];
            }
            dp[i][j] %= MOD;
        }
    }
    for (i = 2; i <= n; i++) {
        ans *= dp[i][i - 1];
        ans %= MOD;
    }
    cout << ans;
}
