#include "bits/stdc++.h"

using namespace std;

#define int long long
#define vec vector
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rend(), (a).rbegin()

template<typename t>
istream& operator>>(istream& in, vector<t>& v) {
    for (auto& u: v) in >> u;
    return in;
}


void solve () {
    int n;
    cin >> n;
    map<int, pair<int, int>> dx, dy;
    set<pair<int, int>> st;
    int tx[2] = { 0, 0 }, ty[2] = { 0, 0 };
    for (int _ = 0; _ < n; ++_) {
        int x, y; cin >> x >> y;
        int pl;
        if (st.find({x, y}) == st.end()) {
            st.insert({x, y});
            pl = 1;
        }
        else {
            st.erase({x, y});
            pl = -1;
        }
        if (dx.find(x) == dx.end()) {
            dx[x] = { 0, 0 };
        }
        auto [ex, ox] = dx[x];
        tx[x % 2] -= max(ex, ox);
        if (y % 2 == 0) ex += pl;
        else ox += pl;
        dx[x] = {ex, ox};
        tx[x % 2] += max(ex, ox);

        if (dy.find(y) == dy.end()) {
            dy[y] = { 0, 0 };
        }
        auto [ey, oy] = dy[y];
        ty[y % 2] -= max(ey, oy);
        if (x % 2 == 0) ey += pl;
        else oy += pl;
        dy[y] = {ey, oy};
        ty[y % 2] += max(ey, oy);
        cout << max({tx[0], tx[1], ty[0], ty[1]}) << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}