// solution.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include<vector>
#include <algorithm>
#include <cmath>

using namespace std;
using ll = long long;

void solve() {

	int n;
	string s;
	cin >> s >> n;
	vector<ll> a(26, 1), cnt(26, 0);
	vector<bool> used(26, 0);
	for (int i = 0; i < n; ++i) {
		char c;
		int x;
		cin >> c >> x;
		a[c - 'a'] = x;
		used[c - 'a'] = 1;
	}
	ll ans = 0;
	for (char c : s) {
		if (!used[c - 'a']) {
			ans++;
		}
		else {
			if (cnt[c - 'a'] == 0) {
				cnt[c - 'a'] = a[c - 'a'] - 1;
				ans++;
			}
			cnt[c - 'a']--;
			ans++;
		}
	}
	cout << ans << '\n';
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(false);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}

}