// solution.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include<vector>
#include <algorithm>
#include <cmath>

using namespace std;
using ll = long long;
using vi = vector<ll>;

const int N = 1005;
ll a[N][N];
ll p[N];
ll v[N];

bool check(ll n) {
	ll s = n * n * (n * n + 1) / 2;
	s /= n;
	for (ll i = 0; i < n; ++i) {
		p[i] = 0;
		v[i] = 0;
	}
	for (ll i = 0; i < n; ++i) {
		for (ll j = 0; j < n; ++j) {
			p[i] += a[i][j];
			v[j] += a[i][j];
		}
	}
	return (max_element(p, p + n) - min_element(p, p + n) == 0 && max_element(v, v + n) - min_element(v, v + n) == 0);
}

void solve() {
	ll n;
	cin >> n;
	for (int i = 0; i < n; ++i)for (int j = 0; j < n; ++j) {
		cin >> a[i][j];
		p[i] += a[i][j];
		v[j] += a[i][j];
	}
	ll s = n * n * (n * n + 1) / 2;
	s /= n;
	vector<ll> pos, posv;
	for (int i = 0; i < n; ++i) {
		if (p[i] != s) {
			pos.push_back(i);
		}
		if (v[i] != s) {
			posv.push_back(i);
		}
	}
	if (pos.empty() && posv.empty()) {
		cout << "1 1\n1 1\n";
		return;
	}
	if (!pos.empty()) {
		int x = pos[0], y = pos[1];
		for (int i = 0; i < n; ++i)for (int j = 0; j < n; ++j) {
			if (p[x] - a[x][i] + a[y][j] == s) {
				cout << x + 1 << ' ' << i + 1 << '\n' << y + 1 << ' ' << j + 1 << '\n';
				return;
			}
		}
	}
	else {
		int x = posv[0], y = posv[1];
		for (int i = 0; i < n; ++i)for (int j = 0; j < n; ++j) {
			if (v[x] - a[i][x] + a[j][y] == s) {
				cout << i + 1 << ' ' << x + 1 << '\n' << j + 1 << ' ' << y + 1 << '\n';
				return;
			}
		}
	}
	vector<pair<ll, ll>> r;
	for (ll x : pos)for (ll y : posv)r.push_back({ x, y });
	for (int i = 0; i < r.size(); ++i) {
		for (int j = i + 1; j < r.size(); ++j) {
			swap(a[r[i].first][r[i].second], a[r[j].first][r[j].second]);
			if (check(n)) {
				cout << r[i].first + 1 << ' ' << r[i].second + 1 << '\n' << r[j].first + 1 << ' ' << r[j].second + 1 << '\n';
				return;
			}
			swap(a[r[i].first][r[i].second], a[r[j].first][r[j].second]);
		}
	}
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(false);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}

}