#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll MOD = 1e9 + 7;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;
    if (n <= 2) {
        cout << 1;
        return 0;
    }
    vector<vector<ll> > c(n + 1, vector<ll>(n + 1));
    c[0][0] = 1;
    for (int i = 1; i <= n; i++) {
        c[i][0] = 1;
        for (int j = 1; j <= i; j++) {
            c[i][j] = (c[i - 1][j - 1] + c[i - 1][j]) % MOD;
        }
    }
    vector<vector<ll> > dp(n + 1, vector<ll>(n + 1));
    dp[1][1] = 1;
    dp[2][1] = 1;
    dp[2][2] = 1;
    ll prev = 1;
    for (int i = 3; i <= n; i++) {
        ll res = 0;
        for (int seg = (i + 1) / 2; seg <= i; seg++) {
            dp[i][seg] = (dp[i - 1][seg - 1] + dp[i - 2][seg - 1]) % MOD;
            if (seg < i) {
                res = (res + (c[i - 1][seg] * dp[i][seg]) % MOD) % MOD;
            }
        }
        res = (res * prev) % MOD;
        prev = res;
    }
    cout << prev;
    return 0;
}


//#include <bits/stdc++.h>
//
//using namespace std;
//using ll = long long;
//
//bool check(vector<vector<int>> &v) {
//    map<int, int> mp;
//    int n = v.size();
//    for (int i = 0; i < n; i++) {
//        int sum = 0;
//        for (int j = 0; j < n; j++) {
//            sum += v[i][j];
//        }
//        mp[sum]++;
//    }
//    for (int i = 0; i < n; i++) {
//        int sum = 0;
//        for (int j = 0; j < n; j++) {
//            sum += v[j][i];
//        }
//        mp[sum]++;
//    }
//    if (mp.size() == 1) {
//        return true;
//    }
//    return false;
//}
//
//int main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(0);
//
//    int n;
//    cin >> n;
//
//    vector<vector<int>> a(n, vector<int>(n));
//    for (int i = 0; i < n; i++) {
//        for (int j = 0; j < n; j++) {
//            cin >> a[i][j];
//        }
//    }
//
//    if (n <= 8) {
//        for (int x1 = 0; x1 < n; x1++) {
//            for (int y1 = 0; y1 < n; y1++) {
//                for (int x2 = 0; x2 < n; x2++) {
//                    for (int y2 = 0; y2 < n; y2++) {
//                        vector<vector<int>> v = a;
//                        int tmp = v[x1][y1];
//                        v[x1][y1] = v[x2][y2];
//                        v[x2][y2] = tmp;
//                        if (check(v)) {
//                            cout << x1 + 1 << " " << y1 + 1 << "\n";
//                            cout << x2 + 1 << " " << y2 + 1;
//                            return 0;
//                        }
//                    }
//                }
//            }
//        }
//    }
//
//    map<int, int> hui;
//    vector<int> rows(n);
//    vector<int> cols(n);
//    for (int i = 0; i < n; i++) {
//        int sum = 0;
//        for (int j = 0; j < n; j++) {
//            sum += a[i][j];
//        }
//        rows[i] = sum;
//        hui[sum]++;
//    }
//
//    for (int i = 0; i < n; i++) {
//        int sum = 0;
//        for (int j = 0; j < n; j++) {
//            sum += a[j][i];
//        }
//        cols[i] = sum;
//        hui[sum]++;
//    }
//
//    int maxx_summ = 0;
//    int maxx_cnt = 0;
//    for (auto [sum, cnt]: hui) {
//        if (cnt > maxx_cnt) {
//            maxx_summ = sum;
//            maxx_cnt = cnt;
//        }
//    }
//
//    int first_i = -1;
//    int second_i = -1;
//    int first_j = -1;
//    int second_j = -1;
//    for (int i = 0; i < n; i++) {
//        int sum = 0;
//        for (int j = 0; j < n; j++) {
//            sum += a[i][j];
//        }
//
//        if (first_i == -1 and sum != maxx_summ) {
//            first_i = i;
//        } else if (sum != maxx_summ) {
//            second_i = i;
//        }
//    }
//
//    for (int i = 0; i < n; i++) {
//        int sum = 0;
//        for (int j = 0; j < n; j++) {
//            sum += a[j][i];
//        }
//
//        if (first_j == -1 and sum != maxx_summ) {
//            first_j = i;
//        } else if (sum != maxx_summ) {
//            second_j = i;
//        }
//    }
//
//    if (second_i == -1) {
//        cout << first_i + 1 << " " << first_j + 1 << "\n" << first_i + 1 << " " << second_j + 1;
//        return 0;
//    }
//    if (second_j == -1) {
//        cout << first_i + 1 << " " << first_j + 1 << "\n" << second_i + 1 << " " << first_j + 1;
//        return 0;
//    }
//
//    if (rows[first_i] - a[first_i][first_j] + a[second_i][second_j] == maxx_summ &&
//        cols[first_j] - a[first_i][first_j] + a[second_i][second_j] == maxx_summ) {
//        cout << first_i + 1 << " " << first_j + 1 << "\n" << second_i + 1 << " " << second_j + 1;
//        return 0;
//    } else {
//        cout << second_i + 1 << " " << first_j + 1 << "\n" << first_i + 1 << " " << second_j + 1;
//    }
//
//    return 0;
//}