#include <bits/stdc++.h>

using i64 = long long;

constexpr int MOD = 1e9 + 7;

void solve() {
    int n;
    std::cin >> n;
    std::vector<std::vector<int>> f(n + 1, std::vector<int>(n + 1, 0));
    for (int i = 0; i <= n; i++) {
        f[0][i] = 1;
    }
    for (int i = 1; i <= n; i++) {
        f[1][i] = i;
    }
    for (int i = 2; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            f[i][j] = ((f[i - 1][j - 1] + f[i - 2][j - 1]) % MOD + f[i][j - 1]) % MOD;
        }
    }
    std::vector<int> dp(n + 1);
    dp[1] = 1;
    for (int i = 2; i <= n; i++) {
        dp[i] = (1LL * dp[i - 1] * f[i][i - 1]) % MOD;
    }
    std::cout << dp[n] << "\n";
}

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    solve();
}
