//#include <iostream>
//#include <vector>
//# define int unsigned long long
//using namespace std;
//
//int factorial(int x, int m) {
//    int res = 1;
//    for (int i = 2; i <= x; i++) {
//        res = (res *  i) % m;
//    }
//    return res;
//}
//
//signed main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
//
//    int n; cin >> n;
//    int m = 1e9 + 7;
//    vector<int> dp(n + 1);
//    dp[1] = 1;
//
//    for (int i = 2; i <= n; i++) {
//        dp[i] = (factorial(i-1, m) * dp[i-1]) % m;
//    }
//
//    cout << dp.back();
//    return 0;
//}




#include <iostream>
#include <vector>

using namespace std;

#define int unsigned long long


bool check(vector<vector<int>> matrix, int x1, int y1, int x2, int y2) {
    int x = matrix[x1][y1];
    vector<int> res;
    matrix[x1][y1] = matrix[x2][y2];
    matrix[x2][y2] = x;
    for (int i = 0; i < matrix.size(); i++) {
        int s = 0;
        for (int j = 0; j < matrix.size(); j++) {
            s += matrix[i][j];
        }
        res.push_back(s);
    }
    for (int i = 0; i < matrix.size(); i++) {
        int s = 0;
        for (int j = 0; j < matrix.size(); j++) {
            s += matrix[j][i];
        }
        res.push_back(s);
    }
    for (int i = 1; i < res.size(); i++) {
        if (res[0] != res[i]) {
            return false;
        }
    }
    return true;
}


signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int n;
    cin >> n;
    vector<vector<int>> matrix(n, vector<int>(n, 0));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            int x;
            cin >> x;
            matrix[i][j] = x;
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            for (int u = i; u < n; u++) {
                if (u == i) {
                    for (int z = j + 1; z < n; z++) {
                        if (check(matrix, i, j, u, z)) {
                            cout << i + 1 << ' ' << j + 1 << '\n';
                            cout << u + 1 << ' ' << z + 1;
                            return 0;
                        }
                    }
                }
                for (int z = 0; z < n; z++) {
                    if (check(matrix, i, j, u, z)) {
                        cout << i + 1 << ' ' << j + 1 << '\n';
                        cout << u + 1 << ' ' << z + 1;
                        return 0;
                    }
                }
            }
        }
    }

}