#include <bits/stdc++.h>

#define PB push_back
#define pb push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())
#define int ll
#define itn int

using namespace std;
typedef long long ll;
typedef pair<ll,ll> pll;
const ll INF=1e18+2;
const ll N=1e6+2;

enum
{
    EMP,
    A,
    B
};

struct segtree
{
    struct node
    {
        array<pair<bool,ll>,3> res;
        bool ex=0;

        node() {}

        node(char c)
        {
            ex=1;

            if(c=='a')
            {
                res[EMP]={1,A};
                res[A]={1,A};
                res[B]={1,EMP};
            }

            else
            {
                res[EMP]={1,B};
                res[A]={1,EMP};
                res[B]={0,EMP};
            }
        }
    };

    node add(node a, node b)
    {
        if(!a.ex) return b;
        if(!b.ex) return a;
        node c;
        c.ex=1;

        for(ll cur:{EMP,A,B})
        {
            if(!a.res[cur].F||!b.res[a.res[cur].S].F)
                c.res[cur]={0,EMP};

            else c.res[cur]=b.res[a.res[cur].S];
        }

        return c;
    }

    ve<node> tree;
    ll sz;

    void init(ll n)
    {
        sz=1;
        while(sz<n) sz*=2;
        tree.assign(sz*2,node());
    }

    void upd(ll k, char x, ll v, ll tl, ll tr)
    {
        if(tr-tl==1)
        {
            tree[v]=node(x);
            return;
        }

        ll tm=(tl+tr)/2;
        if(k<tm) upd(k,x,v*2+1,tl,tm);
        else upd(k,x,v*2+2,tm,tr);
        tree[v]=add(tree[v*2+1],tree[v*2+2]);
    }

    void upd(ll k, char x)
    {
        upd(k,x,0,0,sz);
    }

    node get(ll l, ll r, ll v, ll tl, ll tr)
    {
        if(l>=tr||tl>=r) return node();
        if(l<=tl&&tr<=r) return tree[v];

        ll tm=(tl+tr)/2;
        node a=get(l,r,v*2+1,tl,tm);
        node b=get(l,r,v*2+2,tm,tr);
        return add(a,b);
    }

    bool get(ll l, ll r)
    {
        node x=get(l,r+1,0,0,sz);
        return x.res[EMP].F&&x.res[EMP].S!=B;
    }
};

void solve()
{
    ll n,q;
    string s;
    cin>>n>>s>>q;
    segtree st;
    st.init(n);

    for(ll i=0;i<n;i++)
        st.upd(i,s[i]);

    while(q--)
    {
        char t;
        cin>>t;

        if(t=='2')
        {
            ll l,r;
            cin>>l>>r;
            l--, r--;
            cout<<(st.get(l,r)? "YES":"NO")<<endl;
        }

        else
        {
            ll k;
            cin>>k;
            k--;
            s[k]=(s[k]=='a'? 'b':'a');
            st.upd(k,s[k]);
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
        //freopen( "input.txt" , "r" , stdin );
        freopen( "output.txt" , "w" , stdout );
    #endif // LOCAL

    solve();
    return 0;
}

///abbababba
